/***********************************************************************

  VS2.H

***********************************************************************/

/***********************************************************************

  TYPEDEFS

***********************************************************************/

/* useful data types */
typedef unsigned char	UCHAR;
typedef unsigned short	USHORT;
typedef unsigned long	ULONG;
typedef UCHAR __far *	LPCHAR;
typedef USHORT __far *	LPSHORT;
typedef ULONG __far *	LPLONG;
typedef void __far *	LPVOID;
#define VS2API		__pascal __far

/* BIOS Video Display Data Area and data save areas */
typedef struct tagATCSAVEAREA
{
  UCHAR 	ucPalette[16];
  UCHAR 	ucOverscan[1];
  UCHAR 	Reserved[239];
}
    ATCSAVEAREA;
typedef ATCSAVEAREA __far * LPATCSAVEAREA;

typedef struct tagALPHACSO
{
  UCHAR 	ucPoints;
  UCHAR 	ucRAMBank;
  USHORT	usChars;
  USHORT	usFirstChar;
  LPCHAR	lpCharDefTable;
  UCHAR 	ucRows;
  UCHAR 	ucVideoModes[1];
}
    ALPHACSO;
typedef ALPHACSO __far *    LPALPHACSO;

typedef struct tagGRAPHICSCSO
{
  UCHAR 	ucRows;
  USHORT	usPoints;
  LPCHAR	lpCharDefTable;
  UCHAR 	ucVideoModes[1];
}
    GRAPHICSCSO;
typedef GRAPHICSCSO __far * LPGRAPHICSCSO;

typedef struct tagSAVEAREA2
{
  USHORT	usLength;
  LPVOID	lpDCCTable;
  LPALPHACSO	lpAlphaCharSetOverride2;
  LPVOID	lpUserPaletteProfile;
  ULONG 	Reserved[3];
}
    SAVEAREA2;
typedef SAVEAREA2 __far *   LPSAVEAREA2;

typedef struct tagSAVEAREA
{
  LPVOID	lpVideoParamTable;
  LPATCSAVEAREA lpAttributeSaveArea;
  LPALPHACSO	lpAlphaCharSetOverride;
  LPGRAPHICSCSO lpGraphicsCharSetOverride;
  LPSAVEAREA2	lpSaveArea2;
  ULONG 	Reserved[2];
}
    SAVEAREA;
typedef SAVEAREA __far *    LPSAVEAREA;

typedef struct tagVDDA
{
  UCHAR 	CRTMode;
  USHORT	CRTCols;
  USHORT	CRTLen;
  USHORT	CRTStart;
  USHORT	CursorPosn[8];
  USHORT	CursorMode;
  UCHAR 	ActivePage;
  USHORT	Addr6845;
  UCHAR 	CRTModeSet;
  UCHAR 	CRTPalette;
  UCHAR 	Reserved1[29];
  UCHAR 	Rows;
  USHORT	Points;
  UCHAR 	Info;
  UCHAR 	Info3;
  UCHAR 	Flags;
  UCHAR 	DCC;
  UCHAR 	Reserved2[29];
  LPSAVEAREA	lpSaveArea;
}
    VDDA;
typedef VDDA __far *	    LPVDDA;

/* VESA BIOS extension (version 2.0) data structures */
typedef struct tagVBEINFOBLOCK
{
  char	    VbeSignature[4];
  USHORT    VbeVersion;
  LPCHAR    OemStringPtr;
  ULONG     Capabilities;
  LPSHORT   VideoModePtr;
  USHORT    TotalMemory;	    /* version 1.2 */
  USHORT    OemSoftwareRev;	    /* version 2.0 */
  LPCHAR    OemVendorNamePtr;	    /* version 2.0 */
  LPCHAR    OemProductNamePtr;	    /* version 2.0 */
  LPCHAR    OemProductRevPtr;	    /* version 2.0 */
  char	    Reserved[222];
  char	    OemData[256];	    /* version 2.0 */
}
    VBEINFOBLOCK;

typedef struct tagMODEINFOBLOCK
{
  /* supported in all VBE versions ... */
  USHORT    ModeAttributes;
  UCHAR     WinAAttributes;
  UCHAR     WinBAttributes;
  USHORT    WinGranularity;
  USHORT    WinSize;
  USHORT    WinASegment;
  USHORT    WinBSegment;
  LPVOID    WinFuncPtr;
  USHORT    BytesPerScanLine;

  /* supported in VBE version 1.2 and above ... */
  USHORT    XResolution;
  USHORT    YResolution;
  UCHAR     XCharSize;
  UCHAR     YCharSize;
  UCHAR     NumberOfPlanes;
  UCHAR     BitsPerPixel;
  UCHAR     NumberOfBanks;
  UCHAR     MemoryModel;
  UCHAR     BankSize;
  UCHAR     NumberOfImagePages;
  UCHAR     Reserved1;

  UCHAR     RedMaskSize;
  UCHAR     RedFieldPosition;
  UCHAR     GreenMaskSize;
  UCHAR     GreenFieldPosition;
  UCHAR     BlueMaskSize;
  UCHAR     BlueFieldPosition;
  UCHAR     RsvdMaskSize;
  UCHAR     RsvdFieldPosition;
  UCHAR     DirectColorModeInfo;

  /* supported in VBE version 2.0 and above ... */
  LPCHAR    PhysBasePtr;
  LPCHAR    OffScreenMemOffset;
  USHORT    OffScreenMemSize;
  UCHAR     Reserved2[206];
}
    MODEINFOBLOCK;

/* video state parameters */
typedef struct tagVIDEOSTATEPARAMS
{
  USHORT    usMode;	    /* 16-bit video mode number */
  USHORT    segVBuf;	    /* display start segment */
  USHORT    ofsVBuf;	    /* display start offset */
  USHORT    usPPB;	    /* pixels per byte */
  USHORT    cbRow;	    /* bytes per logical row */
  USHORT    usCX;	    /* logical buffer dimensions */
  USHORT    usCY;
  USHORT    usSX;	    /* screen dimensions */
  USHORT    usSY;
  USHORT    usX;	    /* logical pixel origin */
  USHORT    usY;
  USHORT    ofsXY;	    /* byte offset of origin pixel */
  USHORT    usVNSkip;	    /* skip count for vert nondisplay timer */
  UCHAR     cBPP;	    /* bits per pixel */
  UCHAR     cRMW;	    /* Graphics Controller raster op bits */
}
    VIDEOSTATEPARAMS;


/***********************************************************************

  CONSTANTS

***********************************************************************/

/* pointer to the start of the BIOS Video Display Data Area */
#define ADDRVDDA	    (LPVDDA)(0x00400049L)
#define LPVBUF		    (LPCHAR)(0xA0000000L)

/* values for VGA Graphics Controller Read-Modify-Write bits */
#define RMW_REPLACE 0x00
#define RMW_AND     0x08
#define RMW_OR	    0x10
#define RMW_XOR     0x18

#define FALSE	0
#define TRUE	(!FALSE)


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

/* Chapter  1: GETVMODE.ASM */
USHORT VS2API GetVMode( void );

/* Chapter  1: SETVMODE.ASM */
void VS2API   SetVMode( USHORT );

/* Chapter  2: SVM256.ASM   */
void VS2API   SetVMode256( USHORT, USHORT );

/* Chapter  2: VRWAIT.ASM   */
void VS2API   VRWait( void );
void VS2API   InitVNWait( void );
void VS2API   VNWait( void );

/* Chapter  3: ALPHATXT.ASM */
void VS2API   TextAt( USHORT, USHORT, char __far *, UCHAR );
void VS2API   SetBlink( USHORT );
void VS2API   SetBorder( UCHAR );

/* Chapter  3: CURSOR.ASM   */
void VS2API   SetCursorXY( USHORT, USHORT );
void VS2API   GetCursorXY( LPSHORT, LPSHORT );
void VS2API   SetCursorSize( USHORT, USHORT );

/* Chapter  3: FADE16.ASM   */
void VS2API   InitFade16( void );
void VS2API   FadeDn16( void );
void VS2API   FadeUp16( void );

/* Chapter  4: PIXLADDR.ASM */
LPCHAR VS2API PixelAddr10( USHORT, USHORT );
LPCHAR VS2API PixelAddr13( USHORT, USHORT );
LPCHAR VS2API PixelAddr256( USHORT, USHORT );

/* Chapter  4: VSP.ASM */
void VS2API   InitVSP( USHORT );

/* Chapter  5: FILLVBUF.ASM */
void VS2API   FillVBuf10( UCHAR );
void VS2API   FillVBuf13( UCHAR );
void VS2API   FillVBuf256( UCHAR );

/* Chapter  5: GETPIXEL.ASM */
UCHAR VS2API  GetPixel10( USHORT, USHORT );
UCHAR VS2API  GetPixel13( USHORT, USHORT );
UCHAR VS2API  GetPixel256( USHORT, USHORT );

/* Chapter  5: SETPIXEL.ASM */
void VS2API   SetPixel10( USHORT, USHORT, UCHAR );
void VS2API   SetPixel13( USHORT, USHORT, UCHAR );
void VS2API   SetPixel256( USHORT, USHORT, UCHAR );

/* Chapter  6: LINE.ASM     */
void VS2API   Line10( USHORT, USHORT, USHORT, USHORT, UCHAR );
void VS2API   Line13( USHORT, USHORT, USHORT, USHORT, UCHAR );
void VS2API   Line256( USHORT, USHORT, USHORT, USHORT, UCHAR );

/* Chapter  7: CIRCLE.ASM  */
void VS2API   Circle10( USHORT, USHORT, USHORT, UCHAR );
void VS2API   Circle13( USHORT, USHORT, USHORT, UCHAR );
void VS2API   Circle256( USHORT, USHORT, USHORT, UCHAR );

/* Chapter  7: ELLIPSE.ASM  */
void VS2API   Ellipse10( USHORT, USHORT, USHORT, USHORT, UCHAR );
void VS2API   Ellipse13( USHORT, USHORT, USHORT, USHORT, UCHAR );
void VS2API   Ellipse256( USHORT, USHORT, USHORT, USHORT, UCHAR );

/* Chapter  8: SCANPIXL.ASM */
USHORT VS2API ScanLeft10( USHORT, USHORT, UCHAR, short );
USHORT VS2API ScanLeft13( USHORT, USHORT, UCHAR, short );
USHORT VS2API ScanLeft256( USHORT, USHORT, UCHAR, short );
USHORT VS2API ScanRight10( USHORT, USHORT, UCHAR, short );
USHORT VS2API ScanRight13( USHORT, USHORT, UCHAR, short );
USHORT VS2API ScanRight256( USHORT, USHORT, UCHAR, short );

/* Chapter  9: BLT.ASM	    */
ULONG VS2API  BltToRAM10( LPVOID, USHORT, USHORT, USHORT, USHORT );
ULONG VS2API  BltToRAM13( LPVOID, USHORT, USHORT, USHORT, USHORT );
ULONG VS2API  BltToRAM256( LPVOID, USHORT, USHORT, USHORT, USHORT );
void VS2API   BltToVBuf10( USHORT, USHORT, LPVOID, USHORT );
void VS2API   BltToVBuf13( USHORT, USHORT, LPVOID, USHORT );
void VS2API   BltToVBuf256( USHORT, USHORT, LPVOID, USHORT );
void VS2API   BltInVBuf10( USHORT, USHORT, USHORT, USHORT, USHORT, USHORT );
void VS2API   BltInVBuf13( USHORT, USHORT, USHORT, USHORT, USHORT, USHORT );
void VS2API   BltInVBuf256( USHORT, USHORT, USHORT, USHORT, USHORT, USHORT );

/* Chapter 10: GLYPHBLT.ASM */
void VS2API   GlyphBlt10( USHORT, USHORT, UCHAR, UCHAR,
				    LPVOID, USHORT, USHORT, USHORT );
void VS2API   GlyphBlt13( USHORT, USHORT, UCHAR, UCHAR,
				    LPVOID, USHORT, USHORT, USHORT );
void VS2API   GlyphBlt256( USHORT, USHORT, UCHAR, UCHAR,
				    LPVOID, USHORT, USHORT, USHORT );

/* Chapter 11: CGENRAM.ASM  */
void VS2API   ExposeCGenRAM( LPVOID );
void VS2API   HideCGenRAM( LPVOID );
USHORT VS2API BltToCGenRAM( USHORT, USHORT, LPVOID, UCHAR, USHORT );

/* Chapter 12: VNI.ASM	    */
USHORT VS2API EnableVNI( void (VS2API *)(void) );
void VS2API   DisableVNI( void );

/* Chapter 12: VNTIMER.ASM  */
void VS2API   EnableVNTimer( void (VS2API *)(void) );
void VS2API   DisableVNTimer( void );

/* Chapter 12: VBUF.ASM     */
USHORT VS2API SetVBufStart( USHORT );
void VS2API   SetScreenStart( USHORT );
USHORT VS2API SetVBufDims( USHORT, USHORT, USHORT );
void VS2API   SetScreenOrg( USHORT, USHORT, USHORT );
void VS2API   SetScreenSplit( USHORT, USHORT, USHORT );

/* Chapter 12: VGADAC.ASM   */
void VS2API   RotateDACTable( LPVOID, short, short );
void VS2API   GetDACRegs( LPVOID, short, short );
void VS2API   SetDACRegs( LPVOID, short, short );
