		TITLE	VS2.INC
		PAGE	55,132

; video buffer base segment
segVBufBase	EQU	0A000h

; 8-bit video mode numbers
M256ModeFirst	EQU	40h
M256Mode0	EQU	(M256ModeFirst)     ; 256-color graphics
M256Mode1	EQU	(M256ModeFirst+1)
M256Mode2	EQU	(M256ModeFirst+2)
M256Mode3	EQU	(M256ModeFirst+3)
M256Mode4	EQU	(M256ModeFirst+4)
M256Mode5	EQU	(M256ModeFirst+5)
M256ModeLast	EQU	M256Mode5

; 16-bit VESA BIOS extension video mode numbers
VBEModeBase	EQU	800h
VBEModeFirst	EQU	(M256ModeFirst+VBEModeBase)
VBEMode0	EQU	(M256Mode0+VBEModeBase)
VBEMode1	EQU	(M256Mode1+VBEModeBase)
VBEMode2	EQU	(M256Mode2+VBEModeBase)
VBEMode3	EQU	(M256Mode3+VBEModeBase)
VBEMode4	EQU	(M256Mode4+VBEModeBase)
VBEMode5	EQU	(M256Mode5+VBEModeBase)
VBEModeLast	EQU	VBEMode5

; BIOS Video Display Data Area
segVDDA 	EQU	40h
EQUIP_FLAG	EQU	10h
CRT_MODE	EQU	49h
CRT_COLS	EQU	4Ah
CRT_LEN 	EQU	4Ch
CRT_START	EQU	4Eh
CURSOR_POSN	EQU	50h
CURSOR_MODE	EQU	60h
ACTIVE_PAGE	EQU	62h
ADDR6845	EQU	63h	    ; (CRTC I/O address)
CRT_MODE_SET	EQU	65h
CRT_PALETTE	EQU	66h
ROWS		EQU	84h
POINTS		EQU	85h
INFO		EQU	87h
INFO_3		EQU	88h

; VESA BIOS Extension information block
VBEINFOBLOCK	    STRUCT
VbeSignature	    BYTE    'VESA'
VbeVersion	    WORD    ?
OemStringPtr	    WORD    ?
		    WORD    ?
Capabilities	    DWORD   ?
VideoModePtr	    WORD    ?
		    WORD    ?
TotalMemory	    WORD    ?		; version 1.2
OemSoftwareRev	    WORD    ?		; version 2.0
OemVendorNamePtr    WORD    ?		; version 2.0
		    WORD    ?
OemProductNamePtr   WORD    ?		; version 2.0
		    WORD    ?
OemProductRevPtr    WORD    ?		; version 2.0
		    WORD    ?
Reserved	    BYTE    222 DUP(0)
VBEINFOBLOCK	    ENDS

; VESA video mode information block
MODEINFOBLOCK	    STRUCT

; supported in all VBE versions ...
ModeAttributes	    WORD    11111b
WinAAttributes	    BYTE    0
WinBAttributes	    BYTE    0
WinGranularity	    WORD    0
WinSize 	    WORD    0
WinASegment	    WORD    0
WinBSegment	    WORD    0
WinFuncPtr	    DWORD   0
BytesPerScanLine    WORD    ?

; supported in VBE version 1.2 and above ...
XResolution	    WORD    ?
YResolution	    WORD    ?
XCharSize	    BYTE    ?
YCharSize	    BYTE    ?
NumberOfPlanes	    BYTE    4
BitsPerPixel	    BYTE    8
NumberOfBanks	    BYTE    1
MemoryModel	    BYTE    5	    ; non-chain 4, 256-color
BankSize	    BYTE    0
NumberOfImagePages  BYTE    0
Reserved1	    BYTE    1

RedMaskSize	    BYTE    0
RedFieldPosition    BYTE    0
GreenMaskSize	    BYTE    0
GreenFieldPosition  BYTE    0
BlueMaskSize	    BYTE    0
BlueFieldPosition   BYTE    0
RsvdMaskSize	    BYTE    0
RsvdFieldPosition   BYTE    0
DirectColorModeInfo BYTE    01b

; supported in VBE version 2.0 and above ...
PhysBasePtr	    DWORD   0
OffScreenMemOffset  DWORD   0
OffScreenMemSize    WORD    0
Reserved2	    BYTE    206 DUP(0)

MODEINFOBLOCK	    ENDS

; video state parameters
VIDEOSTATEPARAMS    STRUCT
usMode		    WORD    0	    ; 16-bit video mode number
segVBuf 	    WORD    0A000h  ; display start segment
ofsVBuf 	    WORD    0	    ; display start offset
usPPB		    WORD    0	    ; pixels per byte
cbRow		    WORD    0	    ; bytes per logical row
usCX		    WORD    0	    ; buffer dimensions
usCY		    WORD    0
usSX		    WORD    0	    ; screen dimensions
usSY		    WORD    0
usX		    WORD    0	    ; logical pixel origin
usY		    WORD    0
ofsXY		    WORD    0	    ; byte offset of origin pixel
usVNSkip	    WORD    0	    ; vert nondisplay timer skip count
cBPP		    BYTE    0	    ; bits per pixel
cRMW		    BYTE    00h     ; Read-Modify-Write bits
VIDEOSTATEPARAMS    ENDS

; values for VGA Graphics Controller Read-Modify-Write bits
RMW_REPLACE	EQU	00h
RMW_AND 	EQU	08h
RMW_OR		EQU	10h
RMW_XOR 	EQU	18h

; ASCII characters
BELL		EQU	07h
BACKSPACE	EQU	08h
LF		EQU	0Ah
CR		EQU	0Dh
