		TITLE	FN06.ASM
		NAME	FN06
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	SwitchStack:NEAR
		EXTRN	UnswitchStack:NEAR

		PUBLIC	Fn06
Fn06		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L000
	cmp	VSP.usMode, VBEModeLast
	jbe	L001

; not an M256X mode, so just chain to the previous int 10h handler
L000:	pushf
	call	PrevISR10
	ret

; come here for M256X modes
L001:	call	SwitchStack

	xor	ah, ah
	push	ax		; Dc
	mov	al, bh
	push	ax		; cBkgd
	mov	al, cl
	push	ax		; Xc0
	mov	al, ch
	push	ax		; Yc0
	mov	al, dl
	push	ax		; Xc1
	mov	al, dh
	push	ax		; Yc1
	call	M256ScrollUp

	call	UnswitchStack

L009:	ret

Fn06		ENDP

; M256ScrollUp -- scrolls the specified rectangle in the video buffer
;
;   void _pascal far
;   M256ScrollUp( unsigned int	  Dc,	    ; distance (# of rows) to scroll
;		    unsigned char cBkgd,    ; background pixel
;		    unsigned char Xc0,	    ; upper-left character X
;		    unsigned char Yc0,	    ; upper-left character Y
;		    unsigned char Xc1,	    ; lower-right character X
;		    unsigned char Yc1 );    ; lower-right character Y

; parameters
Yc1		EQU	[bp+6]
Xc1		EQU	[bp+8]
Yc0		EQU	[bp+10]
Xc0		EQU	[bp+12]
cBkgd		EQU	[bp+14]
Dc		EQU	[bp+16]

; temporary variables
nBytesPerCharRow    EQU     [bp-2]
nBytesPerVBufRow    EQU     [bp-4]
Nc		    EQU     [bp-6]

		PUBLIC	M256ScrollUp
M256ScrollUp	PROC	FAR

	enter	6, 0

; preserve regs
	push	ds
	push	es
	pusha
	pushf

	cld		    ; clear df for movs and stos

; compute the number of bytes per character row in the video buffer
	mov	ax, segVDDA
	mov	ds, ax

	mov	ax, ds:[CRT_COLS]
	add	ax, ax		; CRT_COLS*2
	mov	nBytesPerVBufRow, ax

; determine the distance (number of rows of characters) to scroll
	mov	cx, Yc1
	sub	cx, Yc0
	inc	cx		; CX = Yc1-Yc0+1

; if the distance is 0 or more than the number of rows, scroll everything away
	cmp	WORD PTR Dc, 0
	je	L110

	cmp	Dc, cx
	jb	L120		; jump if fewer than all rows

L110:	mov	Dc, cx		; (scroll everything)
	mov	WORD PTR Nc, 0	; (# rows to move is zero)
	jmp	L130

; come here if not scrolling everything
L120:	sub	cx, Dc
	mov	Nc, cx		; save # of rows to copy

; determine the source and destination addresses
L130:	mov	ax, Yc0
	mul	WORD PTR ds:[POINTS]	; AX = Yc0*POINTS
	mul	WORD PTR nBytesPerVBufRow
	mov	di, ax

	mov	ax, Dc
	mul	WORD PTR ds:[POINTS]
	mul	WORD PTR nBytesPerVBufRow
	add	ax, di
	mov	si, ax

	mov	ax, Xc0
	add	ax, ax		    ; 2 bytes per character
	add	si, ax
	add	di, ax

; determine the number of bytes to move in each character row
	mov	ax, Xc1
	sub	ax, Xc0 	    ; Xc1-Xc0
	inc	ax		    ; AX = # of chars per row
	add	ax, ax
	mov	nBytesPerCharRow, ax

; compute the row increment
	mov	bx, nBytesPerVBufRow
	sub	bx, ax		    ; BX = row increment

	push	seg DGROUP
	pop	es
	mov	es, es:VSP.segVBuf  ; ES:DI -> destination

; scroll up
	cmp	WORD PTR Nc, 0
	je	L160		    ; jump if nothing to scroll

; set Graphics Controller write mode 1
	mov	dx, 3CEh
	mov	ax, 4105h
	out	dx, ax

	mov	ax, Nc
	mul	WORD PTR ds:[POINTS]	; AX = Nc*POINTS
	mov	dx, ax		    ; DX = Np (# pixel rows)

	push	es
	pop	ds		    ; DS:SI -> source

; move each row of pixels
L140:	mov	cx, nBytesPerCharRow
	rep movsb

	add	si, bx		    ; DS:SI -> next source row
	add	di, bx		    ; ES:DI -> next dest row

	dec	dx
	jnz	L140

; restore Graphics Controller write mode 0
	mov	dx, 3CEh
	mov	ax, 4005h
	out	dx, ax

; clear the rows at the bottom of the scrolled area
L160:	mov	ax, segVDDA
	mov	ds, ax
	mov	ax, Dc
	mul	WORD PTR ds:[POINTS]	; AX = Dc*POINTS
	mov	dx, ax		    ; DX = # of pixel rows to fill

	mov	al, cBkgd
	mov	ah, al

	mov	si, nBytesPerCharRow
	shr	si, 1		    ; SI = # words per row

; erase the remaining rows
L170:	mov	cx, si
	rep stosw

	add	di, bx		    ; ES:DI -> next dest row

	dec	dx
	jnz	L170

; restore regs and return
	popf
	popa
	pop	es
	pop	ds
	leave
	ret	12

M256ScrollUp	ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS
		EXTRN	PrevISR10:DWORD

_DATA		ENDS

		END
