		TITLE	FN0E.ASM
		NAME	FN0E
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	GLYPHBLT256:FAR
		EXTRN	M256ScrollUp:FAR
		EXTRN	SwitchStack:NEAR
		EXTRN	UnswitchStack:NEAR

		PUBLIC	Fn0E
Fn0E		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L000
	cmp	VSP.usMode, VBEModeLast
	jbe	L001

; not an M256X mode, so just chain to the previous int 10h handler
L000:	pushf
	call	PrevISR10
	ret

; pass control characters through to ROM BIOS
L001:	cmp	al, BELL
	je	L000
	cmp	al, BACKSPACE
	je	L000
	cmp	al, CR
	je	L000
	cmp	al, LF
	je	L005

; all other characters
	call	SwitchStack
	call	ShowChar
	call	UnswitchStack
	ret

; special handling for LF
L005:	push	ds
	push	ax
	push	bx

	mov	ax, segVDDA
	mov	ds, ax
	mov	ax, ds:[CURSOR_POSN]	; AH = character row
					; AL = character column
	cmp	ah, ds:[ROWS]		; compare with ROWS
	jb	L010			; jump if not beyond last row

; beyond last row, so scroll up
	push	1			; Dc
	push	0			; cBkgd
	push	0			; Xc0
	push	0			; Yc0
	mov	ax, ds:[CRT_COLS]
	dec	ax
	push	ax			; Xc1
	mov	al, ds:[ROWS]
	xor	ah, ah
	push	ax			; Yc1
	call	M256ScrollUp

; clear the last row
	push	0			; Dc
	push	0			; cBkgd
	push	0			; Xc0
	mov	bl, ds:[ROWS]
	xor	bh, bh
	push	bx			; Yc0
	mov	ax, ds:[CRT_COLS]
	dec	ax
	push	ax			; Xc1
	push	bx			; Yc1 (ROWS)
	call	M256ScrollUp

	jmp	L020

; no scrolling, so just update CURSOR_POSN
L010:	inc	ah
	mov	ds:[CURSOR_POSN], ax

; restore DS and return
L020:	pop	bx
	pop	ax
	pop	ds
	ret

Fn0E		ENDP

; ShowChar
;
; Caller:   AL = ASCII character
;	    BL = foreground pixel value

ShowChar	PROC	NEAR

	mov	bh, al			; BH = ASCII character

; address the BIOS Video Display Data Area through ES
	push	segVDDA
	pop	es

; push the x- and y-coordinates
	mov	dx, es:[CURSOR_POSN]	; DH = character row
					; DL = character column
	mov	al, dl
	xor	ah, ah			; AX = character column
	shl	ax, 3			; AX = x-coordinate
	push	ax

	mov	cx, es:[POINTS] 	; CX = character height
	mov	al, cl
	mul	dh			; AX = graphics row
	push	ax

; push the pixel values
	mov	al, bl
	xor	ah, ah			; AX = foreground pixel value
	push	ax
	push	0			; (background pixel value)

; push a pointer to the glyph table
	mov	al, bh			; AL = ASCII character
	mul	cl			; AX = offset into bit table

	xor	si, si
	mov	es, si			; ES = 0
	mov	si, 4*43h		; ES:SI -> int 43h vector
	les	si, es:[si]		; ES:SI -> BIOS character defs
	add	si, ax			; DS:SI -> character bits
	push	es
	push	si

; push the width and height of the glyph
	push	8			; character width
	push	cx			; character height

; show the character
	push	1			 ; flag (opaque background)
	call	GLYPHBLT256

; advance the cursor
	push	segVDDA
	pop	es
	mov	ax, es:[CURSOR_POSN]	; AH = character row
					; AL = character column
	inc	al			; advance to next column
	cmp	al, es:[CRT_COLS]
	jb	L040			; jump if not at end of row

; come here if end of row
	xor	al, al			; move to leftmost char column
	mov	es:[CURSOR_POSN], ax	; save new cursor value

	cmp	ah, es:[ROWS]		; compare with ROWS
	jae	L050			; jump if last displayed row

	inc	ah			; increment character row

L040:	mov	es:[CURSOR_POSN], ax	; save new cursor value
	jmp	L060

; come here if end of last displayed row
L050:	mov	ax, 0E0Ah		; emit a linefeed
	int	10h			; save current cursor location

L060:	ret

ShowChar	ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS
		EXTRN	PrevISR10:DWORD

_DATA		ENDS

		END
