		TITLE	FN13.ASM
		NAME	FN13
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	Fn0E:NEAR

		PUBLIC	Fn13
Fn13		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L000
	cmp	VSP.usMode, VBEModeLast
	jbe	L001

; not an M256X mode, so just chain to the previous int 10h handler
L000:	pushf
	call	PrevISR10
	ret

; save the current cursor position
L001:	push	es

	push	segVDDA
	pop	es	    ; ES -> BIOS video display data area
	xchg	dx, es:[CURSOR_POSN]	; DX = current cursor x,y
					; CURSOR_POSN = string x,y
	pop	es

; the value in AL determines how to process the string
	cmp	al, 2
	jae	L020	    ; jump if the string contains attributes

; come here if BL contains the attribute byte for the string
L010:	push	ax
	push	bx
	push	cx
	push	dx
	push	es
	push	bp

	mov	ah, 0Eh     ; use function 0Eh to write one character
	mov	al, es:[bp]
	call	Fn0E

	pop	bp
	pop	es
	pop	dx
	pop	cx
	pop	bx
	pop	ax

	inc	bp	    ; ES:BP -> next character in string
	loop	L010

	jmp	L080

; come here if the string contains embedded attribute bytes
L020:	push	ax
	push	cx
	push	dx
	push	es
	push	bp

	mov	ah, 0Eh     ; use function 0Eh to write one character
	mov	al, es:[bp]
	mov	bl, es:[bp+1]
	call	Fn0E

	pop	bp
	pop	es
	pop	dx
	pop	cx
	pop	ax

	add	bp, 2	    ; ES:BP -> next character in string
	loop	L020

L080:	test	al, 1
	jnz	L090	    ; jump if bit 0 = 1 (cursor pos'n updated)

; come here to move the cursor back to where it was
	mov	ah, 2
	xor	bh, bh
	pushf
	call	PrevISR10

L090:	ret

Fn13		ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS
		EXTRN	PrevISR10:DWORD

_DATA		ENDS

		END
