		TITLE	FN4F.ASM
		NAME	FN4F
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	BUFCOPY:FAR
		EXTRN	INITVSP:FAR
		EXTRN	SETVMODE256:FAR
		EXTRN	SETVBUFDIMS:FAR
		EXTRN	SETSCREENORG:FAR
		EXTRN	SwitchStack:NEAR
		EXTRN	UnswitchStack:NEAR

;
; Fn4F00 -- return SVGA information

		PUBLIC	Fn4F00
Fn4F00		PROC	NEAR

	push	es		; pointer to destination buffer
	push	di
	push	ds		; pointer to VBEInfoBlock
	push	offset VIB

; if VESASignature <> "VBE2", return only version 1.x data
	cmp	WORD PTR es:[di], 4256h     ; compare to 'VB'
	jne	L001
	cmp	WORD PTR es:[di+2], 3245h   ; compare to 'E2'
	jne	L001

; come here to copy VBE version 2 data
	push	512		; number of bytes to copy
	call	BUFCOPY

; point addresses in VIB to caller's VBE_OEM_Data
	lea	ax, [di+(offset OEMString - offset VIB)]
	mov	(VBEINFOBLOCK PTR es:[di]).OemStringPtr, ax
	mov	(VBEINFOBLOCK PTR es:[di]).OemStringPtr+2, es

	lea	ax, [di+(offset VideoModeList - offset VIB)]
	mov	(VBEINFOBLOCK PTR es:[di]).VideoModePtr, ax
	mov	(VBEINFOBLOCK PTR es:[di]).VideoModePtr+2, es

	lea	ax, [di+(offset VendorName - offset VIB)]
	mov	(VBEINFOBLOCK PTR es:[di]).OemVendorNamePtr, ax
	mov	(VBEINFOBLOCK PTR es:[di]).OemVendorNamePtr+2, es

	lea	ax, [di+(offset ProductName - offset VIB)]
	mov	(VBEINFOBLOCK PTR es:[di]).OemProductNamePtr, ax
	mov	(VBEINFOBLOCK PTR es:[di]).OemProductNamePtr+2, es

	lea	ax, [di+(offset ProductRev - offset VIB)]
	mov	(VBEINFOBLOCK PTR es:[di]).OemProductRevPtr, ax
	mov	(VBEINFOBLOCK PTR es:[di]).OemProductRevPtr+2, es

	jmp	L009

; come here to copy only VBE version 1.x data
L001:	push	sizeof VIB	; number of bytes to copy
	call	BUFCOPY

; leave a return value in AX
L009:	mov	ax, 4Fh 	; AX = successful return
	ret

Fn4F00		ENDP

;
; Fn4F01 -- return SVGA mode information

		PUBLIC	Fn4F01
Fn4F01		PROC	NEAR

	cmp	cx, VBEModeFirst
	jb	L100
	cmp	cx, VBEModeLast
	jbe	L101

; not an M256X mode, so chain to the previous VBE handler
L100:	pushf
	call	PrevVBE
	ret

; use the specified video mode to choose the MIB
L101:	sub	cx, VBEModeFirst
	xchg	ch, cl		; multiply by 256 (sizeof MODEINFOBLOCK)
	add	cx, offset MIB0 ; DS:CX -> MIB

	push	es
	push	di
	push	ds
	push	cx
	push	sizeof MODEINFOBLOCK
	call	BUFCOPY

	mov	ax, 4Fh 	; AX = successful return
	ret

Fn4F01		ENDP

;
; Fn4F02 -- set SVGA video mode

		PUBLIC	Fn4F02
Fn4F02		PROC	NEAR

	mov	NewMode, bx	; save the requested mode number
	and	bh, 3Fh 	; BX = bits 0-13 of mode number

	cmp	bx, VBEModeFirst
	jb	L200
	cmp	bx, VBEModeLast
	jbe	L202

; not an M256X mode, so chain to the previous VBE handler
L200:	mov	bx, NewMode	; restore bits 14-15
	pushf			; call the previous handler ...
	call	PrevVBE 	; ... to set the mode

	cmp	ax, 4Fh 	; jump if previous handler did not ...
	jne	L201		; ... return a VBE "success" status

	mov	ax, 4F03h	; call the previous handler ...
	pushf			; ... to get the new mode number
	call	PrevVBE

	push	bx
	call	INITVSP

	mov	ax, 4Fh 	; AX = successful return

L201:	ret

; come here to set up the requested video mode
L202:	mov	ax, 014Fh	; (error return value)

	test	NewMode, 4000h	; test bit 14 (flat buffer addressing)
	jnz	L209		; if set, exit with AX=error return

; set up the requested video mode
	call	SwitchStack

	push	bx		; push bits 0-13 of mode number
	call	INITVSP

	mov	bx, NewMode
	and	bh, 3Fh 	; BX = bits 0-13 of mode number
	push	bx

	mov	bx, NewMode
	and	bx, 8000h	; isolate bit 15 ("clear memory" flag)
	xor	bh, 80h 	; BX = 0 if bit 15 was set
	push	bx		; push the flag
	call	SETVMODE256

; update the VDDA INFO byte
	mov	bx, NewMode
	and	bh, 80h 	; isolate bit 15

	push	ds
	push	segVDDA
	pop	ds

	and	BYTE PTR ds:[INFO], 7Fh
	or	ds:[INFO],bh

	pop	ds

	call	UnswitchStack
	mov	ax, 4Fh 	; AX = successful return

L209:	ret

Fn4F02		ENDP

;
; Fn4F03 -- return current video mode

		PUBLIC	Fn4F03
Fn4F03		PROC	NEAR

; get the BIOS 8-bit mode number and the "memory clear" bit
	push	ds		; preserve DS
	push	segVDDA
	pop	ds		; DS -> VDDA

	mov	al, ds:[CRT_MODE]	; AL = BIOS 8-bit mode number
	mov	ah, BYTE PTR ds:[INFO]	; get VDDA INFO byte
	and	ah, 80h 		; isolate bit 7
	pop	ds

	mov	bx, VSP.usMode	; BX = current video mode number
	or	bh, bh
	jnz	L301		; jump if VESA mode

; non-VESA mode, so return the 8-bit mode number
	or	al, ah			; update AL bit 7
	xor	ah, ah			; AX = BIOS mode number
	mov	bx, ax
	jmp	L309

; come here to return a VBE mode number
L301:	or	bh, ah			; update BX bit 15

L309:	mov	ax, 4Fh     ; AX = successful return
	ret

Fn4F03		ENDP

;
; Fn4F04 --save/restore SVGA video state

		PUBLIC	Fn4F04
Fn4F04		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L400
	cmp	VSP.usMode, VBEModeLast
	jbe	L401

; not an M256X mode, so just chain to the previous int 10h handler
L400:	pushf
	call	PrevVBE
	ret

L401:	mov	ah, 1	    ; VESA error return
	ret

Fn4F04		ENDP

;
; Fn4F05 -- CPU video memory window control

		PUBLIC	Fn4F05
Fn4F05		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L500
	cmp	VSP.usMode, VBEModeLast
	jbe	L501

; not an M256X mode, so just chain to the previous int 10h handler
L500:	pushf
	call	PrevVBE
	ret

L501:	mov	ah, 1	    ; VESA error return
	ret

Fn4F05		ENDP

;
; Fn4F06 -- set/get logical scan line length

		PUBLIC	Fn4F06
Fn4F06		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L600
	cmp	VSP.usMode, VBEModeLast
	jbe	L601

; not an M256X mode, so just chain to the previous int 10h handler
L600:	pushf
	call	PrevVBE
	ret

; jump to the appropriate routine for the specified subfunction
L601:	cmp	bl, 0
	je	L620

	cmp	bl, 1
	je	L630

	cmp	bl, 2
	je	L610

	mov	ah, 1		; error return (invalid subfunction)
	ret

; subfunction 2: set logical row length in bytes
L610:	mov	dx, 1
	xor	ax, ax		; DX:AX = 10000h
	div	VSP.usSY	; AX = maximum row size in bytes
	cmp	ax, cx
	jb	L695		; jump if specified row size is too big

	shl	cx, 2		; CX = row size in pixels
	jmp	L625

; subfunction 0: set logical row length in pixels
L620:	mov	dx, 1
	xor	ax, ax		; DX:AX = 10000h
	div	VSP.usSY	; AX = maximum row size in bytes
	shl	ax, 2		; AX = maximum row size in pixels
	and	al, 0F8h	; round down to a multiple of 8 pixels
	cmp	ax, cx
	jb	L695		; jump if specified row size is too big

; come here to redimension the video buffer
L625:	call	SwitchStack
	push	cx		; x (row length in pixels)
	push	0FFFFh		; y (maximum value for # of rows)
	push	0		; flag (x and y specify pixels)
	call	SETVBUFDIMS
	call	UnswitchStack

; subfunction 1: get logical row length
L630:	mov	bx, VSP.cbRow
	mov	cx, VSP.usCX
	mov	dx, VSP.usCY

	mov	ax, 4Fh 	; AX = successful return
	ret

; come here if logical row size is too big
L695:	mov	cx, ax		; CX = maximum logical row size
	mov	ax, 24Fh	; AX = error return
	ret

Fn4F06		ENDP

;
; Fn4F07 -- set/get display start

		PUBLIC	Fn4F07
Fn4F07		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L700
	cmp	VSP.usMode, VBEModeLast
	jbe	L701

; not an M256X mode, so just chain to the previous int 10h handler
L700:	pushf
	call	PrevVBE
	ret

L701:	and	bl, 7Fh 	; test bits 0-6
	jnz	L705		; jump if nonzero

; come here to set display-start coordinates
	call	SwitchStack
	push	cx		; x-coordinate of upper left corner
	push	dx		; y-coordinate of upper left corner
	push	0		; flag (use pixel coordinates)
	call	SETSCREENORG
	call	UnswitchStack

; come here to get display-start coordinates
L705:	xor	bh, bh		; (always 0)
	mov	cx, VSP.usX
	mov	dx, VSP.usY

	mov	ax, 4Fh 	; AX = successful return
	ret

Fn4F07		ENDP

;
; Fn4F08

		PUBLIC	Fn4F08
Fn4F08		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L800
	cmp	VSP.usMode, VBEModeLast
	jbe	L801

; not an M256X mode, so just chain to the previous int 10h handler
L800:	pushf
	call	PrevVBE
	ret

L801:	mov	ah, 1	    ; AX = error return value

	cmp	bl, 1
	jne	L809	    ; exit with error if not subfunction 1

; come here for subfunction 1 (return number of bits per primary color)
	mov	bh, 6	    ; (always 6 bits for VGA video DAC)
	mov	ax, 4Fh     ; AX = successful return value

L809:	ret

Fn4F08		ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS
		EXTRN	PrevVBE:DWORD

NewMode 	WORD	?

; VBE information block
VIB		VBEINFOBLOCK < 'VESA',				    \
				200h,				    \
				offset OEMString, seg DGROUP,	    \
				0,				    \
				offset VideoModeList, seg DGROUP,   \
				4,				    \
				100h,				    \
				offset VendorName, seg DGROUP,	    \
				offset ProductName, seg DGROUP,     \
				offset ProductRev, seg DGROUP >

; the VBE OEM data immediately follows the VbeInfoBlock data
; (this is a convenience for supporting VBE version 2.0 only)
OEMString	BYTE	'VGA 256-color graphics modes', 0
VendorName	BYTE	'Microsoft Press', 0
ProductName	BYTE	'M256X -- VBE for VGA 256-color graphics', 0
ProductRev	BYTE	'version 2.0', 0

; the list of VBE video mode numbers is last so that it can be
;  expanded if necessary
VideoModeList	WORD	VBEMode0, VBEMode1, VBEMode2, \
			VBEMode3, VBEMode4, VBEMode5

		PUBLIC	VMLEnd
VMLEnd		WORD	0FFFFh

; round up to a total of 256 bytes
		BYTE	256-($-OEMString) DUP(?)

; VESA mode info blocks
MIB0		MODEINFOBLOCK	< ,,,,,,,, 80, 320, 200, 8,  8 >
MIB1		MODEINFOBLOCK	< ,,,,,,,, 80, 320, 240, 8,  8 >
MIB2		MODEINFOBLOCK	< ,,,,,,,, 80, 320, 400, 8, 16 >
MIB3		MODEINFOBLOCK	< ,,,,,,,, 90, 360, 240, 8,  8 >
MIB4		MODEINFOBLOCK	< ,,,,,,,, 90, 360, 400, 8, 16 >
MIB5		MODEINFOBLOCK	< ,,,,,,,, 90, 360, 480, 8, 16 >

_DATA		ENDS

		END
