		TITLE	E32.ASM
		NAME	E32
		PAGE	55,132

.386

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE USE16 PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	PIXELADDR10:FAR
		EXTRN	PIXELADDR13:FAR
		EXTRN	PIXELADDR256:FAR

; parameters for all Ellipse functions
ucPixel 	EQU	BYTE PTR [bp+6]
b		EQU	WORD PTR [bp+8]
a		EQU	WORD PTR [bp+10]
yc		EQU	WORD PTR [bp+12]
xc		EQU	WORD PTR [bp+14]

; temporary variables
ULAddr		EQU	WORD PTR [bp-2]
URAddr		EQU	WORD PTR [bp-4]
LLAddr		EQU	WORD PTR [bp-6]
LRAddr		EQU	WORD PTR [bp-8]
LMask		EQU	BYTE PTR [bp-10]
RMask		EQU	BYTE PTR [bp-12]

_d		EQU	DWORD PTR [bp-16]
_dx		EQU	DWORD PTR [bp-20]
_dy		EQU	DWORD PTR [bp-24]
Asquared	EQU	DWORD PTR [bp-28]
Bsquared	EQU	DWORD PTR [bp-32]
TwoAsquared	EQU	DWORD PTR [bp-36]
TwoBsquared	EQU	DWORD PTR [bp-40]

; Ellipse10X
;
;   void VS2API Ellipse10X( USHORT xc, USHORT yc,
;				USHORT a, USHORT b, UCHAR ucPixel );

		PUBLIC	ELLIPSE10X
ELLIPSE10X	PROC	FAR

	enter	40, 0
	push	si
	push	di

; set up the Graphics Controller
	mov	dx, 3CEh	; DX = Graphics Controller I/O addr
	mov	ax, 0B05h	; AL = Mode register number
				; AH = Write Mode 3 (bits 0,1)
	out	dx, ax		;	Read Mode 1 (bit 4)

	mov	ah, ucPixel	; AH = pixel value
	xor	al, al		; AL = Set/Reset reg number
	out	dx, ax

	mov	ax, 0F01h	; AH = value for Enable Set/Reset
	out	dx, ax		; AL = Enable Set/Reset reg number

	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select reg
	out	dx, ax

	mov	ax, 7		; AH = 0; AL = Color Don't Care reg
	out	dx, ax

; initial constants
	movzx	eax, a		    ; EAX = a
	mul	eax		    ; EAX = a^2
	mov	Asquared, eax
	shl	eax, 1		    ; EAX = 2*a^2
	mov	TwoAsquared, eax

	movzx	eax, b
	mul	eax		    ; EAX = b^2
	mov	Bsquared, eax
	shl	eax, 1		    ; EAX = 2*b^2
	mov	TwoBsquared, eax

			    ; plot pixels from (0,b) until dy/dx = -1

; initial buffer address and bit mask
	mov	ax, b
	mul	VSP.cbRow	; AX = relative byte offset of b
	mov	si, ax
	mov	di, ax

	push	xc
	push	yc
	call	PixelAddr10
	mov	bx, ax
	mov	es, dx		; ES:BX -> buffer

	mov	ah, 80h 	; AH = 80h (bit mask)
	mov	cl, BYTE PTR xc
	and	cl, 7		; CL = xc MOD 8
	shr	ah, cl

	mov	LMask, ah
	mov	RMask, ah

	add	si, bx		; SI = offset of (0,b)
	mov	ULAddr, si
	mov	URAddr, si
	sub	bx, di		; BX = offset of (0,-b)
	mov	LLAddr, bx
	mov	LRAddr, bx

; initial decision variables
	xor	eax, eax
	mov	_dx, eax	; dx = 0

	mov	eax, TwoAsquared
	movzx	edx, b
	mul	edx		; EAX = dy = TwoAsquared*b
	mov	_dy, eax

	mov	eax, Asquared
	shr	eax, 2		; EAX = Asquared/4
	add	eax, Bsquared	; EAX = Bsquared + Asquared/4
	mov	_d, eax 	; d = Bsquared + Asquared/4

	mov	eax, Asquared
	movzx	edx, b
	mul	edx		; EAX = Asquared*b
	sub	_d, eax 	; d = Bsquared - Asquared*b + Asquared/4

; loop until dy/dx >= -1
	mov	bx, b		; BX = initial y-coordinate

	xor	cx, cx		; CH = 0 (initial y-increment)
				; CL = 0 (initial x-increment)
L010:	mov	eax, _dx
	cmp	eax, _dy
	jge	L020		; jump if dx>=dy

	call	Set4Pixels10X

	mov	cx, 1		; CH = 0 (y-increment)
				; CL = 1 (x-increment)
	bt	_d, 31		; test the high-order bit
	jc	L011		; jump if d < 0

	mov	ch, 1		; increment in y direction
	dec	bx		; decrement current y-coordinate

	mov	eax, _dy
	sub	eax, TwoAsquared
	mov	_dy, eax	; dy = dy - TwoAsquared
	sub	_d, eax 	; d = d - dy

L011:	mov	eax, _dx
	add	eax, TwoBsquared
	mov	_dx, eax	; dx = dx + TwoBsquared

	add	eax, Bsquared	; EAX = dx + Bsquared
	add	_d, eax 	; d = d + dx + Bsquared

	jmp	L010

			    ; plot pixels from current (x,y) until y < 0

; update decision variables
L020:	mov	eax, Asquared
	sub	eax, Bsquared	; EAX = Asquared-Bsquared
	mov	edx, eax	; EDX = Asquared-Bsquared
	sar	edx, 1		; EDX = (Asquared-Bsquared)/2
	add	eax, edx	; EAX = 3*(Asquared-Bsquared)/2

	sub	eax, _dx
	sub	eax, _dy    ; EAX = 3*(Asquared-Bsquared)/2 - (dx+dy)
	sar	eax, 1	    ; EAX =
			    ;  (3*(Asquared-Bsquared)/2 - (dx+dy))/2
	add	_d, eax     ; update d

; loop until y < 0
L021:	call	Set4Pixels10X

	mov	cx, 100h	; CH = 1 (y-increment)
				; CL = 0 (x-increment)
	bt	_d, 31		; test the high-order bit
	jnc	L022		; jump if d >= 0

	mov	cl, 1		; increment in x direction

	mov	eax, _dx
	add	eax, TwoBsquared    ; EAX = dx + TwoBsquared
	mov	_dx, eax	    ; dx = dx + TwoBsquared

	add	_d, eax 	    ; d = d + dx

L022:	mov	eax, _dy
	sub	eax, TwoAsquared    ; EAX = dy - TwoAsquared
	mov	_dy, eax	    ; dy = d - TwoAsquared

	sub	eax, Asquared	    ; EAX = dy - Asquared
	sub	_d, eax 	    ; d = d + Asquared - dy

	dec	bx		    ; decrement y
	jns	L021		    ; loop if y >= 0

; restore the default Graphics Controller state
	mov	dx, 3CEh
	xor	ax, ax		; AH = 0, AL = 0
	out	dx, ax		; Set/Reset

	inc	ax		; AH = 0, AL = 1
	out	dx, ax		; Enable Set/Reset

	mov	al, 3		; AH = 0, AL = 3
	out	dx, ax		; Data Rotate/Func Select

	mov	al, 5		; AH = 0, AL = 5
	out	dx, ax		; Mode

; restore registers and return
	pop	di
	pop	si
	leave			; 4*sizeof(USHORT) + sizeof(UCHAR)
	ret	10

ELLIPSE10X	ENDP

; Set4Pixels10X
;
; Caller:   CH = y-increment (0 or -1)
;	    CL = x-increment (0 or 1)

Set4Pixels10X	PROC	NEAR

	push	ax		; preserve these regs
	push	bx

	xor	bx, bx		; BX = 0
	test	ch, ch
	jz	L030		; jump if y-increment = 0

	mov	bx, VSP.cbRow
	neg	bx		; BX = negative y-increment

; pixels at (xc-x,yc+y) and (xc-x,yc-y)
L030:	xor	si, si		; SI = 0
	mov	ah, LMask
	rol	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around
	neg	si		; SI = 0 or -1

	mov	di, si		; SI,DI = left x-increment

	add	si, ULAddr	; SI = upper left addr + horiz incr
	add	si, bx		; SI = new upper left addr
	add	di, LLAddr
	sub	di, bx		; DI = new lower left addr

	mov	LMask, ah	; update these variables
	mov	ULAddr, si
	mov	LLAddr, di

	and	es:[si], ah	; update upper left pixel
	and	es:[di], ah	; update lower left pixel

; pixels at (xc+x,yc+y) and (xc+x,yc-y)
	xor	si, si		; SI = 0
	mov	ah, RMask
	ror	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around

	mov	di, si		; SI,DI = right x-increment

	add	si, URAddr	; SI = upper right addr + horiz incr
	add	si, bx		; SI = new upper right addr
	add	di, LRAddr
	sub	di, bx		; DI = new lower right addr

	mov	RMask, ah	; update these variables
	mov	URAddr, si
	mov	LRAddr, di

	and	es:[si], ah	; update upper left pixel
	and	es:[di], ah	; update lower left pixel

	pop	bx
	pop	ax
	ret

Set4Pixels10X	ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD USE16 PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
