		TITLE	VMODE.ASM
		NAME	VMODE
		PAGE	55,132

.286

INCLUDE 	vs2.inc

; bits for EQUIP_FLAG
CGAbits 	EQU	00100000b
MDAbits		EQU	00110000b

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'

; SetVMode
;
;   void VS2API SetVMode( USHORT usMode );

; parameter
usMode		EQU	[bp+6]

		PUBLIC	SETVMODE
SETVMODE	PROC	FAR

	enter	0, 0

	mov	bx, usMode
	or	bh, bh
	jnz	L002		; jump if VESA BIOS mode

; set bits in EQUIP_FLAG
	mov	al, bl		; AL = desired video mode number
	mov	bl, CGAbits	; BL = bits indicating presence of CGA

	mov	ah, al		; test if desired mode is monochrome
	and	ah, 7
	cmp	ah, 7
	jne	L001		; jump if desired mode not 7 or 0Fh

	mov	bl, MDAbits	; BL = bits indicating presence of MDA

L001:	push	segVDDA 	; ES -> Video Display Data Area
	pop	es

	and	BYTE PTR es:[EQUIP_FLAG], 11001111b
	or	BYTE PTR es:[EQUIP_FLAG], bl

; set BIOS video mode
	xor	ah, ah		; AH = 0 (Set Video Mode)
	int	10h
	jmp	L003

; come here to set VESA BIOS video mode
L002:	mov	ax, 4F02h	; AH = 4Fh (VESA BIOS function)
				; AL = 2 (Set SVGA video mode)
	int	10h

L003:	leave
	ret	2		; sizeof(USHORT)

SETVMODE	ENDP

; GetVMode
;
;   USHORT VS2API GetVMode( void );

		PUBLIC	GETVMODE
GETVMODE	PROC	FAR

	enter	0, 0

; try to get a VESA BIOS video mode number
	mov	ax, 4F03h   ; AH = 4Fh (VESA BIOS function)
			    ; AL = 3 (get current video mode)
	int	10h
	cmp	ax, 4Fh
	jne	L101

	mov	ax, bx	    ; AX = VESA video mode
	jmp	L102

; come here to request a non-VESA video-mode number
L101:	mov	ah, 0Fh     ; AH = 0Fh (INT 10h function number)
	int	10h	    ; call ROM BIOS to get video mode number
	xor	ah, ah	    ; AX = video mode number

L102:	leave
	ret

GETVMODE	ENDP

VS2_TEXT	ENDS

		END
