		TITLE	VRWAIT.ASM
		NAME	VRWAIT
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

; VRWait
;
;   void VS2API VRWait( void );

		PUBLIC	VRWAIT
VRWAIT		PROC	FAR

	push	ds
	push	ax
	push	dx

	push	segVDDA
	pop	ds
	mov	dx, ds:[ADDR6845]
	add	dx, 6	    ; DX = Status Register 1 I/O addr

; wait for vertical retrace to end
L000:	in	al, dx
	test	al, 8
	jnz	L000

; wait for next vertical retrace
L001:	in	al, dx
	test	al, 8
	jz	L001

	pop	dx
	pop	ax
	pop	ds
	ret

VRWAIT		ENDP

; InitVNWait
;
;   void VS2API InitVNWait( void );
;
; Notes:
;   Initializes a timeout value for detecting the start of the
;   vertical nondisplay interval.

		PUBLIC	INITVNWAIT
INITVNWAIT	PROC	FAR

	enter	0, 0
	push	ax		; save AX, CX, DX
	push	cx
	push	dx
	push	ds		; save DS

	push	segVDDA
	pop	ds
	mov	dx, ds:[ADDR6845]
	add	dx, 6		; DX = Status Register 1 I/O addr

; wait for vertical retrace
L101:	in	al, dx
	test	al, 8
	jz	L101

; initialize the loop counter
	mov	cx, 0FFFFh	; CX = FFFFh

; wait for display enable
L102:	in	al, dx
	test	al, 1
	jnz	L102

; wait for the end of display enable
	cli			; disable interrupts
L103:	in	al, dx
	test	al, 1
	jz	L103

; loop until display enable becomes active
L104:	in	al, dx
	test	al, 1
	loopnz	L104
	sti			; enable interrupts

	pop	ds		; DS -> DGROUP

	neg	cx		; make CX positive
	add	cx, cx		; double it for safety
	mov	_VNLoopMax, cx	; save the result

	pop	dx		; restore AX, CX, DX
	pop	cx
	pop	ax
	leave
	ret

INITVNWAIT	ENDP

; VNWait
;
;   void VS2API VNWait( void );
;
; Notes:
;   Waits for "display enable end" by timing out when bit 0
;   of VGA Input Status Register 1 stays set to 1.  This indicates
;   that horizontal display enable is remaining inactive, that is,
;   that the vertical nondisplay interval has begun.
;
;   Call InitVNWait prior to using this function.

		PUBLIC	VNWAIT
VNWAIT		PROC	FAR

	push	ds
	push	ax
	push	cx
	push	dx

	push	segVDDA
	pop	ds		; DS -> BIOS data area
	mov	dx, ds:[ADDR6845]
	add	dx, 6		; DX = Status Register 1 I/O addr

	push	seg DGROUP
	pop	ds		; DS -> DGROUP

; wait for display enable
L201:	in	al, dx
	test	al, 1
	jnz	L201

; wait for the end of display enable
L202:	mov	cx, _VNLoopMax	; CX = maximum number of loops
L203:	in	al, dx
	test	al, 1
	jz	L203

; wait for display enable
L204:	in	al, dx
	test	al, 1
	loopnz	L204
	jz	L202		; jump if display enable detected

	pop	dx
	pop	cx
	pop	ax
	pop	ds
	ret

VNWAIT		ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		PUBLIC	_VNLoopMax
_VNLoopMax	WORD	?

_DATA		ENDS

		END
