		TITLE	ALPHATXT.ASM
		NAME	ALPHATXT
		PAGE	55,132

.286

INCLUDE 	vs2.inc

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'

; TextAt
;
;   void VS2API
;   TextAt( USHORT x, USHORT y, char far * sz, UCHAR attrib );
;
; Notes:
;   If bit 15 of x is set, the text is displayed at the current cursor
;   x position.  If bit 15 of y is set, the text is displayed at the
;   current cursor y position.

; parameters
attrib		EQU	BYTE PTR [bp+6]
sz		EQU	DWORD PTR [bp+8]
y		EQU	WORD PTR [bp+12]
x		EQU	WORD PTR [bp+14]

; temporary variables
len		EQU	WORD PTR [bp-2]

		PUBLIC	TEXTAT
TEXTAT		PROC	FAR

	enter	2, 0
	push	di

; determine the length of the string
	les	di, sz	    ; ES:DI -> null-terminated string
	xor	al, al	    ; AL = 0
	mov	cx, 0FFFFh  ; CX = loop index for scan
	cld
	repne scasb
	not	cx
	dec	cx	    ; CX = string length
	mov	len, cx

; get the current cursor position and video page
	mov	ah, 0Fh     ; int 10h function number
	int	10h	    ; BH = video page
	mov	di, bx	    ; (save in DI)

	mov	ah, 3	    ; int 10h function number
	int	10h	    ; DL = cursor x; DH = cursor y

	mov	ax, x
	or	ax, ax
	js	L002	    ; jump to use current cursor x

	mov	dl, al	    ; DL = user-specified x

L002:	mov	ax, y
	or	ax, ax
	js	L004	    ; jump to use current cursor y

	mov	dh, al	    ; DH = current cursor y

; come here to display the text
L004:	mov	ax, 1301h   ; AH = int 10h function number
			    ; AL = 1 (use attribute in BL and update
			    ;		the cursor position)
	mov	bx, di	    ; BH = video page
	mov	bl, attrib
	mov	cx, len     ; CX = # of bytes to display

	push bp
	les	bp, sz	    ; ES:BP -> sz
	int	10h
	pop bp

	pop	di
	leave
	ret	10		; 3*sizeof(USHORT) + sizeof(LPCHAR)

TEXTAT		ENDP

; SetBlink
;
;   void VS2API SetBlink( USHORT flag );
;
; Notes:
;   If the flag is nonzero, blinking is enabled.

; parameters
flag		EQU	BYTE PTR [bp+6]

		PUBLIC	SETBLINK
SETBLINK	PROC	FAR

	enter	0, 0

	xor	bl, bl		; BL = 0
	neg	flag		; cf set if flag is nonzero
	rcl	bl, 1		; BL = 1 if flag is nonzero
	mov	ax, 1003h	; AH = int 10h function number
				; AL = 3 (subfunction number)
	int	10h

	leave
	ret	2		; sizeof(USHORT)

SETBLINK	ENDP

; SetBorder
;
;   void VS2API SetBorder( UCHAR border );

; parameters
border		EQU	BYTE PTR [bp+6]

		PUBLIC	SETBORDER
SETBORDER	PROC	FAR

	enter	0, 0

	mov	bh, border
	mov	ax, 1001h	; AH = int 10h function number
				; AL = 1 (subfunction number)
	int	10h

	leave
	ret	2		; sizeof(UCHAR)

SETBORDER	ENDP

VS2_TEXT	ENDS

		END
