		TITLE	FADE16.ASM
		NAME	FADE16
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	VNWAIT:FAR

; temporary variable used in InitFade16, FadeDn16, FadeUp16
n		EQU	[bp-2]

; InitFade16
;
;   void VS2API InitFade16( void );

		PUBLIC	INITFADE16
INITFADE16	PROC	FAR

	enter	2, 0		; reserve 2 bytes on stack

	push	si		; preserve registers
	push	di
	cld

; load the DAC with 16 16-color palettes
	mov	BYTE PTR n, 0

L001:	mov	si, offset DACPal0
	mov	di, offset DACPal
	push	ds
	pop	es		; ES:DI -> DACPal

	mov	bl, 16
	sub	bl, n		; BL = 16-n

	mov	cx, 16*3	; # of values in DACPal

L002:	lodsb			; AL = DACPal0 value
	mul	bl		; AX = value * (16-n)
	shr	ax, 4		; AL = (value * (16-n)) / 16
	stosb			; update DACPal value
	loop	L002

	mov	bx, n
	shl	bx, 4		; BX = starting DAC register
	mov	cx, 16		; CX = # of DAC registers
	mov	dx, offset DACPal
	push	ds
	pop	es		; ES:DX -> DACPal
	mov	ax, 1012h	; AH = function 10h
				; AL = subfunction 12h
	int	10h

	inc	BYTE PTR n	; loop while n<16
	cmp	BYTE PTR n, 16
	jb	L001

; load the Attribute Controller palette registers
	mov	dx, offset PalVal
	push	ds
	pop	es		; ES:DX -> PalVal
	mov	ax, 1002h	; AH = function 10h
				; AL = subfunction 2
	int	10h

	pop	di		; restore regs and return
	pop	si
	leave
	ret

INITFADE16	ENDP

; FadeDn16
;
;   void VS2API FadeDn16( void );

		PUBLIC	FADEDN16
FADEDN16	PROC	FAR

	enter	2, 0		; reserve 2 bytes on stack

	mov	BYTE PTR n, 0

L010:	call	VNWAIT		; wait for vertical nondisplay

; set Attribute Controller Mode Control bit 7
	mov	bx, 0100h	; BL = 0 (set bit 7)
				; BH = 1 (value for bit 7)
	mov	ax, 1013h	; AH = function 10h
				; AL = subfunction 13h
	int	10h

; select the nth 16-color palette in the DAC
	mov	bl, 1		; BL = 1 (select nth palette)
	mov	bh, n		; BH = n
	mov	ax, 1013h	; AH = function 10h
				; AL = subfunction 13h
	int	10h

	inc	BYTE PTR n	; loop while n<16
	cmp	BYTE PTR n, 16
	jb	L010

	leave
	ret

FADEDN16	ENDP

; FadeUp16
;
;   void VS2API FadeUp16( void );

		PUBLIC	FADEUP16
FADEUP16	PROC	FAR

	enter	2, 0		; reserve 2 bytes on stack

	mov	BYTE PTR n, 15

L020:	call	VNWAIT		; wait for vertical nondisplay

; set Attribute Controller Mode Control bit 7
	mov	bx, 0100h	; BL = 0 (set bit 7)
				; BH = 1 (value for bit 7)
	mov	ax, 1013h	; AH = function 10h
				; AL = subfunction 13h
	int	10h

; select the nth 16-color palette in the DAC
	mov	bl, 1		; BL = 1 (select nth palette)
	mov	bh, n		; BH = n
	mov	ax, 1013h	; AH = function 10h
				; AL = subfunction 13h
	int	10h

	dec	BYTE PTR n	; loop while n>=0
	jns	L020

	leave
	ret

FADEUP16	ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

DACPal0 	BYTE	00h, 00h, 00h	; 00h
		BYTE	00h, 00h, 2Ah	; 01h
		BYTE	00h, 2Ah, 00h	; 02h
		BYTE	00h, 2Ah, 2Ah	; 03h
		BYTE	2Ah, 00h, 00h	; 04h
		BYTE	2Ah, 00h, 2Ah	; 05h
		BYTE	2Ah, 15h, 00h	; 06h
		BYTE	2Ah, 2Ah, 2Ah	; 07h
		BYTE	15h, 15h, 15h	; 08h
		BYTE	15h, 15h, 3Fh	; 09h
		BYTE	15h, 3Fh, 15h	; 0Ah
		BYTE	15h, 3Fh, 3Fh	; 0Bh
		BYTE	3Fh, 15h, 15h	; 0Ch
		BYTE	3Fh, 15h, 3Fh	; 0Dh
		BYTE	3Fh, 3Fh, 15h	; 0Eh
		BYTE	3Fh, 3Fh, 3Fh	; 0Fh

DACPal		BYTE	16*3 DUP(?)
PalVal		BYTE	00h, 01h, 02h, 03h, 04h, 05h, 06h, 07h
		BYTE	08h, 09h, 0Ah, 0Bh, 0Ch, 0Dh, 0Eh, 0Fh
		BYTE	00h

_DATA		ENDS

		END
