/***********************************************************************

  SVM.C

***********************************************************************/

#include    <stdio.h>	    /* sscanf printf */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

int main( int, char * * );


/***********************************************************************

  main

***********************************************************************/

int main( int argc, char * * argv )
{
    USHORT  usMode;
    UCHAR   ucBorder = 0, ucBkgd = 0;
    LPVDDA  lpVDDA = ADDRVDDA;


    /* verify command-line syntax */
    if( argc < 2 )
    {
      printf( "\nSyntax: SVM <mode> [border [bkgd]]\n" );
      return 3;
    }

    /* pass the mode number to the BIOS */
    sscanf( argv[1], "%x", &usMode );
    SetVMode( usMode );

    /* display the current BIOS video mode number */
    printf( "Video mode %02Xh", lpVDDA->CRTMode );

    /* display the VESA BIOS extension mode number */
    usMode = GetVMode();
    if( usMode != (USHORT)lpVDDA->CRTMode )
      printf( " (VBE mode %02Xh)\n", usMode );
    else
      printf( "\n" );

    /* look for a border color */
    if( argc >= 3 )
    {
      sscanf( argv[2], "%x", &ucBorder );

      if( argc >= 4 )
	sscanf( argv[3], "%x", &ucBkgd );
    }

    /* set the border color */
    if( ucBorder )
      SetBorder( ucBorder );

    /* set the background color by calling the ROM BIOS to */
    /*	store the specified color in palette register 0 */
    if( ucBkgd )
      __asm
      {
	mov ax, 1000h
	mov bh, ucBkgd
	mov bl, 0
	int 10h
      }

    return 0;
}
