		TITLE	'PIXLADDR.ASM'
		NAME	PIXLADDR
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

; parameters for all PixelAddr functions
usY		EQU	[bp+6]
usX		EQU	[bp+8]

; PixelAddr10
;
;   LPCHAR VS2API PixelAddr10( USHORT usX, USHORT usY );
;
; Notes:
;   Valid in VGA video modes that use planar pixel mapping:
;	BIOS mode 0Dh:	320x200 16-color
;	BIOS mode 0Eh:	640x200 16-color
;	BIOS mode 0Fh:	640x350 monochrome (4-color)
;	BIOS mode 10h:	640x350 16-color
;	BIOS mode 11h:	640x480 2-color
;	BIOS mode 12h:	640x480 16-color

		PUBLIC	PIXELADDR10
PIXELADDR10	PROC	FAR

	enter	0, 0

	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)

	mov	dx, usX
	shr	dx, 3		; DX = x/8
	add	ax, dx		; AX = y*(bytes per row) + x/8

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	dx, VSP.segVBuf ; DX:AX = byte addr of pixel

	leave
	ret	4		; 2*sizeof(USHORT)

PIXELADDR10	ENDP

; PixelAddr13
;
;   LPCHAR VS2API PixelAddr13( USHORT usX, USHORT usY );
;
; Notes:
;   Valid in VGA BIOS mode 13h (320x200 256-color)

		PUBLIC	PIXELADDR13
PIXELADDR13	PROC	FAR

	enter	0, 0

	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)
	add	ax, usX 	; AX = y*(bytes per row) + x

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	dx, VSP.segVBuf ; DX:AX = byte addr of pixel

	leave
	ret	4		; 2*sizeof(USHORT)

PIXELADDR13	ENDP

; PixelAddr256
;
;   LPCHAR VS2API PixelAddr256( USHORT usX, USHORT usY );
;
; Notes:
;   Valid in non-chained VGA 256-color modes

		PUBLIC	PIXELADDR256
PIXELADDR256	PROC	FAR

	enter	0, 0

	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)

	mov	dx, usX
	shr	dx, 2		; DX = x/4
	add	ax, dx		; AX = y*(bytes per row) + x/4

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	dx, VSP.segVBuf ; DX:AX = byte addr of pixel

	leave
	ret	4		; 2*sizeof(USHORT)

PIXELADDR256	ENDP

VS2_TEXT	ENDS


_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
