		TITLE	FILLVBUF.ASM
		NAME	FILLVBUF
		PAGE	55,132

.286

INCLUDE 	vs2.inc

; parameters for all FillVBuf functions
ucPixel 	EQU	[bp+6]

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'

; FillVBuf10
;
;   void VS2API FillVBuf10( UCHAR ucPixel );

		PUBLIC	FILLVBUF10
FILLVBUF10	PROC	FAR

	enter	0, 0
	push	es
	push	di

; address the video buffer
	mov	di, seg DGROUP
	mov	es, di
	mov	es, es:VSP.segVBuf
	xor	di, di		; ES:DI -> start of video buffer

; load the specified pixel value into the Set/Reset register
	mov	ah, ucPixel
	mov	al, 0		; AL = 0 (Set/Reset reg #)
	mov	dx, 3CEh	; Graphics Controller I/O addr
	out	dx, ax

	mov	ax, 0F01h	; AH = 1111b (Enable Set/Reset mask)
				; AL = 1 (Enable Set/Reset reg #)
	out	dx, ax

; fill all 4 bit planes
	mov	cx, 8000h
	cld
	rep stosw

; restore the default Enable Set/Reset value
	mov	ax, 1
	out	dx, ax

	pop	di
	pop	es
	leave
	ret	2

FILLVBUF10	ENDP

; FillVBuf13
;
;   void VS2API FillVBuf13( UCHAR ucPixel );

		PUBLIC	FILLVBUF13
FILLVBUF13	PROC	FAR

	enter	0, 0
	push	es
	push	di

; address the video buffer
	mov	di, seg DGROUP
	mov	es, di
	mov	es, es:VSP.segVBuf
	xor	di, di		; ES:DI -> start of video buffer

	mov	ah, ucPixel
	mov	al, ah

	mov	cx, 8000h
	cld
	rep stosw

	pop	di
	pop	es
	leave
	ret	2

FILLVBUF13	ENDP

; FillVBuf256
;
;   void VS2API FillVBuf256( UCHAR ucPixel );
;
; Notes:
;   This routine uses graphics-controller write mode 0.  It assumes that the
;   value of the Enable Set/Reset register is 0.

		PUBLIC	FILLVBUF256
FILLVBUF256	PROC	FAR

	enter	0, 0
	push	es
	push	di

; address the video buffer
	mov	di, seg DGROUP
	mov	es, di
	mov	es, es:VSP.segVBuf
	xor	di, di		; ES:DI -> start of video buffer

; get the specified pixel value
	mov	al, ucPixel
	mov	ah, al

; fill all 4 bit planes
	mov	cx, 8000h
	cld
	rep stosw

	pop	di
	pop	es
	leave
	ret	2

FILLVBUF256	ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
