		TITLE	GETPIXEL.ASM
		NAME	GETPIXEL
		PAGE	55,132

.286

INCLUDE 	vs2.inc

; parameters for all GetPixel functions
usY		EQU	[bp+6]
usX		EQU	[bp+8]

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

; GetPixel10
;
;   UCHAR VS2API GetPixel10( USHORT usX, USHORT usY );

		PUBLIC	GETPIXEL10
GETPIXEL10	PROC	FAR

	enter	0, 0
	push	si

; point to the specified pixel
	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)

	mov	dx, usX
	mov	cx, dx		; CX = x
	shr	dx, 3		; DX = x/8
	add	ax, dx		; AX = y*(bytes per row) + x/8

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	si, ax
	mov	es, VSP.segVBuf ; ES:SI -> pixel

; compute a mask for the pixel's bit position
	not	cl
	and	cl, 7		; CL = # of bits to shift
	mov	ch, 1
	shl	ch, cl		; CH = bit mask

; read one byte from each bit plane
	mov	dx, 3CEh	; GC I/O address
	mov	ax, 304h	; AH = 3 (bit plane number)
				; AL = 4 (Read Map Select reg #)

	xor	bl, bl		; BL = initial pixel value

L001:	out	dx, ax		; select a bit plane
	mov	bh, es:[si]	; read one byte
	and	bh, ch		; mask the desired bit
	neg	bh		; BH bit 7 = masked bit
	rol	bx, 1		; accumulate bits in BL
	dec	ah		; decrement bit plane number
	jge	L001

	mov	al, bl
	xor	ah, ah		; AX = pixel value

	pop	si
	leave
	ret	4		; 2*sizeof(int)

GETPIXEL10	ENDP

; GetPixel13
;
;   UCHAR VS2API GetPixel13( USHORT usX, USHORT usY );

		PUBLIC	GETPIXEL13
GETPIXEL13	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)
	add	ax, usX 	; AX = y*(bytes per row) + x

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	bx, ax
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; get the pixel value
	mov	al, es:[bx]
	xor	ah, ah		; AX = pixel value

	leave
	ret	4		; 2*sizeof(int)

GETPIXEL13	ENDP

; GetPixel256
;
;   UCHAR VS2API GetPixel256( USHORT usX, USHORT usY );

		PUBLIC	GETPIXEL256
GETPIXEL256	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	cx, usX
	mov	bx, cx		    ; BX = x coordinate

	mov	ax, VSP.cbRow
	mul	WORD PTR usY	    ; AX = row offset
	shr	bx, 2		    ; BX = column offset
	add	bx, ax		    ; BX = buffer offset
	add	bx, VSP.ofsVBuf
	mov	es, VSP.segVBuf     ; ES:BX -> pixel

; select the plane that contains the specified pixel
	and	cl, 3
	mov	ah, cl		    ; AH = Read Map plane #
	mov	al, 4		    ; AL = Read Map reg #

	mov	dx, 3CEh	    ; Graphics Controller I/O addr
	out	dx, ax

; get the pixel value
	mov	al, es:[bx]
	xor	ah, ah

	leave
	ret	4		    ; 2*sizeof(int)

GETPIXEL256	ENDP

VS2_TEXT	ENDS


_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
