		TITLE	SETPIXEL.ASM
		NAME	SETPIXEL
		PAGE	55,132

.286

INCLUDE 	vs2.inc

; parameters for all SetPixel functions
ucPixel 	EQU	[bp+6]
usY		EQU	[bp+8]
usX		EQU	[bp+10]

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

; SetPixel10
;
;   void VS2API SetPixel10( USHORT usX, USHORT usY, UCHAR ucPixel );

		PUBLIC	SETPIXEL10
SETPIXEL10	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)

	mov	dx, usX
	mov	cx, dx		; CX = x
	shr	dx, 3		; DX = x/8
	add	ax, dx		; AX = y*(bytes per row) + x/8

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	bx, ax
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; compute a mask for the pixel's bit position
	and	cl, 7		; CL = # of bits to shift
	mov	ax, 8008h	; AH = 80h (bit mask)
				; AL = 8 (Bit Mask reg #)
	shr	ah, cl		; AH = bit mask for pixel

; set the Graphics Controller Bit Mask register
	mov	dx, 3CEh	; GC I/O address
	out	dx, ax

; set the Graphics Controller Mode register
	mov	ax, 205h	; AL = Mode register #
				; AH = Write Mode 2 (bits 0,1)
				;      Read Mode 0 (bit 3)
	out	dx, ax

; set the Data Rotate/Function Select register
	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select
	out	dx, ax

; set the pixel value
	mov	al, ucPixel	; AL = pixel value
	xchg	es:[bx], al	; load latches during CPU read;
				; update latches and bit planes
				;  during CPU write

; restore default Graphics Controller registers
	mov	ax, 0FF08h	; Bit Mask
	out	dx, ax

	mov	ax, 5		; Mode register
	out	dx, ax

	mov	ax, 3		; Function Select
	out	dx, ax

	leave
	ret	6		; 2*sizeof(int) + sizeof(char)

SETPIXEL10	ENDP

; SetPixel13
;
;   void VS2API SetPixel13( USHORT usX, USHORT usY, UCHAR ucPixel );

		PUBLIC	SETPIXEL13
SETPIXEL13	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	ax, usY
	mul	VSP.cbRow	; AX = y * (bytes per row)
	add	ax, usX 	; AX = y*(bytes per row) + x

	add	ax, VSP.ofsVBuf ; add origin offset
	mov	bx, ax
	mov	es, VSP.segVBuf ; ES:BX -> pixel

	mov	al, ucPixel	; AL = pixel value

; select a raster op
	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select
	mov	dx, 3CEh	; Graphics Controller I/O addr
	out	dx, ax

; update the pixel value
	mov	al, ucPixel
	xchg	es:[bx], al

; restore the Graphics Controller Data Rotate/Function Select register
	mov	ax, 3
	out	dx, ax

	leave
	ret	6		; 2*sizeof(int) + sizeof(char)

SETPIXEL13	ENDP

; SetPixel256
;
;   void VS2API SetPixel256( USHORT usX, USHORT usY, UCHAR ucPixel );

		PUBLIC	SETPIXEL256
SETPIXEL256	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	cx, usX
	mov	bx, cx		; BX = x coordinate

	mov	ax, VSP.cbRow
	mul	WORD PTR usY	; AX = row offset
	shr	bx, 2		; BX = column offset
	add	bx, ax		; BX = buffer offset
	add	bx, VSP.ofsVBuf
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; select the plane that contains the specified pixel
	and	cl, 3
	mov	ax, 0102h	; AL = Map Mask reg #
	shl	ah, cl		; AH = bit plane #

	mov	dx, 3C4h	; Sequencer
	out	dx, ax

; select a raster op
	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select
	mov	dl, 0CEh	; DX = 3CEh (Graphics Controller)
	out	dx, ax

; update the pixel value
	mov	al, ucPixel
	xchg	es:[bx], al

; restore the Graphics Controller Data Rotate/Function Select register
	mov	ax, 3
	out	dx, ax

; restore the Sequencer Map Mask register
	mov	ax, 0F02h
	mov	dl, 0C4h
	out	dx, ax

	leave
	ret	6		; 2*sizeof(int) + sizeof(char)

SETPIXEL256	ENDP

VS2_TEXT	ENDS


_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
