		TITLE	ELLIPSE.ASM
		NAME	ELLIPSE
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	PIXELADDR10:FAR
		EXTRN	PIXELADDR13:FAR
		EXTRN	PIXELADDR256:FAR

; parameters for all Ellipse functions
ucPixel 	EQU	[bp+6]
b		EQU	[bp+8]
a		EQU	[bp+10]
yc		EQU	[bp+12]
xc		EQU	[bp+14]

; temporary variables
ULAddr		EQU	WORD PTR [bp-2]
URAddr		EQU	WORD PTR [bp-4]
LLAddr		EQU	WORD PTR [bp-6]
LRAddr		EQU	WORD PTR [bp-8]
LMask		EQU	BYTE PTR [bp-10]
RMask		EQU	BYTE PTR [bp-12]

_d		EQU	WORD PTR [bp-16]
_dx		EQU	WORD PTR [bp-20]
_dy		EQU	WORD PTR [bp-24]
Asquared	EQU	WORD PTR [bp-28]
Bsquared	EQU	WORD PTR [bp-32]
TwoAsquared	EQU	WORD PTR [bp-36]
TwoBsquared	EQU	WORD PTR [bp-40]

; Ellipse10
;
;   void VS2API Ellipse10( USHORT xc, USHORT yc,
;				USHORT a, USHORT b, UCHAR ucPixel );

		PUBLIC	ELLIPSE10
ELLIPSE10	PROC	FAR

	enter	40, 0
	push	si
	push	di

; set up the Graphics Controller
	mov	dx, 3CEh	; DX = Graphics Controller I/O addr
	mov	ax, 0B05h	; AL = Mode register number
				; AH = Write Mode 3 (bits 0,1)
	out	dx, ax		;	Read Mode 1 (bit 4)

	mov	ah, ucPixel	; AH = pixel value
	xor	al, al		; AL = Set/Reset reg number
	out	dx, ax

	mov	ax, 0F01h	; AH = value for Enable Set/Reset
	out	dx, ax		; AL = Enable Set/Reset reg number

	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select reg
	out	dx, ax

	mov	ax, 7		; AH = 0; AL = Color Don't Care reg
	out	dx, ax

; initial constants
	mov	ax, a
	mul	ax
	mov	Asquared, ax
	mov	Asquared+2, dx	    ; a^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoAsquared, ax
	mov	TwoAsquared+2, dx   ; 2*a^2

	mov	ax, b
	mul	ax
	mov	Bsquared, ax
	mov	Bsquared+2, dx	    ; b^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoBsquared, ax
	mov	TwoBsquared+2, dx   ; 2*b^2

			    ; plot pixels from (0,b) until dy/dx = -1

; initial buffer address and bit mask
	mov	ax, b
	mul	VSP.cbRow	; AX = relative byte offset of b
	mov	si, ax
	mov	di, ax

	push	xc
	push	yc
	call	PixelAddr10
	mov	bx, ax
	mov	es, dx		; ES:BX -> buffer

	mov	ah, 80h 	; AH = 80h (bit mask)
	mov	cl, xc
	and	cl, 7		; CL = xc MOD 8
	shr	ah, cl

	mov	LMask, ah
	mov	RMask, ah

	add	si, bx		; SI = offset of (0,b)
	mov	ULAddr, si
	mov	URAddr, si
	sub	bx, di		; BX = offset of (0,-b)
	mov	LLAddr, bx
	mov	LRAddr, bx

; initial decision variables
	xor	ax, ax
	mov	_dx, ax
	mov	_dx+2, ax	; dx = 0

	mov	ax, TwoAsquared
	mov	dx, TwoAsquared+2
	mov	cx, b
	call	LongMultiply	; perform 32-bit by 16-bit mulitply
	mov	_dy, ax
	mov	_dy+2, dx	; dy = TwoAsquared * b

	mov	ax, Asquared
	mov	dx, Asquared+2	; DX:AX = Asquared
	sar	dx, 1
	rcr	ax, 1
	sar	dx, 1
	rcr	ax, 1		; DX:AX = Asquared/4

	add	ax, Bsquared
	adc	dx, Bsquared+2	; DX:AX = Bsquared + Asquared/4
	mov	_d, ax
	mov	_d+2, dx

	mov	ax, Asquared
	mov	dx, Asquared+2
	mov	cx, b
	call	LongMultiply	; DX:AX = Asquared*b
	sub	_d, ax
	sbb	_d+2, dx	; d = Bsquared - Asquared*b + Asquared/4

; loop until dy/dx >= -1
	mov	bx, b		; BX = initial y-coordinate

	xor	cx, cx		; CH = 0 (initial y-increment)
				; CL = 0 (initial x-increment)
L010:	mov	ax, _dx
	mov	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2
	jns	L020		; jump if dx>=dy

	call	Set4Pixels10

	mov	cx, 1		; CH = 0 (y-increment)
				; CL = 1 (x-increment)
	cmp	_d+2, 0
	js	L011		; jump if d < 0

	mov	ch, 1		; increment in y direction
	dec	bx		; decrement current y-coordinate

	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy = dy - TwoAsquared

	sub	_d, ax
	sbb	_d+2, dx	    ; d = d - dy

L011:	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx = dx + TwoBsquared

	add	ax, Bsquared
	adc	dx, Bsquared+2	    ; DX:AX = dx + Bsquared
	add	_d, ax
	adc	_d+2, dx	    ; d = d + dx + Bsquared

	jmp	L010

			    ; plot pixels from current (x,y) until y < 0

; update decision variables
L020:	push	bx		; preserve current y-coordinate
	push	cx		; preserve x- and y-increments

	mov	ax, Asquared
	mov	dx, Asquared+2
	sub	ax, Bsquared
	sbb	dx, Bsquared+2	; DX:AX = Asquared-Bsquared

	mov	bx, ax
	mov	cx, dx	    ; CX:BX = (Asquared-Bsquared)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX = (Asquared-Bsquared)/2
	add	ax, bx
	adc	dx, cx	    ; DX:AX = 3*(Asquared-Bsquared)/2

	sub	ax, _dx
	sbb	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2   ; DX:AX = 3*(Asquared-Bsquared)/2 - (dx+dy)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX =
			    ;  (3*(Asquared-Bsquared)/2 - (dx+dy))/2
	add	_d, ax
	adc	_d+2, dx    ; update d

; loop until y < 0
	pop	cx		; CH,CL = y- and x-increments
	pop	bx		; BX = y

L021:	call	Set4Pixels10

	mov	cx, 100h	; CH = 1 (y-increment)
				; CL = 0 (x-increment)
	cmp	_d+2, 0
	jns	L022		; jump if d >= 0

	mov	cl, 1		; increment in x direction

	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx = dx + TwoBsquared

	add	_d, ax
	adc	_d+2, dx	    ; d = d + dx

L022:	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy = dy - TwoAsquared

	sub	ax, Asquared
	sbb	dx, Asquared+2	    ; DX:AX = dy - Asquared
	sub	_d, ax
	sbb	_d+2, dx	    ; d = d + Asquared - dy

	dec	bx		    ; decrement y
	jns	L021		    ; loop if y >= 0

; restore the default Graphics Controller state
	mov	dx, 3CEh
	xor	ax, ax		; AH = 0, AL = 0
	out	dx, ax		; Set/Reset

	inc	ax		; AH = 0, AL = 1
	out	dx, ax		; Enable Set/Reset

	mov	al, 3		; AH = 0, AL = 3
	out	dx, ax		; Data Rotate/Func Select

	mov	al, 5		; AH = 0, AL = 5
	out	dx, ax		; Mode

; restore registers and return
	pop	di
	pop	si
	leave			; 4*sizeof(USHORT) + sizeof(UCHAR)
	ret	10

ELLIPSE10	ENDP

; Set4Pixels10
;
; Caller:   CH = y-increment (0 or -1)
;	    CL = x-increment (0 or 1)

Set4Pixels10	PROC	NEAR

	push	ax		; preserve these regs
	push	bx

	xor	bx, bx		; BX = 0
	test	ch, ch
	jz	L030		; jump if y-increment = 0

	mov	bx, VSP.cbRow
	neg	bx		; BX = negative y-increment

; pixels at (xc-x,yc+y) and (xc-x,yc-y)
L030:	xor	si, si		; SI = 0
	mov	ah, LMask
	rol	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around
	neg	si		; SI = 0 or -1

	mov	di, si		; SI,DI = left x-increment

	add	si, ULAddr	; SI = upper left addr + horiz incr
	add	si, bx		; SI = new upper left addr
	add	di, LLAddr
	sub	di, bx		; DI = new lower left addr

	mov	LMask, ah	; update these variables
	mov	ULAddr, si
	mov	LLAddr, di

	and	es:[si], ah	; update upper left pixel
	and	es:[di], ah	; update lower left pixel

; pixels at (xc+x,yc+y) and (xc+x,yc-y)
	xor	si, si		; SI = 0
	mov	ah, RMask
	ror	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around

	mov	di, si		; SI,DI = right x-increment

	add	si, URAddr	; SI = upper right addr + horiz incr
	add	si, bx		; SI = new upper right addr
	add	di, LRAddr
	sub	di, bx		; DI = new lower right addr

	mov	RMask, ah	; update these variables
	mov	URAddr, si
	mov	LRAddr, di

	and	es:[si], ah	; update upper left pixel
	and	es:[di], ah	; update lower left pixel

	pop	bx
	pop	ax
	ret

Set4Pixels10	ENDP

; Ellipse13
;
;   void VS2API Ellipse13( USHORT xc, USHORT yc,
;				USHORT a, USHORT b, UCHAR ucPixel );

		PUBLIC	ELLIPSE13
ELLIPSE13	PROC	FAR

	enter	40, 0
	push	si
	push	di

; set up the Graphics Controller
	mov	dx, 3CEh	; DX = Graphics Controller I/O addr
	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select reg
	out	dx, ax

; initial constants
	mov	ax, a
	mul	ax
	mov	Asquared, ax
	mov	Asquared+2, dx	    ; a^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoAsquared, ax
	mov	TwoAsquared+2, dx   ; 2*a^2

	mov	ax, b
	mul	ax
	mov	Bsquared, ax
	mov	Bsquared+2, dx	    ; b^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoBsquared, ax
	mov	TwoBsquared+2, dx   ; 2*b^2

			    ; plot pixels from (0,b) until dy/dx = -1

; initial buffer address
	mov	ax, b
	mul	VSP.cbRow	; AX = relative byte offset of b
	mov	si, ax
	mov	di, ax

	push	xc
	push	yc
	call	PixelAddr13	; DX:AX -> (xc,yc)
	mov	es, dx

	add	si, ax		; SI = offset of (0,b)
	mov	ULAddr, si
	mov	URAddr, si
	sub	ax, di		; AX = offset of (0,-b)
	mov	LLAddr, ax
	mov	LRAddr, ax

; initial decision variables
	xor	ax, ax
	mov	_dx, ax
	mov	_dx+2, ax	; dx = 0

	mov	ax, TwoAsquared
	mov	dx, TwoAsquared+2
	mov	cx, b
	call	LongMultiply	; perform 32-bit by 16-bit mulitply
	mov	_dy, ax
	mov	_dy+2, dx	; dy = TwoAsquared * b

	mov	ax, Asquared
	mov	dx, Asquared+2	; DX:AX = Asquared
	sar	dx, 1
	rcr	ax, 1
	sar	dx, 1
	rcr	ax, 1		; DX:AX = Asquared/4

	add	ax, Bsquared
	adc	dx, Bsquared+2	; DX:AX = Bsquared + Asquared/4
	mov	_d, ax
	mov	_d+2, dx

	mov	ax, Asquared
	mov	dx, Asquared+2
	mov	cx, b
	call	LongMultiply	; DX:AX = Asquared*b
	sub	_d, ax
	sbb	_d+2, dx	; d = Bsquared - Asquared*b + Asquared/4

; loop until dy/dx >= -1
	mov	bx, b		; BX = initial y-coordinate

	xor	cx, cx		; CH = 0 (initial y-increment)
				; CL = 0 (initial x-increment)
L110:	mov	ax, _dx
	mov	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2
	jns	L120		; jump if dx>=dy

	call	Set4Pixels13

	mov	cx, 1		; CH = 0 (y-increment)
				; CL = 1 (x-increment)
	cmp	_d+2, 0
	js	L111		; jump if d < 0

	mov	ch, 1		; increment in y direction
	dec	bx		; decrement current y-coordinate

	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy = dy - TwoAsquared

	sub	_d, ax
	sbb	_d+2, dx	    ; d = d - dy

L111:	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx = dx + TwoBsquared

	add	ax, Bsquared
	adc	dx, Bsquared+2	    ; DX:AX = dx + Bsquared
	add	_d, ax
	adc	_d+2, dx	    ; d = d + dx + Bsquared

	jmp	L110

			    ; plot pixels from current (x,y) until y < 0

; update decision variables
L120:	push	bx		; preserve current y-coordinate
	push	cx		; preserve x- and y-increments

	mov	ax, Asquared
	mov	dx, Asquared+2
	sub	ax, Bsquared
	sbb	dx, Bsquared+2	; DX:AX = Asquared-Bsquared

	mov	bx, ax
	mov	cx, dx	    ; CX:BX = (Asquared-Bsquared)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX = (Asquared-Bsquared)/2
	add	ax, bx
	adc	dx, cx	    ; DX:AX = 3*(Asquared-Bsquared)/2

	sub	ax, _dx
	sbb	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2   ; DX:AX = 3*(Asquared-Bsquared)/2 - (dx+dy)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX =
			    ;  (3*(Asquared-Bsquared)/2 - (dx+dy))/2
	add	_d, ax
	adc	_d+2, dx    ; update d

; loop until y < 0
	pop	cx		; CH,CL = y- and x-increments
	pop	bx		; BX = y

L121:	call	Set4Pixels13

	mov	cx, 100h	; CH = 1 (y-increment)
				; CL = 0 (x-increment)
	cmp	_d+2, 0
	jns	L122		; jump if d >= 0

	mov	cl, 1		; increment in x direction

	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx = dx + TwoBsquared

	add	_d, ax
	adc	_d+2, dx	    ; d = d + dx

L122:	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy = dy - TwoAsquared

	sub	ax, Asquared
	sbb	dx, Asquared+2	    ; DX:AX = dy - Asquared
	sub	_d, ax
	sbb	_d+2, dx	    ; d = d + Asquared - dy

	dec	bx		    ; decrement y
	jns	L121		    ; loop if y >= 0

; restore the default Graphics Controller state
	mov	dx, 3CEh
	mov	ax, 3		; AH = 0, AL = 3
	out	dx, ax		; Data Rotate/Func Select

; restore registers and return
	pop	di
	pop	si
	leave			; 4*sizeof(USHORT) + sizeof(UCHAR)
	ret	10

ELLIPSE13	ENDP

; Set4Pixels13
;
; Caller:   CH = y-increment (0 or -1)
;	    CL = x-increment (0 or 1)

Set4Pixels13	PROC	NEAR

	push	ax		; preserve these regs
	push	bx

	mov	ah, ucPixel	; AH = pixel value

	xor	bx, bx		; BX = 0
	test	ch, ch
	jz	L130		; jump if y-increment = 0

	mov	bx, VSP.cbRow
	neg	bx		; BX = negative y-increment

L130:	mov	al, 8		; AL = Bit Mask reg number

; pixels at (xc-x,yc+y) and (xc-x,yc-y)
	xor	ch, ch		; CX = x-increment (0 or 1)
	mov	si, cx
	neg	si		; SI = 0 or -1
	mov	di, si		; SI,DI = left x-increment

	add	si, ULAddr	; SI = upper left addr + horiz incr
	add	si, bx		; SI = new upper left addr
	add	di, LLAddr
	sub	di, bx		; DI = new lower left addr

	mov	ULAddr, si
	mov	LLAddr, di

	mov	al, ah
	xchg	es:[si], al	; update upper left pixel
	mov	al, ah
	xchg	es:[di], al	; update lower left pixel

; pixels at (xc+x,yc+y) and (xc+x,yc-y)
	mov	si, cx		; SI = x-increment (0 or 1)
	mov	di, si		; SI,DI = right x-increment

	add	si, URAddr	; SI = upper right addr + horiz incr
	add	si, bx		; SI = new upper right addr
	add	di, LRAddr
	sub	di, bx		; DI = new lower right addr

	mov	URAddr, si
	mov	LRAddr, di

	mov	al, ah
	xchg	es:[si], al    ; update upper left pixel
	xchg	es:[di], ah	; update lower left pixel

	pop	bx
	pop	ax
	ret

Set4Pixels13	ENDP

; Ellipse256
;
;   void VS2API Ellipse256( USHORT xc, USHORT yc,
;				USHORT a, USHORT b, UCHAR ucPixel );

		PUBLIC	ELLIPSE256
ELLIPSE256	PROC	FAR

	enter	40, 0
	push	si
	push	di

; set up the Graphics Controller
	mov	dx, 3CEh	; DX = Graphics Controller I/O addr
	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select reg
	out	dx, ax

; initial constants
	mov	ax, a
	mul	ax
	mov	Asquared, ax
	mov	Asquared+2, dx	    ; a^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoAsquared, ax
	mov	TwoAsquared+2, dx   ; 2*a^2

	mov	ax, b
	mul	ax
	mov	Bsquared, ax
	mov	Bsquared+2, dx	    ; b^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoBsquared, ax
	mov	TwoBsquared+2, dx   ; 2*b^2

			    ; plot pixels from (0,b) until dy/dx = -1

; initial buffer address and bit mask
	mov	ax, b
	mul	VSP.cbRow	; AX = relative byte offset of b
	mov	si, ax
	mov	di, ax

	push	xc
	push	yc
	call	PixelAddr256
	mov	bx, ax
	mov	es, dx		; ES:BX -> buffer

; create a mask for the Sequencer Map Mask register
	mov	ah, 11h 	; AH = 11h (map mask)
	mov	cl, xc
	and	cl, 3		; CL = xc MOD 4
	shl	ah, cl		; AH = initial map mask

	mov	LMask, ah
	mov	RMask, ah

	add	si, bx		; SI = offset of (0,b)
	mov	ULAddr, si
	mov	URAddr, si
	sub	bx, di		; BX = offset of (0,-b)
	mov	LLAddr, bx
	mov	LRAddr, bx

; initial decision variables
	xor	ax, ax
	mov	_dx, ax
	mov	_dx+2, ax	; dx = 0

	mov	ax, TwoAsquared
	mov	dx, TwoAsquared+2
	mov	cx, b
	call	LongMultiply	; perform 32-bit by 16-bit mulitply
	mov	_dy, ax
	mov	_dy+2, dx	; dy = TwoAsquared * b

	mov	ax, Asquared
	mov	dx, Asquared+2	; DX:AX = Asquared
	sar	dx, 1
	rcr	ax, 1
	sar	dx, 1
	rcr	ax, 1		; DX:AX = Asquared/4

	add	ax, Bsquared
	adc	dx, Bsquared+2	; DX:AX = Bsquared + Asquared/4
	mov	_d, ax
	mov	_d+2, dx

	mov	ax, Asquared
	mov	dx, Asquared+2
	mov	cx, b
	call	LongMultiply	; DX:AX = Asquared*b
	sub	_d, ax
	sbb	_d+2, dx	; d = Bsquared - Asquared*b + Asquared/4

; loop until dy/dx >= -1
	mov	bx, b		; BX = initial y-coordinate

	xor	cx, cx		; CH = 0 (initial y-increment)
				; CL = 0 (initial x-increment)
L210:	mov	ax, _dx
	mov	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2
	jns	L220		; jump if dx>=dy

	call	Set4Pixels256

	mov	cx, 1		; CH = 0 (y-increment)
				; CL = 1 (x-increment)
	cmp	_d+2, 0
	js	L211		; jump if d < 0

	mov	ch, 1		; increment in y direction
	dec	bx		; decrement current y-coordinate

	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy = dy - TwoAsquared

	sub	_d, ax
	sbb	_d+2, dx	    ; d = d - dy

L211:	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx = dx + TwoBsquared

	add	ax, Bsquared
	adc	dx, Bsquared+2	    ; DX:AX = dx + Bsquared
	add	_d, ax
	adc	_d+2, dx	    ; d = d + dx + Bsquared

	jmp	L210

			    ; plot pixels from current (x,y) until y < 0

; update decision variables
L220:	push	bx		; preserve current y-coordinate
	push	cx		; preserve x- and y-increments

	mov	ax, Asquared
	mov	dx, Asquared+2
	sub	ax, Bsquared
	sbb	dx, Bsquared+2	; DX:AX = Asquared-Bsquared

	mov	bx, ax
	mov	cx, dx	    ; CX:BX = (Asquared-Bsquared)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX = (Asquared-Bsquared)/2
	add	ax, bx
	adc	dx, cx	    ; DX:AX = 3*(Asquared-Bsquared)/2

	sub	ax, _dx
	sbb	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2   ; DX:AX = 3*(Asquared-Bsquared)/2 - (dx+dy)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX =
			    ;  (3*(Asquared-Bsquared)/2 - (dx+dy))/2
	add	_d, ax
	adc	_d+2, dx    ; update d

; loop until y < 0
	pop	cx		; CH,CL = y- and x-increments
	pop	bx		; BX = y

L221:	call	Set4Pixels256

	mov	cx, 100h	; CH = 1 (y-increment)
				; CL = 0 (x-increment)
	cmp	_d+2, 0
	jns	L222		; jump if d >= 0

	mov	cl, 1		; increment in x direction

	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx = dx + TwoBsquared

	add	_d, ax
	adc	_d+2, dx	    ; d = d + dx

L222:	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy = dy - TwoAsquared

	sub	ax, Asquared
	sbb	dx, Asquared+2	    ; DX:AX = dy - Asquared
	sub	_d, ax
	sbb	_d+2, dx	    ; d = d + Asquared - dy

	dec	bx		    ; decrement y
	jns	L221		    ; loop if y >= 0

; restore the default Sequencer and Graphics Controller states
	mov	dx, 3C4h
	mov	ax, 0F02h	; AH = 0, AL = 2
	out	dx, ax		; Map Mask

	mov	dl, 0CEh	; DX = 3CEh
	mov	ax, 3
	out	dx, ax		; Data Rotate/Function Select

; restore registers and return
	pop	di
	pop	si
	leave			; 4*sizeof(USHORT) + sizeof(UCHAR)
	ret	10

ELLIPSE256	ENDP

; Set4Pixels256
;
; Caller:   CH = y-increment (0 or -1)
;	    CL = x-increment (0 or 1)

Set4Pixels256	PROC	NEAR

	push	ax		; preserve these regs
	push	bx
	push	dx

	mov	dx, 3C4h	; Sequencer I/O addr
	mov	al, 2		; Map Mask reg number

	xor	bx, bx		; BX = 0
	test	ch, ch
	jz	L230		; jump if y-increment = 0

	mov	bx, VSP.cbRow
	neg	bx		; BX = negative y-increment

; pixels at (xc-x,yc+y) and (xc-x,yc-y)
L230:	xor	si, si		; SI = 0
	mov	ch, ucPixel	; CH = pixel value
	mov	ah, LMask
	ror	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around
	neg	si		; SI = 0 or -1

	mov	di, si		; SI,DI = left x-increment

	add	si, ULAddr	; SI = upper left addr + horiz incr
	add	si, bx		; SI = new upper left addr
	add	di, LLAddr
	sub	di, bx		; DI = new lower left addr

	mov	LMask, ah	; update these variables
	mov	ULAddr, si
	mov	LLAddr, di

	and	ah, 0Fh
	out	dx, ax		; select bit plane for current pixels
	mov	ah, ch		; AH = pixel value
	xchg	es:[si], ah	; update upper left pixel
	mov	ah, ch
	xchg	es:[di], ah	; update lower left pixel

; pixels at (xc+x,yc+y) and (xc+x,yc-y)
	xor	si, si		; SI = 0
	mov	ah, RMask
	rol	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around

	mov	di, si		; SI,DI = right x-increment

	add	si, URAddr	; SI = upper right addr + horiz incr
	add	si, bx		; SI = new upper right addr
	add	di, LRAddr
	sub	di, bx		; DI = new lower right addr

	mov	RMask, ah	; update these variables
	mov	URAddr, si
	mov	LRAddr, di

	and	ah, 0Fh
	out	dx, ax		; select bit plane for current pixels
	mov	ah, ch		; AH = pixel value
	xchg	es:[si], ah	; update upper left pixel
	xchg	es:[di], ch	; update lower left pixel

	pop	dx
	pop	bx
	pop	ax
	ret

Set4Pixels256	ENDP

; LongMultiply
;
; Caller:	DX:AX = L (32-bit integer)
;		CX =	S (16-bit integer)
; Returns:	DX:AX = L*S (32-bit product)

LongMultiply	PROC	NEAR

	push	ax	    ; preserve LOWORD(L)
	mov	ax, dx	    ; AX = HIWORD(L)
	mul	cx	    ; AX = HIWORD(L)*S
	xchg	ax, cx	    ; AX = S; CX=HIWORD(L)*S
	pop	dx	    ; DX = LOWORD(L)
	mul	dx	    ; AX = LOWORD(L)*S
			    ; DX = carry
	add	dx, cx	    ; DX = HIWORD(L)*S + carry
	ret

LongMultiply	ENDP


VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
