/***********************************************************************

  FILL1.C

***********************************************************************/

#include    <stdio.h>	    /* printf sscanf */
#include    <conio.h>	    /* _getch */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

void	      main( int, char * * );

void VS2API   DoPixelFill( USHORT, USHORT, UCHAR, UCHAR );
void VS2API   PixelFill( USHORT, USHORT );
void VS2API   DoLAFill( USHORT, USHORT, UCHAR, UCHAR );
USHORT VS2API LineAdjFill( short, short, short, short, short );
USHORT VS2API ScanLeft( USHORT, USHORT );
USHORT VS2API ScanRight( USHORT, USHORT );

/* defined in PATTERNS.C */
typedef void (VS2API *	FILLPROC)( USHORT, USHORT, UCHAR, UCHAR );
void	    Test1( FILLPROC );
void	    Test2( FILLPROC );
void	    Test3( FILLPROC );
void	    Test4( FILLPROC );
void	    Test5( FILLPROC );
void	    Test6( FILLPROC );
void	    Test7( FILLPROC );
void	    Test8( FILLPROC );
void	    AuxPrintf( char *, ... );
void	    InitVMode( USHORT );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;

/* defined in PATTERNS.C */
extern UCHAR (VS2API * fnGetPixel)( USHORT, USHORT );
extern void (VS2API *  fnSetPixel)( USHORT, USHORT, UCHAR );
extern void (VS2API *  fnLine)( USHORT, USHORT, USHORT, USHORT, UCHAR );

UCHAR	 ucBorder, ucFill;	/* used in LineAdjFill */

#ifdef STACKTEST
static int nDepth;
static int nMaxDepth;
static USHORT	usSPMin, usSPMax;
#endif


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * argv[] )
{
    USHORT  usMode;
    FILLPROC	fnFill = DoLAFill;


    if( argc != 2 )
    {
      printf( "Syntax: FILL1 <mode #>\n" );
      return;
    }

    /* select the specified video mode */
    sscanf( argv[1], "%x", &usMode );
    InitVMode( usMode );

    /* select the specified video mode */
    sscanf( argv[1], "%x", &usMode );
    InitVMode( usMode );

    Test1( fnFill );
    _getch();
    InitVMode( usMode );

    Test2( fnFill );
    _getch();
    InitVMode( usMode );

    Test3( fnFill );
    _getch();
    InitVMode( usMode );

    Test4( fnFill );
    _getch();
    InitVMode( usMode );

    Test5( fnFill );
    _getch();
    InitVMode( usMode );

    Test6( fnFill );
    _getch();
    InitVMode( usMode );

    Test7( fnFill );
    _getch();
    InitVMode( usMode );

    Test8( fnFill );
    _getch();
    SetVMode( 3 );	    /* restore 80x25 text mode */
}


/***********************************************************************

  DoPixelFill

***********************************************************************/

void VS2API
DoPixelFill( USHORT x, USHORT y, UCHAR ucPixelB, UCHAR ucPixelF )
{
    ucBorder = ucPixelB;
    ucFill = ucPixelF;
    PixelFill( x, y );
}


/***********************************************************************

  PixelFill

  Notes:
    This function does not validate x or y.  It also won't fill a
    region of any appreciable size without overflowing the stack.

***********************************************************************/

void VS2API PixelFill( USHORT x, USHORT y )
{
    static UCHAR    v;

#ifdef STACKTEST
    nDepth++ ;
    printf( "(%3u, %3u): %4d\r", x, y, nDepth );
#endif

    v = (*fnGetPixel)( x, y );

    if( (v != ucBorder) && (v != ucFill) )
    {
      (*fnSetPixel)( x, y, ucFill );

      PixelFill( x-1, y );
      PixelFill( x+1, y );
      PixelFill( x, y-1 );
      PixelFill( x, y+1 );
    }

#ifdef STACKTEST
    nDepth-- ;
#endif
}


/***********************************************************************

  DoLAFill

***********************************************************************/

void VS2API
DoLAFill( USHORT x0, USHORT y0, UCHAR ucPixelB, UCHAR ucPixelF )
{
#ifdef STACKTEST
    nDepth = 0;
    nMaxDepth = 0;
    usSPMin = 0;
    usSPMax = 0;
#endif

    /* do nothing if the seed pixel is a border pixel */
    if( (*fnGetPixel)( x0, y0 ) == ucPixelB )
      return;

    /* save the border and fill values in global variables */
    ucBorder = ucPixelB;
    ucFill = ucPixelF;

    LineAdjFill( x0, y0, 1, x0, x0 );

#ifdef STACKTEST
    printf( "Maximum recursion depth %d\n", nMaxDepth-1 );
    printf( "Stack space required: %u bytes\n", usSPMax-usSPMin );
#endif
}


/***********************************************************************

  LineAdjFill

***********************************************************************/

USHORT VS2API LineAdjFill( short SeedX, short SeedY,
			    short D, short PrevXL, short PrevXR )
{
    short   x, y, xl, xr;
    UCHAR   v;

#ifdef STACKTEST
    /* save the maximum value of SP */
    if( 0 == nDepth )
    {
      __asm
      {
	mov	usSPMax, SP
      }
    }

    nDepth++ ;
    printf( "(%3u, %3u): %4d\r", SeedX, SeedY, nDepth );

    if( nDepth > nMaxDepth )
    {
      nMaxDepth = nDepth;	/* save the maximum depth of recursion */
      __asm
      {
	mov	usSPMin, SP	/* save the minimum value of SP */
      }
    }
#endif

    /* clip y */
    if( (SeedY < 0) || (SeedY == (short)vsp.usSY) )
      return vsp.usCX;		/* return a maximally-large value */

    y = SeedY;
    xl = SeedX;
    xr = SeedX;

    /* find the endpoints of the current run */
    xl = ScanLeft( xl, y );
    xr = ScanRight( xr, y );

    /* fill the current run */
    (*fnLine)( xl, y, xr, y, ucFill );

    /* find and fill adjacent runs in the same direction */
    for( x=xl; x<=xr; x++ )
    {
      /* inspect the adjacent row of pixels */
      {
	v = (*fnGetPixel)( x, y+D );
	if( (v != ucBorder) && (v != ucFill) )
	  x = LineAdjFill( x, y+D, D, xl, xr );
      }
    }

    /* find and fill adjacent runs in the opposite direction */
    for( x=xl; x<PrevXL; x++ )
    {
      v = (*fnGetPixel)( x, y-D );
      if( (v != ucBorder) && (v != ucFill) )
	x = LineAdjFill( x, y-D, -D, xl, xr );
    }

    for( x=PrevXR; x<=xr; x++ )
    {
      v = (*fnGetPixel)( x, y-D );

      if( (v != ucBorder) && (v != ucFill) )
	x = LineAdjFill( x, y-D, -D, xl, xr );
    }

#ifdef STACKTEST
    --nDepth;
#endif

    return xr;
}


/***********************************************************************

  ScanLeft

***********************************************************************/

USHORT VS2API ScanLeft( USHORT xl, USHORT y )
{
    UCHAR   v;


    do
    {
      --xl;

      /* clip */
      if( xl == -1 )
	break;
      v = (*fnGetPixel)( xl, y );
    }
    while( (v != ucBorder) && (v != ucFill) );

    return ++xl;
}


/***********************************************************************

  ScanRight

***********************************************************************/

USHORT VS2API ScanRight( USHORT xr, USHORT y )
{
    UCHAR   v;


    do
    {
      ++xr;

      /* clip */
      if( xr == vsp.usCX )
	break;
      v = (*fnGetPixel)( xr, y );
    }
    while( (v != ucBorder) && (v != ucFill) );

    return --xr;
}
