		TITLE	CGENRAM.ASM
		NAME	CGENRAM
		PAGE	55,132

.286

INCLUDE 	vs2.inc

; defined for MS Windows 3.x ...
BITMAPINFOHEADER	STRUCT
biSize			DWORD	?
biWidth 		DWORD	?
biHeight		DWORD	?
biPlanes		WORD	?
biBitCount		WORD	?
biCompression		DWORD	?
biSizeImage		DWORD	?
biXPelsPerMeter 	DWORD	?
biYPelsPerMeter 	DWORD	?
biClrUsed		DWORD	?
biClrImportant		DWORD	?
BITMAPINFOHEADER	ENDS
; end of Windows 3.x definitions

; parameter for ExposeCGenRAM and HideCGenRAM
lpSave		EQU	[bp+6]

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	BUFCOPY:FAR
		EXTRN	VRWAIT:FAR

; ExposeCGenRAM
;
;   void VS2API ExposeCGenRAM( LPVOID lpSave );
;
; Notes:
;   Caller provides a 16-byte save area.

		PUBLIC	EXPOSECGENRAM
EXPOSECGENRAM	PROC	FAR

	enter	0, 0
	push	si
	push	di

	les	di, lpSave	; ES:DI -> save area
	mov	si, es
	or	si, si
	jz	L009		; do nothing if null pointer

	call	VRWAIT		; wait for vertical retrace interval

; save value for Sequencer synchronous reset
	cld
	mov	ax, 100h
	stosw

; save current Sequencer registers 4, 2, and 0
	mov	dx, 3C4h	; Sequencer I/O address
	mov	ah, 4

L000:	mov	al, ah		; AL = register number
	out	dx, al
	inc	dx		; DX = 3C5h
	in	al, dx		; AL = current register value
	xchg	ah, al		; AH = register value
				; AL = register number
	stosw			; save the register value and number
	mov	ah, al		; AH = register number
	dec	dx		; DX = 3C4h
	sub	ah, 2		; AH = next register number
	jns	L000		; loop for AH = 4, 2, and 0

; program the Sequencer for sequential addressing in map 2 only
	lea	si, [di-6]	; ES:SI -> current value for reg 4
	lodsw	es:[si] 	; AH = value for register 4
	and	ah, 0F7h	; bit 3 = 0
	or	ah, 4		; bit 2 = 1
	out	dx, ax

	lodsw	es:[si] 	; AH = value for register 2
	mov	ah, 4		; AH = bit mask for map 2
	out	dx, ax

; save current Graphics Controller registers
	mov	dl, 0CEh	; DX = 3CEh
	mov	ah, 6

L001:	mov	al, ah		; AL = register number
	out	dx, al
	inc	dx		; DX = 3CFh
	in	al, dx		; AL = current register value
	xchg	ah, al		; AH = register value
				; AL = register number
	stosw			; save the register value and number
	mov	ah, al		; AH = register number
	dec	dx		; DX = 3CEh
	dec	ah		; AH = next register number
	cmp	ah, 4		; loop for AH = 6, 5, and 4
	jae	L001

; program the Graphics Controller
	lea	si, [di-6]	; ES:SI -> value for GC reg 6
	lodsw	es:[si] 	; AH = reg 6 (Miscellaneous) value
	and	ah, 0F1h	; zero bits 3, 2, and 1
	out	dx, ax		; linear addressing at A000:0000

	lodsw	es:[si] 	; AH = reg 5 (Graphics Mode) value
	and	ah, 0EFh	; bit 4 = 0
	out	dx, ax		; disable CGA odd/even addressing

	lodsw	es:[si] 	; AH = reg 4 (Read Map Select) value
	mov	ah, 2		; AH = map 2
	out	dx, ax

L009:	pop	di
	pop	si
	leave
	ret	4		; sizeof(LPVOID)

EXPOSECGENRAM	ENDP

; HideCGenRAM
;
;   void VS2API HideCGenRAM( LPVOID lpSave );

		PUBLIC	HIDECGENRAM
HIDECGENRAM	PROC	FAR

	enter	0, 0
	push	ds
	push	si

	lds	si, lpSave	; DS:SI -> save area
	mov	ax, ds
	or	ax, ax
	jz	L109		; do nothing if null pointer

	call	VRWAIT		; wait for vertical retrace interval

; restore previous Sequencer registers
	cld
	mov	cx, 4
	mov	dx, 3C4h	; Sequencer I/O addr
	rep outsw

; restore previous Graphics Controller registers
	mov	cx, 3
	mov	dl, 0CEh	; DX = 3CEh
	rep outsw

L109:	pop	si
	pop	ds
	leave
	ret	4		; sizeof(LPVOID)

HIDECGENRAM	ENDP

; BltToCGenRAM
;
;   USHORT VS2API BltToCGenRAM( USHORT x, USHORT y, LPVOID pBMP,
;				    UCHAR attrib, USHORT glyph0 );
;
; Notes:
;   The specified glyph (0-FFh) identifies the first one to be used
;   to store the bitmap.
;
;   Returns the number of glyphs currently used for bitmap data, or
;   0FFFFh if too few free glyphs are available to store the bitmap.
;
;   The x and y values are character coordinates (not pixels).

; parameters
glyph0		EQU	WORD PTR [bp+6]
attrib		EQU	BYTE PTR [bp+8]
pBMP		EQU	DWORD PTR [bp+10]
y		EQU	WORD PTR [bp+14]
x		EQU	WORD PTR [bp+16]

; temporary variables
h		EQU	WORD PTR [bp-2]
w		EQU	WORD PTR [bp-4]
hc		EQU	WORD PTR [bp-6]
wc		EQU	WORD PTR [bp-8]
p		EQU	WORD PTR [bp-10]
RowIncr 	EQU	WORD PTR [bp-12]
GyIncr		EQU	WORD PTR [bp-14]
nPad		EQU	WORD PTR [bp-16]
Dest		EQU	DWORD PTR [bp-20]
RVal		EQU	WORD PTR [bp-22]

		PUBLIC	BLTTOCGENRAM
BLTTOCGENRAM	PROC	FAR

	enter	22, 0
	push	ds
	push	si
	push	di
	cld

; get the displayed character height from the ROM BIOS data area
	push	segVDDA
	pop	es
	mov	ax, es:[POINTS]
	mov	p, ax

; compute the address of the first character
	mov	al, es:[CRT_COLS]
	mul	BYTE PTR y	    ; character offset of start of row
	shl	ax, 1		    ; byte offset of 1st char in row
	mov	di, x
	add	di, di		    ; byte offset of xth char in row
	add	di, ax
	add	di, VSP.ofsVBuf     ; video-buffer offset of char
	mov	WORD PTR Dest, di
	mov	di, VSP.segVBuf
	mov	WORD PTR Dest+2, di ; Dest -> 1st character

; save the number of bytes per video-buffer row
	mov	ax, es:[CRT_COLS]
	shl	ax, 1
	mov	RowIncr, ax

; verify that it's a monochrome bitmap
	lds	si, pBMP
	cmp	(BITMAPINFOHEADER PTR [si]).biPlanes, 1
	je	L200
	jmp	L290

; compute the bitmap dimensions
L200:	mov	ax, WORD PTR (BITMAPINFOHEADER PTR [si]).biWidth
	mov	w, ax
	add	ax, 7
	shr	ax, 3	    ; AX = (w+7)/8 = character width
	mov	wc, ax

	mov	ax, WORD PTR (BITMAPINFOHEADER PTR [si]).biHeight
	mov	h, ax
	add	ax, p
	dec	ax
	xor	dx, dx	    ; DX:AX = (h+p-1)
	div	p	    ; AX = (h+p-1)/p = character height
	mov	hc, ax

; verify that the glyph table size is not exceeded
	mul	wc	    ; AX = hc*wc = # of glyphs used
	add	ax, glyph0  ; AX = character past end of bitmap
	cmp	ax, 256
	jbe	L202

	mov	RVal, 0FFFFh
	jmp	L290

; save the return value
L202:	mov	RVal, ax

; verify the number of entries in the color table
L204:	mov	cx, WORD PTR (BITMAPINFOHEADER PTR [si]).biClrUsed
	or	cx, cx
	jnz	L205

	mov	cx, 2	    ; assume 2 color-table entries

; point past the BITMAPINFOHEADER and color table
L205:	add	si, sizeof BITMAPINFOHEADER
	shl	cx, 2	    ; CX = size of color table
	add	si, cx	    ; DS:SI -> bitmap data

; compute the number of bytes of padding in each bitmap row
	mov	ax, w
	dec	ax
	shr	ax, 3	    ; AX = (w-1)/8
	not	ax
	and	ax, 3	    ; AX = 3-((w-1)/8 MOD 4)
	mov	nPad, ax

; null out the glyph table
	push	seg DGROUP
	push	offset SaveArea
	call	EXPOSECGENRAM	; A000:2000 -> 2nd table

	push	0A000h
	pop	es
	mov	di, glyph0
	shl	di, 5		; DI = offset of glyph0 bits
	mov	cx, 256*32	; # of bytes in glyph table

	sub	cx, di		; CX = # of bytes to update
	shr	cx, 1		; CX = # of words to update

	add	di, 2000h	; ES:DI -> 2nd table
	xor	ax, ax
	rep stosw

; point to the last row of the destination
	mov	di, glyph0
	shl	di, 5		; DI = offset of glyph0 bits
	add	di, 2000h	; ES:DI -> first glyph

	mov	ax, hc
	dec	ax
	mul	wc	    ; AX = wc*(hc-1)
	shl	ax, 5	    ; AX = 32*wc*(hc-1)
			    ;	 = glyph for 1st char in last row
	add	di, ax

	mov	ax, h
	dec	ax
	div	p	    ; DX = (h-1) MOD p
	add	di, dx	    ; ES:DI -> 1st byte of glyph bits

; compute the end-of-bit-row increment
	mov	bx, wc
	shl	bx, 5	    ; BX = wc*32
	inc	bx	    ; BX = (wc*32)+1 = increment

; compute the end-of-glyph-row increment
	mov	cx, wc
	shl	cx, 5	    ; CX = 32*wc
	sub	cx, p	    ; CX = (32*wc)-p
	mov	GyIncr, cx  ;	 = increment

; copy each row of glyph bits into the character-generator glyph table
L210:	mov	dx, p	    ; DX = # of rows of bits in each glyph

L212:	mov	cx, wc

L214:	lodsb		    ; AL = 8 bits from the bitmap
	mov	es:[di], al ; store the bits in the current glyph
	add	di, 32	    ; ES:DI -> next glyph
	loop	L214

; skip end-of-row padding in the bitmap
	add	si, nPad

; point to the previous row of glyph bits
	sub	di, bx
	dec	dx
	jz	L215	    ; jump if decremented beyond top of char

	dec	h
	jnz	L212
	jmp	L220

; come here to back up to previous row of glyphs
L215:	sub	di, GyIncr

	dec	h
	jnz	L210
	jmp	L220

; restore normal video-buffer addressing
L220:	push	seg DGROUP
	push	offset SaveArea
	call	HIDECGENRAM

; use 9-bit character codes to access the first two glyph tables
	cli		    ; block interrupts
	mov	dx, 3C4h    ; Sequencer I/O addr
	mov	ax, 0100h
	out	dx, ax	    ; synchronous reset

	mov	ax, 2003h   ; AH = value for Char Map Select reg
	out	dx, ax	    ; (bits 5,3,2 = 100b to use 2nd glyph table)
			    ; AL = Char Map Select reg #
	mov	al, 1
	out	dx, al
	inc	dx	    ; DX = 3C5h
	in	al, dx	    ; AL = current reg 1 (Clocking Mode) value
	dec	dx	    ; DX = 3C4h
	test	al, 1
	jnz	L222	    ; jump if already using 8-wide characters

; use 8-dot wide characters
	mov	ah, al
	mov	al, 1
	or	ah, al	    ; bit 0 = 1 (8-dot characters)
	out	dx, ax

; use the slower dot clock
	mov	dl, 0CCh    ; DX = 3CCh (Misc Output reg input addr)
	in	al, dx	    ; AL = Misc Output reg value
	and	al, 0F3h    ; bits 2-3 = 00b (use 25.172 MHz dot clock)
	mov	dl, 0C2h    ; DX = 3C2h (Misc Output reg output addr)
	out	dx, al

; update the Attribute Controller Horizontal Pel Pan register
	push	segVDDA
	pop	es
	mov	dx, es:[ADDR6845]
	add	dx, 6	    ; DX = Input Status 1 I/O addr
	in	al, dx	    ; reset the Attribute Controller flip flop
	mov	dl, 0C0h    ; DX = 3C0h
	mov	al, 33h     ; bits 0-4 = 13h (Horizontal Pel Pan reg #)
			    ; bit 5 = 1 (palette address source)
	out	dx, al
	xor	al, al	    ; AL = 0 (Horizontal Pel Pan value)
	out	dx, al

L222:	mov	dl, 0C4h    ; DX = 3C4h
	mov	ax, 0300h
	out	dx, ax	    ; clear synchronous reset
	sti

; put a rectangle of characters into the video buffer
	mov	ax, glyph0  ; AL = first character value
	mov	ah, attrib  ; AH = attribute
	or	ah, 8	    ; bit 3 = 1 (extended attribute bit)

; compute the increment between destination character rows
	mov	cx, wc
	add	cx, cx	    ; CX = # of bytes per bitmap row
	mov	bx, RowIncr
	sub	bx, cx	    ; BX = increment between rows

	mov	dx, hc	    ; DX = # of character rows

	les	di, Dest    ; ES:DI -> 1st character to store

; come here at the start of each row of characters in the bitmap
L230:	mov	cx, wc

L232:	stosw		    ; store the first row of characters
	inc	ax	    ; AL = next character value
	loop	L232

	add	di, bx	    ; ES:DI -> next character row
	dec	dx
	jnz	L230	    ; loop down all rows

L290:	mov	ax, RVal    ; AX = return value

	pop	di
	pop	si
	pop	ds
	leave
	ret	12	    ; 4*sizeof(USHORT) + sizeof(LPVOID)

BLTTOCGENRAM	ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

; save area for calls to ExposeCGenRAM and HideCGenRAM
SaveArea	WORD	8 DUP(?)

_DATA		ENDS

		END
