/***********************************************************************

  CGRTEST.C

  Tests:
    ExposeCGenRAM
    HideCGenRAM

***********************************************************************/

#include    <stdio.h>	    /* printf _lseek */
#include    <string.h>	    /* _fmemcpy */
#include    <fcntl.h>	    /* _open */
#include    <sys\types.h>   /* _open */
#include    <sys\stat.h>    /* _open */
#include    <io.h>	    /* _open _lseek _read _close */
#include    <conio.h>	    /* _getch */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

void	    main( int, char * * );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * * argv )
{
    USHORT  usSize, usMode, SaveArea[8];
    LPCHAR  lpGlyph = LPVBUF;
    LPCHAR  lpVBuf = (LPCHAR)0xB8000000L;
    UCHAR   Buf[32];
    int     hFile, n;
    int     x0, y0, x, y;


    /* verify command-line syntax */
    if( argc != 2 )
    {
      printf( "Syntax: CGRTEST <filename>\n" );
      return;
    }

    /* clear the display */
    usMode = GetVMode();
    SetVMode( usMode );
    InitVSP( usMode );

    /* open a file of 256 glyphs */
    hFile = _open( argv[1], _O_BINARY | _O_RDONLY );
    if( hFile < 0 )
    {
      printf( "Unable to open file '%s'\n", argv[1] );
      return;
    }

    /* determine the size of the glyphs using the file size */
    usSize = (USHORT)(_lseek( hFile, 0L, SEEK_END ) / 256);
    printf( "Glyph size is 8 by %u", usSize );

    /* make alphanumeric character-generator RAM addressible */
    ExposeCGenRAM( SaveArea );
    _fmemset( lpGlyph, 0, 256*32 );	/* null all glyphs */

    /* read the glyphs */
    _lseek( hFile, 0L, SEEK_SET );
    for( n=0; n<256; n++ )
    {
      _read( hFile, Buf, usSize );
      _fmemcpy( lpGlyph, Buf, usSize );
      lpGlyph += 32;
    }

    /* close the file */
    _close( hFile );

    /* restore alphanumeric video mode */
    HideCGenRAM( SaveArea );

    /* draw a 32-by-16 character block */
    x0 = (vsp.usSX-32)/2;
    y0 = (vsp.usSY-8)/2;
    for( x=0; x<32; x++ )
      for( y=0; y<8; y++ )
	lpVBuf[ (y+y0)*vsp.cbRow + (x+x0)*2 ] = (UCHAR)(y*32+x);

    SetCursorXY( 0, 20 );
}
