		TITLE	CGA.ASM
		NAME	CGA
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

; parameters for all PixelAddr functions
usY		EQU	[bp+6]
usX		EQU	[bp+8]

; PixelAddr04
;
;   LPCHAR VS2API PixelAddr04( USHORT usX, USHORT usY );

		PUBLIC	PIXELADDR04
PIXELADDR04	PROC	FAR

	enter	0, 0

	mov	ax, usX 	; AX = x
	mov	cl, al		; CL = low-order byte of x
	mov	bx, usY 	; BX = y

	xchg	bh, bl
	shr	bx, 1		; BX = 80h*(y&1)
	add	ah, bl		; AX = x + 8000h*(y&1)
	xor	bl, bl		; BX = 100h*(y/2)
	add	ax, bx		; AX = x + 8000h*(y&1) + 100h*(y/2)
	shr	bx, 2		; BX = 40h*(y/2)
	add	ax, bx		; AX = x + 8000h*(y&1) + 140h*(y/2)
	shr	ax, 2		; AX = x/4 + 2000h*(y&1) + 50h*(y/2)
	add	ax, VSP.ofsVBuf ; add origin offset
	mov	dx, VSP.segVBuf ; DX:AX -> pixel

	leave
	ret	4		; 2*sizeof(USHORT)

PIXELADDR04	ENDP

; PixelAddr06
;
;   LPCHAR VS2API PixelAddr06( USHORT usX, USHORT usY );

		PUBLIC	PIXELADDR06
PIXELADDR06	PROC	FAR

	enter	0, 0

	mov	ax, usX 	; AX = x
	mov	cl, al		; CL = low-order byte of x
	mov	bx, usY 	; BX = y

	xchg	bh, bl
	shr	ax, 1		; AX = x/2
	shr	bx, 1		; BX = 80h*(y&1)
	add	ah, bl		; AX = x + 8000h*(y&1)
	xor	bl, bl		; BX = 100h*(y/2)
	add	ax, bx		; AX = x/2 + 8000h*(y&1) + 100h*(y/2)
	shr	bx, 2		; BX = 40h*(y/2)
	add	ax, bx		; AX = x/2 + 8000h*(y&1) + 140h*(y/2)
	shr	ax, 2		; AX = x/8 + 2000h*(y&1) + 50h*(y/2)
	add	ax, VSP.ofsVBuf ; add origin offset
	mov	dx, VSP.segVBuf ; DX:AX -> pixel

	leave
	ret	4		; 2*sizeof(USHORT)

PIXELADDR06	ENDP

; parameters for all SetPixel functions
ucPixel 	EQU	[bp+6]
usY		EQU	[bp+8]
usX		EQU	[bp+10]

; SetPixel04
;
;   void VS2API SetPixel04( USHORT usX, USHORT usY, UCHAR ucPixel );

		PUBLIC	SETPIXEL04
SETPIXEL04	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	bx, usX 	; BX = x
	mov	cl, bl		; CL = low-order byte of x
	mov	ax, usY 	; AX = y

	xchg	ah, al
	shr	ax, 1		; AX = 80h*(y&1)
	add	bh, al		; BX = x + 8000h*(y&1)
	xor	al, al		; AX = 100h*(y/2)
	add	bx, ax		; BX = x + 8000h*(y&1) + 100h*(y/2)
	shr	ax, 2		; AX = 40h*(y/2)
	add	bx, ax		; BX = x + 8000h*(y&1) + 140h*(y/2)
	shr	bx, 2		; BX = x/4 + 2000h*(y&1) + 50h*(y/2)
	add	bx, VSP.ofsVBuf ; add origin offset
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; compute a bit mask for the 2-bit packed pixel
	mov	ax, 303h    ; AH = 3 (bit mask)
			    ; AL = 3 (mask for pixel value)
	not	cl
	and	cl, ah
	shl	cl, 1	    ; CL = # bits to shift left

; shift the bit mask and new pixel value into position
	and	al, ucPixel
	shl	ax, cl

; jump to the Replace, AND, OR or XOR routine
	jmp	SetPixelOp04

; come here to Replace the pixel value
ReplPixel04::
	not	ah		; AH = inverse bit mask
	and	es:[bx], ah	; zero the pixel value
	or	es:[bx], al	; set the pixel value
	jmp	L001

; come here to AND the pixel value
ANDPixel04::
	not	ah		; AH = inverse bit mask
	or	al, ah		; AL = all 1's except pixel value
	and	es:[bx], al
	jmp	L001

; come here to OR the pixel value
ORPixel04::
	or	es:[bx], al
	jmp	L001

; come here to XOR the pixel value
XORPixel04::
	xor	es:[bx], al

L001:	leave
	ret	6

SETPIXEL04	ENDP

; SetPixel06
;
;   void VS2API SetPixel06( USHORT usX, USHORT usY, UCHAR ucPixel );

		PUBLIC	SETPIXEL06
SETPIXEL06	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	bx, usX     ; BX = x
	mov	cl, bl	    ; CL = low-order byte of x
	mov	ax, usY     ; AX = y

	xchg	ah, al
	shr	bx, 1	    ; BX = x/2
	shr	ax, 1	    ; AX = 80h*(y&1)
	add	bh, al	    ; BX = x/2 + 8000h*(y&1)
	xor	al, al	    ; AX = 100h*(y/2)
	add	bx, ax	    ; BX = x/2 + 8000h*(y&1) + 100h*(y/2)
	shr	ax, 2	    ; AX = 40h*(y/2)
	add	bx, ax	    ; BX = x/2 + 8000h*(y&1) + 140h*(y/2)
	shr	bx, 2	    ; BX = x/8 + 2000h*(y&1) + 50h*(y/2)
	add	bx, VSP.ofsVBuf ; add origin offset
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; compute a bit mask for the 1-bit packed pixel
	mov	ax, 101h    ; AH = 1 (bit mask)
			    ; AL = 1 (mask for pixel value)
	not	cl
	and	cl, 7	    ; CL = # bits to shift left

; shift the bit mask and new pixel value into position
	and	al, ucPixel
	shl	ax, cl

; jump to the Replace, AND, OR or XOR routine
	jmp	SetPixelOp06

; come here to Replace the pixel value
ReplPixel06::
	not	ah		; AH = inverse bit mask
	and	es:[bx], ah	; zero the pixel value
	or	es:[bx], al	; set the pixel value
	jmp	L102

; come here to AND the pixel value
ANDPixel06::
	not	ah		; AH = inverse bit mask
	or	al, ah		; AL = all 1's except pixel value
	and	es:[bx], al
	jmp	L102
				
; come here to OR the pixel value
ORPixel06::
	or	es:[bx], al
	jmp	L102

; come here to XOR the pixel value
XORPixel06::
	xor	es:[bx], al

L102:	leave
	ret	6

SETPIXEL06	ENDP

; parameters for all GetPixel functions
usY		EQU	[bp+6]
usX		EQU	[bp+8]

; GetPixel04
;
;   UCHAR VS2API GetPixel04( USHORT usX, USHORT usY );

		PUBLIC	GETPIXEL04
GETPIXEL04	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	bx, usX     ; BX = x
	mov	cl, bl	    ; CL = low-order byte of x
	mov	ax, usY     ; AX = y

	xchg	ah, al
	shr	ax, 1	    ; AX = 80h*(y&1)
	add	bh, al	    ; BX = x + 8000h*(y&1)
	xor	al, al	    ; AX = 100h*(y/2)
	add	bx, ax	    ; BX = x + 8000h*(y&1) + 100h*(y/2)
	shr	ax, 2	    ; AX = 40h*(y/2)
	add	bx, ax	    ; BX = x + 8000h*(y&1) + 140h*(y/2)
	shr	bx, 2	    ; BX = x/4 + 2000h*(y&1) + 50h*(y/2)
	add	bx, VSP.ofsVBuf ; add origin offset
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; compute the number of bits to shift for the 2-bit packed pixel
	not	cl
	and	cl, 3
	shl	cl, 1

; get the pixel value and shift it back into place
	mov	al, es:[bx] ; AL = byte containing the pixel
	shr	al, cl
	and	ax, 3

	leave
	ret	4	    ; 2*sizeof(int)

GETPIXEL04	ENDP

; GetPixel06
;
;   UCHAR VS2API GetPixel06( USHORT usX, USHORT usY );

		PUBLIC	GETPIXEL06
GETPIXEL06	PROC	FAR

	enter	0, 0

; point to the specified pixel
	mov	bx, usX     ; BX = x
	mov	cl, bl	    ; CL = low-order byte of x
	mov	ax, usY     ; AX = y

	xchg	ah, al
	shr	bx, 1	    ; BX = x/2
	shr	ax, 1	    ; AX = 80h*(y&1)
	add	bh, al	    ; BX = x/2 + 8000h*(y&1)
	xor	al, al	    ; AX = 100h*(y/2)
	add	bx, ax	    ; BX = x/2 + 8000h*(y&1) + 100h*(y/2)
	shr	ax, 2	    ; AX = 40h*(y/2)
	add	bx, ax	    ; BX = x/2 + 8000h*(y&1) + 140h*(y/2)
	shr	bx, 2	    ; BX = x/8 + 2000h*(y&1) + 50h*(y/2)
	add	bx, VSP.ofsVBuf ; add origin offset
	mov	es, VSP.segVBuf ; ES:BX -> pixel

; compute the number of bits to shift for the 1-bit packed pixel
	not	cl
	and	cl, 7

; get the pixel value and shift it back into place
	mov	al, es:[bx] ; AL = byte containing the pixel
	shr	al, cl
	and	ax, 1

	leave
	ret	4	    ; 2*sizeof(int)

GETPIXEL06	ENDP

; parameters for all Line functions
ucPixel 	EQU	[bp+6]
y2		EQU	[bp+8]
x2		EQU	[bp+10]
y1		EQU	[bp+12]
x1		EQU	[bp+14]

; temporary variables
LineFn		EQU	WORD PTR [bp-2]
VertIncr	EQU	WORD PTR [bp-4]
Incr2		EQU	WORD PTR [bp-6]
Incr1		EQU	WORD PTR [bp-8]
IncrY		EQU	WORD PTR [bp-10]

; Line04
;
;   void VS2API
;     Line04( USHORT x1, USHORT y1, USHORT x2, USHORT y2, UCHAR ucPixel );

		PUBLIC	LINE04
LINE04		PROC	FAR

	enter	10, 0

	push	si
	push	di

	and	BYTE PTR ucPixel, 3	; force a valid pixel value
	mov	si, VSP.cbRow

; check for horizontal line
	mov	bx, y2
	sub	bx, y1		; BX = y2 - y1
	jnz	L200

	call	HorzLine04
	jmp	L209

; check for vertical line
L200:	mov	cx, x2
	sub	cx, x1		; CX = x2 - x1
	jnz	L201

	call	VertLine04
	jmp	L209

; come here if not horizontal or vertical
L201:	jns	L202		; jump if x2 > x1

; at this point x2 < x1, so reverse the endpoints
	neg	cx		; CX = dX
	neg	bx		; BX = dY

	mov	ax, x2		; exchange x1 and x2
	xchg	ax, x1
	mov	x2, ax

	mov	ax, y2		; exchange y1 and y2
	xchg	ax, y1
	mov	y2, ax

; at this point, dX (in register CX) is positive
L202:	mov	IncrY, 2000h
	sub	si, 2000h	; SI = cbRow-2000h

	or	bx, bx		; test sign of dY
	jns	L204		; jump if slope is positive

	neg	bx		; make dY positive
	neg	si		; negate interleave increments
	xchg	si, IncrY
	neg	si

; select the appropriate routine for the slope of line
L204:	mov	LineFn, offset LoSlopeLine04
	cmp	bx, cx
	jl	L205		; jump if dY < dX (slope < 1)

	mov	LineFn, offset HiSlopeLine04
	xchg	bx, cx		; exchange dY and dX

; calculate the initial decision variable and increments
L205:	shl	bx, 1		; BX = Incr1 = 2*dY
	mov	Incr1, bx
	mov	dx, bx
	sub	dx, cx		; DX = d = 2*dY-dX
	mov	Incr2, dx
	sub	Incr2, cx	; Incr2 = 2*(dY-dX)

; calculate the first pixel address
	push	cx		; preserve dX and d
	push	dx

	push	x1
	push	y1
	call	PixelAddr04	; DX:AX -> buffer
	mov	es, dx
	mov	di, ax		; ES:DI -> buffer

; exchange y-increments depending on whether y is even or odd
	test	ah, 20h
	jnz	L206

	xchg	si, IncrY

; create a bit mask for the first pixel
L206:	mov	ah, 0C0h	; AH = C0h (bit mask)
	mov	cl, x1
	and	cl, 3		; CL = x1 MOD 4
	add	cl, cl		; CX = 2*(x1 MOD 4)
	shr	ah, cl		; AH = bit mask

	pop	dx		; DX = d
	pop	cx		; CX = dX
	inc	cx		; CX = # of pixels to draw

; mask the pixel value
	mov	bx, offset PackedPixel04
	mov	al, ucPixel
	xlat
	mov	bl, al
	and	bl, ah		; BL = masked pixel
	mov	bh, ah
	not	bh		; BH = inverse mask

				; at this point:
				;  ES:DI -> first pixel
				;   BH = inverse bit mask for 1st pixel
				;   BL = pixel value
				;   CX = # pixels to draw
				;   DX = decision variable
				;   SI = initial y-increment

	call	LineFn		; draw the line

; restore registers and return
L209:	pop	di
	pop	si
	leave
	ret	10		; 4*sizeof(USHORT) + sizeof(UCHAR)

LINE04		ENDP

VertLine04	PROC	NEAR

	mov	ax, y1		; AX = y1
	mov	cx, y2
	sub	cx, ax		; CX = y2-y1
	jge	L210		; jump if dY >= 0

	add	ax, cx		; AX = y2
	neg	cx		; force dY >= 0

L210:	inc	cx		; CX = # of pixels to draw
	push	cx		; preserve CX

; point to the bottommost pixel
	push	x1
	push	ax
	call	PixelAddr04
	mov	es, dx
	mov	di, ax		; ES:DI = byte address of pixel

; compute y-increments (2000h and cbRow-2000h)
	mov	dx, 2000h	; DX = 2000h
	sub	si, dx		; SI = cbRow - 2000h
	test	ah, 20h
	jz	L211		; jump if (y MOD 2) = 0

	xchg	si, dx		; exchange y-increments

L211:	mov	al, ucPixel
	mov	bx, offset PackedPixel04
	xlat
	mov	bl, al		; AL = packed pixel value

	mov	ax, 0C03Fh	; AH = C0h (bit mask)
				; AL = 3Fh (inverse bit mask)
	mov	cl, x1
	and	cl, 3		; CL = x1 MOD 4
	add	cl, cl		; CX = 2*(x1 MOD 4)
	shr	ah, cl		; AH = bit mask
	ror	al, cl		; AL = inverse bit mask

	pop	cx		; CX = # of pixels

; draw the line
	and	ah, bl		; AH = pixel value
L212:	and	es:[di], al	; zero previous pixel
	or	es:[di], ah	; update pixel
	add	di, dx		; increment to next interleave
	xchg	dx, si		; update y-increment
	loop	L212

	ret

VertLine04	ENDP

HorzLine04	PROC	NEAR

; ensure that x1 < x2 (move left to right)
	mov	di, x1		; DI = x1
	mov	si, x2		; SI = x2
	cmp	si, di
	jae	L220

	xchg	si, di		; DI = leftmost x-coordinate

; determine the bit masks for the leftmost and rightmost pixel(s)
L220:	mov	dx, 0FFC0h	; DH = FFh (left mask)
				; DL = C0h (right mask)
	mov	cx, di
	and	cl, 3		; CL = x1 MOD 4
	add	cl, cl		; CL = 2*(x1 MOD 4)
	shr	dh, cl		; DH = left mask
	mov	cx, si
	and	cl, 3		; CL = x2 MOD 4
	add	cl, cl		; CL = 2*(x2 MOD 4)
	sar	dl, cl		; DL = right mask

; compute the byte offset of the first byte in the row
	push	dx		; preserve bit masks
	mov	ax, y1
	xor	bx, bx		; BX = 0
	shr	ax, 1		; AX = y/2; cf = y MOD 2
	rcr	bx, 1		; BX = 8000h * (y MOD 2)
	shr	bx, 2		; BX = 2000h * (y MOD 2)
	mul	VSP.cbRow	; AX = y * (bytes per row)
	add	ax, bx		; AX = offset of first byte in row
	pop	dx		; restore bit masks

; compute byte offsets for x1 and x2
	shr	di, 2		; DI = byte offset of x1
	shr	si, 2		; DX = byte offset of x2

	mov	cx, si
	sub	cx, di		; CX = difference of byte offsets

; point to the first byte in the line
	add	di, ax
	add	di, VSP.ofsVBuf
	mov	es, VSP.segVBuf ; ES:DI -> first byte

	jcxz	L223		; jump if only 1 byte in the line

; set pixels in the leftmost byte of the line
	mov	al, ucPixel
	mov	bx, offset PackedPixel04
	xlat			; AL = packed pixel value

	mov	ah, dh		; AH = bit mask for 1st byte
	and	al, ah		; AL = masked pixel(s)
	not	ah		; AH = inverse bit mask

	and	ah, es:[di]	; AH = masked pixel data
	or	al, ah		; AL = updated pixel data
	stosb			; store into video buffer

	mov	al, ucPixel
	xlat			; AL = packed pixel value

	dec	cx
	jz	L222		; jump if only 1 byte remains

; draw the middle of the line
	mov	ah, al		; AH:AL = packed pixels
	shr	cx, 1		; CX = # of words; cf set if odd
	rep	stosw		; update 2 bytes at a time
	jnc	L222		; jump if even # of bytes
	stosb			; update the odd byte

; set pixels in the rightmost byte of the line
L222:	mov	ah, dl		; AH = bit mask for last byte
	and	al, ah		; AL = masked pixel(s)
	not	ah		; AH = inverse bit mask

	and	ah, es:[di]	; AH = masked pixel data
	or	ah, al		; AH = updated pixel data
	mov	es:[di], ah	; store into video buffer

	ret

; come here if only one byte in the line
L223:	mov	al, ucPixel
	mov	bx, offset PackedPixel04
	xlat			; AL = packed pixel value

	mov	ah, dl
	and	ah, dh		; AH = bit mask for the byte
	and	al, ah		; AL = masked pixel(s)
	not	ah		; AH = inverse bit mask

	and	ah, es:[di]	; AH = masked pixel data
	or	ah, al		; AH = updated pixel data
	mov	es:[di], ah	; store into video buffer

	ret

HorzLine04	ENDP

LoSlopeLine04	PROC	NEAR	; come here for dY < dX (slope < 1)

L230:	mov	al, es:[di]	; AL = next byte from video buffer

L231:	and	al, bh		; zero current pixel
	or	al, bl		; set current pixel
	ror	bl, 2		; rotate pixel value
	ror	bh, 2		; rotate inverse mask
	jnc	L234		; jump if bit mask rotated to
				;  leftmost pixel position

; bit mask not rotated around
	or	dx, dx		; test sign of d
	jns	L232		; jump if d >= 0

	add	dx, Incr1	; d = d + Incr1
	loop	L231

; at this point, all but the last byte of pixels have been set
	mov	es:[di], al	; set remaining pixel(s)
	ret

; come here when d>=0
L232:	add	dx, Incr2	; d = d + Incr2
	mov	es:[di], al	; update bit planes
	add	di, si		; increment y
	xchg	si, IncrY
	loop	L230
	ret

; bit mask rotated around
L234:	stosb			; update bit planes; autoincrement DI

	or	dx, dx		; test sign of d
	jns	L235		; jump if non-negative

	add	dx, Incr1	; d = d + Incr1
	loop	L230
	ret

L235:	add	dx, Incr2	; d = d + Incr2
	add	di, si		; increment y
	xchg	si, IncrY
	loop	L230
	ret

LoSlopeLine04	ENDP

HiSlopeLine04	PROC	NEAR	; come here for dY >= dX (slope >= 1)

L241:	mov	al, es:[di]	; AL = next byte from video buffer
	and	al, bh		; zero current pixel
	or	al, bl		; update current pixel
	mov	es:[di], al	; store updated pixel
	add	di, si		; increment y
	xchg	si, IncrY

L242:	or	dx, dx		; test sign of d
	jns	L243		; jump if d >= 0

	add	dx, Incr1	; d = d + Incr1
	loop	L241		; loop until all pixels are drawn
	ret

L243:	add	dx, Incr2	; d = d + Incr2
	ror	bl, 2		; rotate pixel value
	ror	bh, 2		; rotate bit mask
	cmc			; cf set if mask has rotated to
				;  leftmost pixel position
	adc	di, 0		; conditionally increment DI
	loop	L241
	ret

HiSlopeLine04	ENDP

; Line06
;
;   void VS2API
;     Line06( USHORT x1, USHORT y1, USHORT x2, USHORT y2, UCHAR ucPixel );

		PUBLIC	LINE06
LINE06		PROC	FAR

	enter	10, 0

	push	si
	push	di

	and	BYTE PTR ucPixel, 1	; force a valid pixel value
	mov	si, VSP.cbRow

; check for horizontal line
	mov	bx, y2
	sub	bx, y1		; BX = y2 - y1
	jnz	L300

	call	HorzLine06
	jmp	L309

; check for vertical line
L300:	mov	cx, x2
	sub	cx, x1		; CX = x2 - x1
	jnz	L301

	call	VertLine06
	jmp	L309

; come here if not horizontal or vertical
L301:	jns	L302		; jump if x2 > x1

; at this point x2 < x1, so reverse the endpoints
	neg	cx		; CX = dX
	neg	bx		; BX = dY

	mov	ax, x2		; exchange x1 and x2
	xchg	ax, x1
	mov	x2, ax

	mov	ax, y2		; exchange y1 and y2
	xchg	ax, y1
	mov	y2, ax

; at this point, dX (in register CX) is positive
L302:	mov	IncrY, 2000h
	sub	si, 2000h	; SI = cbRow-2000h

	or	bx, bx		; test sign of dY
	jns	L304		; jump if slope is positive

	neg	bx		; make dY positive
	neg	si		; negate interleave increments
	xchg	si, IncrY
	neg	si

; select the appropriate routine for the slope of line
L304:	mov	LineFn, offset LoSlopeLine06
	cmp	bx, cx
	jl	L305		; jump if dY < dX (slope < 1)

	mov	LineFn, offset HiSlopeLine06
	xchg	bx, cx		; exchange dY and dX

; calculate the initial decision variable and increments
L305:	shl	bx, 1		; BX = Incr1 = 2*dY
	mov	Incr1, bx
	mov	dx, bx
	sub	dx, cx		; DX = d = 2*dY-dX
	mov	Incr2, dx
	sub	Incr2, cx	; Incr2 = 2*(dY-dX)

; calculate the first pixel address
	push	cx		; preserve dX and d
	push	dx

	push	x1
	push	y1
	call	PixelAddr06	; DX:AX -> buffer
	mov	es, dx
	mov	di, ax		; ES:DI -> buffer

; exchange y-increments depending on whether y is even or odd
	test	ah, 20h
	jnz	L306

	xchg	si, IncrY

; create a bit mask for the first pixel
L306:	mov	ah, 80h 	; AH = 80h (bit mask)
	mov	cl, x1
	and	cl, 7		; CL = x1 MOD 8
	shr	ah, cl		; AH = bit mask

	pop	dx		; DX = d
	pop	cx		; CX = dX
	inc	cx		; CX = # of pixels to draw

; mask the pixel value
	mov	bx, offset PackedPixel06
	mov	al, ucPixel
	xlat
	mov	bl, al
	and	bl, ah		; BL = masked pixel
	mov	bh, ah
	not	bh		; BH = inverse mask

				; at this point:
				;  ES:DI -> first pixel
				;   BH = inverse bit mask for 1st pixel
				;   BL = pixel value
				;   CX = # pixels to draw
				;   DX = decision variable
				;   SI = initial y-increment

	call	LineFn		; draw the line

; restore registers and return
L309:	pop	di
	pop	si
	leave
	ret	10		; 4*sizeof(USHORT) + sizeof(UCHAR)

LINE06		ENDP

VertLine06	PROC	NEAR

	mov	ax, y1		; AX = y1
	mov	cx, y2
	sub	cx, ax		; CX = y2-y1
	jge	L310		; jump if dY >= 0

	add	ax, cx		; AX = y2
	neg	cx		; force dY >= 0

L310:	inc	cx		; CX = # of pixels to draw
	push	cx		; preserve CX

; point to the bottommost pixel
	push	x1
	push	ax
	call	PixelAddr06
	mov	es, dx
	mov	di, ax		; ES:DI = byte address of pixel

; compute y-increments (2000h and cbRow-2000h)
	mov	dx, 2000h	; DX = 2000h
	sub	si, dx		; SI = cbRow - 2000h
	test	ah, 20h
	jz	L311		; jump if (y MOD 2) = 0

	xchg	si, dx		; exchange y-increments

L311:	mov	al, ucPixel
	mov	bx, offset PackedPixel06
	xlat
	mov	bl, al		; AL = packed pixel value

	mov	ax, 807Fh	; AH = 80h (bit mask)
				; AL = 7Fh (inverse bit mask)
	mov	cl, x1
	and	cl, 7		; CL = x1 MOD 8
	shr	ah, cl		; AH = bit mask
	ror	al, cl		; AL = inverse bit mask

	pop	cx		; CX = # of pixels

; draw the line
	and	ah, bl		; AH = pixel value
L312:	and	es:[di], al	; zero previous pixel
	or	es:[di], ah	; update pixel
	add	di, dx		; increment to next interleave
	xchg	dx, si		; update y-increment
	loop	L312

	ret

VertLine06	ENDP

HorzLine06	PROC	NEAR

; ensure that x1 < x2 (move left to right)
	mov	di, x1		; DI = x1
	mov	si, x2		; SI = x2
	cmp	si, di
	jae	L320

	xchg	si, di		; DI = leftmost x-coordinate

; determine the bit masks for the leftmost and rightmost pixel(s)
L320:	mov	dx, 0FF80h	; DH = FFh (left mask)
				; DL = 80h (right mask)
	mov	cx, di
	and	cl, 7		; CL = x1 MOD 8
	shr	dh, cl		; DH = left mask
	mov	cx, si
	and	cl, 7		; CL = x2 MOD 8
	sar	dl, cl		; DL = right mask

; compute the byte offset of the first byte in the row
	push	dx		; preserve bit masks
	mov	ax, y1
	xor	bx, bx		; BX = 0
	shr	ax, 1		; AX = y/2; cf = y MOD 2
	rcr	bx, 1		; BX = 8000h * (y MOD 2)
	shr	bx, 2		; BX = 2000h * (y MOD 2)
	mul	VSP.cbRow	; AX = y * (bytes per row)
	add	ax, bx		; AX = offset of first byte in row
	pop	dx		; restore bit masks

; compute byte offsets for x1 and x2
	shr	di, 3		; DI = byte offset of x1
	shr	si, 3		; DX = byte offset of x2

	mov	cx, si
	sub	cx, di		; CX = difference of byte offsets

; point to the first byte in the line
	add	di, ax
	add	di, VSP.ofsVBuf
	mov	es, VSP.segVBuf ; ES:DI -> first byte

	jcxz	L323		; jump if only 1 byte in the line

; set pixels in the leftmost byte of the line
	mov	al, ucPixel
	mov	bx, offset PackedPixel06
	xlat			; AL = packed pixel value

	mov	ah, dh		; AH = bit mask for 1st byte
	and	al, ah		; AL = masked pixel(s)
	not	ah		; AH = inverse bit mask

	and	ah, es:[di]	; AH = masked pixel data
	or	al, ah		; AL = updated pixel data
	stosb			; store into video buffer

	mov	al, ucPixel
	xlat			; AL = packed pixel value

	dec	cx
	jz	L322		; jump if only 1 byte remains

; draw the middle of the line
	mov	ah, al		; AH:AL = packed pixels
	shr	cx, 1		; CX = # of words; cf set if odd
	rep	stosw		; update 2 bytes at a time
	jnc	L322		; jump if even # of bytes
	stosb			; update the odd byte

; set pixels in the rightmost byte of the line
L322:	mov	ah, dl		; AH = bit mask for last byte
	and	al, ah		; AL = masked pixel(s)
	not	ah		; AH = inverse bit mask

	and	ah, es:[di]	; AH = masked pixel data
	or	ah, al		; AH = updated pixel data
	mov	es:[di], ah	; store into video buffer

	ret

; come here if only one byte in the line
L323:	mov	al, ucPixel
	mov	bx, offset PackedPixel06
	xlat			; AL = packed pixel value

	mov	ah, dl
	and	ah, dh		; AH = bit mask for the byte
	and	al, ah		; AL = masked pixel(s)
	not	ah		; AH = inverse bit mask

	and	ah, es:[di]	; AH = masked pixel data
	or	ah, al		; AH = updated pixel data
	mov	es:[di], ah	; store into video buffer

	ret

HorzLine06	ENDP

LoSlopeLine06	PROC	NEAR	; come here for dY < dX (slope < 1)

L330:	mov	al, es:[di]	; AL = next byte from video buffer

L331:	and	al, bh		; zero current pixel
	or	al, bl		; set current pixel
	ror	bl, 1		; rotate pixel value
	ror	bh, 1		; rotate inverse mask
	jnc	L334		; jump if bit mask rotated to
				;  leftmost pixel position

; bit mask not rotated around
	or	dx, dx		; test sign of d
	jns	L332		; jump if d >= 0

	add	dx, Incr1	; d = d + Incr1
	loop	L331

; at this point, all but the last byte of pixels have been set
	mov	es:[di], al	; set remaining pixel(s)
	ret

; come here when d>=0
L332:	add	dx, Incr2	; d = d + Incr2
	mov	es:[di], al	; update bit planes
	add	di, si		; increment y
	xchg	si, IncrY
	loop	L330
	ret

; bit mask rotated around
L334:	stosb			; update bit planes; autoincrement DI

	or	dx, dx		; test sign of d
	jns	L335		; jump if non-negative

	add	dx, Incr1	; d = d + Incr1
	loop	L330
	ret

L335:	add	dx, Incr2	; d = d + Incr2
	add	di, si		; increment y
	xchg	si, IncrY
	loop	L330
	ret

LoSlopeLine06	ENDP

HiSlopeLine06	PROC	NEAR	; come here for dY >= dX (slope >= 1)

L341:	mov	al, es:[di]	; AL = next byte from video buffer
	and	al, bh		; zero current pixel
	or	al, bl		; update current pixel
	mov	es:[di], al	; store updated pixel
	add	di, si		; increment y
	xchg	si, IncrY

L342:	or	dx, dx		; test sign of d
	jns	L343		; jump if d >= 0

	add	dx, Incr1	; d = d + Incr1
	loop	L341		; loop until all pixels are drawn
	ret

L343:	add	dx, Incr2	; d = d + Incr2
	ror	bl, 1		; rotate pixel value
	ror	bh, 1		; rotate bit mask
	cmc			; cf set if mask has rotated to
				;  leftmost pixel position
	adc	di, 0		; conditionally increment DI
	loop	L341
	ret

HiSlopeLine06	ENDP

VS2_TEXT	ENDS


_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

; addrs of desired pixel operations ("raster ops")
SetPixelOp04	WORD	ReplPixel04
SetPixelOp06	WORD	ReplPixel06

; packed pixel values
PackedPixel04	BYTE	00000000b, 01010101b, 10101010b, 11111111b
PackedPixel06	BYTE	00000000b, 11111111b

_DATA		ENDS

		END
