		TITLE	EGA.ASM
		NAME	EGA
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	PIXELADDR10:FAR

; Line10EGA (write mode 0, Set/Reset)
;
;   void VS2API
;     Line10EGA( USHORT x1, USHORT y1, USHORT x2, USHORT y2, UCHAR ucPixel );

ucPixel 	EQU	[bp+6]
y2		EQU	[bp+8]
x2		EQU	[bp+10]
y1		EQU	[bp+12]
x1		EQU	[bp+14]

VertIncr	EQU	WORD PTR [bp-2]
Incr1		EQU	WORD PTR [bp-4]
Incr2		EQU	WORD PTR [bp-6]
LineFn		EQU	WORD PTR [bp-8]

		PUBLIC	LINE10EGA
LINE10EGA	PROC	FAR

	enter	8, 0

	push	si
	push	di

	mov	si, VSP.cbRow

; check for horizontal line
	mov	bx, y2
	sub	bx, y1		; BX = y2 - y1
	jnz	L000

	call	HorzLine10
	jmp	L009

; check for vertical line
L000:	mov	cx, x2
	sub	cx, x1		; CX = x2 - x1
	jnz	L001

	call	VertLine10
	jmp	L009

; come here if not horizontal or vertical
L001:	jns	L002		; jump if x2 > x1

; at this point x2 < x1, so reverse the endpoints
	neg	cx		; CX = dX
	neg	bx		; BX = dY

	mov	ax, x2		; exchange x1 and x2
	xchg	ax, x1
	mov	x2, ax

	mov	ax, y2		; exchange y1 and y2
	xchg	ax, y1
	mov	y2, ax

; at this point, dX (in register cx) is positive
L002:	or	bx, bx		; test sign of dY
	jns	L004		; jump if slope is positive

	neg	bx		; make dY positive
	neg	si		; negate the y-increment

; select the appropriate routine for the slope of line
L004:	mov	VertIncr, si	; save vertical increment

	mov	LineFn, offset LoSlopeLine10
	cmp	bx, cx
	jl	L005		; jump if dY < dX (slope < 1)

	mov	LineFn, offset HiSlopeLine10
	xchg	bx, cx		; exchange dY and dX

; calculate the initial decision variable and increments
L005:	shl	bx, 1		; BX = 2*dY
	mov	Incr1, bx	; Incr1 = 2*dY
	sub	bx, cx
	mov	si, bx		; SI = d = 2*dY - dX
	sub	bx, cx
	mov	Incr2, bx	; Incr2 = 2*(dY - dX)

; calculate the first pixel address
	push	cx		; preserve dX
	push	x1
	push	y1
	call	PixelAddr10	; DX:AX -> buffer
	mov	es, dx
	mov	di, ax		; ES:DI -> buffer
	mov	ax, 8008h	; AH = 80h (bit mask)
				; AL = 8 (Bit Mask reg #)
	mov	cl, x1
	and	cl, 7		; CL = x1 MOD 8
	shr	ah, cl		; AH = initial bit mask

	pop	cx		; CX = dX
	inc	cx		; CX = # of pixels to draw

	call	SetGC10EGA	; at this point:
				;  ES:DI -> first pixel
				;   AH = bit mask for 1st pixel
				;   AL = Bit Mask register number
				;   CX = # pixels to draw
				;   DX = Graphics Controller I/O addr
				;   SI = decision variable

	call	LineFn		; draw the line

; restore the default Graphics Controller state
L009:	xor	ax, ax		; AH = 0, AL = 0
	out	dx, ax		; Set/Reset

	inc	ax		; AH = 0, AL = 1
	out	dx, ax		; Enable Set/Reset

	mov	al, 3		; AH = 0, AL = 3
	out	dx, ax		; Data Rotate/Func Select

	mov	ax, 0FF08h	; AH = 11111111b, AL = 8
	out	dx, ax		; Bit Mask

; restore registers and return
	pop	di
	pop	si
	leave
	ret	10		; 4*sizeof(USHORT) + sizeof(UCHAR)

LINE10EGA	ENDP

VertLine10	PROC	NEAR

	mov	ax, y1		; AX = y1
	mov	cx, y2
	sub	cx, ax		; CX = y2-y1
	jge	L011		; jump if dY >= 0

	add	ax, cx		; AX = y2
	neg	cx		; force dY >= 0

L011:	inc	cx		; CX = # of pixels to draw
	push	cx		; preserve CX

; point to the bottommost pixel
	push	x1
	push	ax
	call	PixelAddr10
	mov	es, dx
	mov	di, ax		; ES:DI = byte address of pixel

	call	SetGC10EGA	; set up Graphics Controller

	mov	ax, 8008h	; AH = 80h (bit mask)
				; AL = 8 (Bit Mask register number)
	mov	cl, x1
	and	cl, 7		; CL = x1 MOD 8
	shr	ah, cl
	out	dx, ax

	pop	cx		; CX = # of pixels

; draw the line
L012:	or	es:[di], al	; set pixel
	add	di, si		; increment to next line
	loop	L012

	ret

VertLine10	ENDP

HorzLine10	PROC	NEAR

; ensure that x1 < x2 (move left to right)
	mov	di, x1		; DI = x1
	mov	si, x2		; SI = x2
	cmp	si, di
	jae	L020

	xchg	si, di		; DI = leftmost x-coordinate

; compute the bit masks for the leftmost and rightmost pixel(s)
L020:	mov	bx, 0FF80h	; BH = FFh (left mask)
				; BL = 80h (right mask)
	mov	cx, di
	and	cl, 7		; CL = x1 MOD 8
	shr	bh, cl		; BH = left mask
	mov	cx, si
	and	cl, 7		; CL = x2 MOD 8
	sar	bl, cl		; BL = right mask

; compute the offset of the first byte in the scan line
	mov	ax, y1
	mul	VSP.cbRow	; AX = y * (bytes per row)

; compute byte offsets for x1 and x2
	shr	di, 3		; DI = byte offset of x1
	shr	si, 3		; DX = byte offset of x2

	mov	cx, si
	sub	cx, di		; CX = difference of byte offsets

; point to the first byte in the line
	add	di, ax
	add	di, VSP.ofsVBuf
	mov	es, VSP.segVBuf ; ES:DI -> first byte

	call	SetGC10EGA	; set up Graphics Controller

	jcxz	L023		; jump if only 1 byte in the line

; set pixels in the leftmost byte of the line
	mov	ah, bh		; AH = bit mask for 1st byte
	mov	al, 8		; AL = 8 (Bit Mask register number)
	out	dx, ax		; update Graphics Controller

	and	es:[di], ah	; update the pixels

	dec	cx
	jz	L022		; jump if only 1 byte remains

; draw the middle of the line
	mov	ah, 0FFh	; AH = bit mask
	out	dx, ax		; update Bit Mask register

L021:	inc	di		; point to the next byte
	and	es:[di], ah	; update pixels
	loop	L021

; set pixels in the rightmost byte of the line
L022:	mov	ah, bl		; AH = bit mask for last byte
	out	dx, ax		; update Graphics Controller
	and	es:[di+1], ah	; update bit planes

	ret

; come here if only one byte in the line
L023:	mov	ah, bl
	and	ah, bh		; AH = bit mask for the byte
	mov	al, 8		; AL = 8 (Bit Mask register number)
	out	dx, ax

	and	es:[di], ah	; set the pixels
	ret

HorzLine10	ENDP

LoSlopeLine10	PROC	NEAR	; come here for dY < dX (slope < 1)

	mov	bl, ah		; BL = initial bit mask

L030:	mov	ah, bl		; AH = bit mask for next pixel

L031:	or	ah, bl		; mask current pixel position
	ror	bl, 1		; rotate pixel value
	jc	L034		; jump if bit mask rotated to
				;  leftmost pixel position

; bit mask not rotated around
	or	si, si		; test sign of d
	jns	L032		; jump if d >= 0

	add	si, Incr1	; d = d + Incr1
	loop	L031

; at this point, all but the last byte of pixels have been set
	out	dx, ax		; update Bit Mask Register
	or	es:[di], al	; set remaining pixel(s)
	ret

; come here when d>=0
L032:	add	si, Incr2	; d = d + Incr2
	out	dx, ax		; update Bit Mask Register
	or	es:[di], al	; update bit planes
	add	di, VertIncr	; increment y
	loop	L030
	ret

; bit mask rotated around
L034:	out	dx, ax		; update Bit Mask Register ...

	or	es:[di], al	; update bit planes
	inc	di		; increment x

	or	si, si		; test sign of d
	jns	L035		; jump if non-negative

	add	si, Incr1	; d = d + Incr1
	loop	L030
	ret

L035:	add	si, Incr2	; d = d + Incr2
	add	di, VertIncr	; vertical increment
	loop	L030
	ret

LoSlopeLine10	ENDP

HiSlopeLine10	PROC	NEAR	; come here for dY >= dX (slope >= 1)

	mov	bx, VertIncr	; BX = y-increment

L041:	out	dx, ax		; update Bit Mask Register
	or	es:[di], al	; update bit planes

	add	di, bx		; increment y

L042:	or	si, si		; test sign of d
	jns	L043		; jump if d >= 0

	add	si, Incr1	; d = d + Incr1
	loop	L041		; loop until all pixels are drawn
	ret

L043:	add	si, Incr2	; d = d + Incr2
	ror	ah, 1		; rotate bit mask
	adc	di, 0		; increment DI if mask has rotated to
				;  leftmost pixel position
	loop	L041
	ret

HiSlopeLine10	ENDP

; SetGC10EGA
;
; Notes:
;   Leaves DX = 3CEh (Graphics Controller I/O address)

SetGC10EGA	PROC	NEAR

	push	ax

	mov	dx, 3CEh	; Graphics Controller I/O addr

	mov	ah, ucPixel	; AH = pixel value
	xor	al, al		; AL = Set/Reset reg #
	out	dx, ax

	mov	ax, 0F01h	; AH = 1111b (bit plane mask for
				;  Enable Set/Reset)
	out	dx, ax		; AL = Enable Set/Reset reg #

	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Func Select reg #
	out	dx, ax

	pop	ax
	ret

SetGC10EGA	ENDP

; Ellipse10EGA
;
;   void VS2API Ellipse10EGA( USHORT xc, USHORT yc,
;				USHORT a, USHORT b, UCHAR ucPixel );

; parameters for all Ellipse functions
ucPixel 	EQU	[bp+6]
b		EQU	[bp+8]
a		EQU	[bp+10]
yc		EQU	[bp+12]
xc		EQU	[bp+14]

; temporary variables
ULAddr		EQU	WORD PTR [bp-2]
URAddr		EQU	WORD PTR [bp-4]
LLAddr		EQU	WORD PTR [bp-6]
LRAddr		EQU	WORD PTR [bp-8]
LMask		EQU	BYTE PTR [bp-10]
RMask		EQU	BYTE PTR [bp-12]

_d		EQU	WORD PTR [bp-16]
_dx		EQU	WORD PTR [bp-20]
_dy		EQU	WORD PTR [bp-24]
Asquared	EQU	WORD PTR [bp-28]
Bsquared	EQU	WORD PTR [bp-32]
TwoAsquared	EQU	WORD PTR [bp-36]
TwoBsquared	EQU	WORD PTR [bp-40]

		PUBLIC	ELLIPSE10EGA
ELLIPSE10EGA	PROC	FAR

	enter	40, 0
	push	si
	push	di

; set Graphics Controller Mode register
	mov	dx, 3CEh	; DX = Graphics Controller I/O addr
	mov	ax, 5		; AL = Mode register number
				; AH = Write Mode 0 (bits 0,1)
	out	dx, ax		;	Read Mode 0 (bit 4)

; set Data Rotate/Function Select register
	mov	ah, VSP.cRMW	; AH = Read-Modify-Write bits
	mov	al, 3		; AL = Data Rotate/Function Select reg
	out	dx, ax

; set Set/Reset and Enable Set/Reset registers
	mov	ah, ucPixel	; AH = pixel value
	mov	al, 0		; AL = Set/Reset reg number
	out	dx, ax

	mov	ax, 0F01h	; AH = value for Enable Set/Reset (all
				;  bit planes enabled)
	out	dx, ax		; AL = Enable Set/Reset reg number

; initial constants
	mov	ax, a
	mul	ax
	mov	Asquared, ax
	mov	Asquared+2, dx	    ; a^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoAsquared, ax
	mov	TwoAsquared+2, dx   ; 2*a^2

	mov	ax, b
	mul	ax
	mov	Bsquared, ax
	mov	Bsquared+2, dx	    ; b^2
	shl	ax, 1
	rcl	dx, 1
	mov	TwoBsquared, ax
	mov	TwoBsquared+2, dx   ; 2*b^2

			    ; plot pixels from (0,b) until dy/dx = -1

; initial buffer address and bit mask
	mov	ax, b
	mul	VSP.cbRow	; AX = relative byte offset of b
	mov	si, ax
	mov	di, ax

	push	xc
	push	yc
	call	PixelAddr10
	mov	bx, ax
	mov	es, dx		; ES:BX -> buffer

	mov	ax, 8008h	; AH = 80h (bit mask)
				; AL = 8 (Bit Mask register number)
	mov	cl, xc
	and	cl, 7		; CL = x1 MOD 8
	shr	ah, cl

	mov	LMask, ah
	mov	RMask, ah

	add	si, bx		; SI = offset of (0,b)
	mov	ULAddr, si
	mov	URAddr, si
	sub	bx, di		; BX = offset of (0,-b)
	mov	LLAddr, bx
	mov	LRAddr, bx

; initial decision variables
	xor	ax, ax
	mov	_dx, ax
	mov	_dx+2, ax	; dx = 0

	mov	ax, TwoAsquared
	mov	dx, TwoAsquared+2
	mov	cx, b
	call	LongMultiply	; perform 32-bit by 16-bit mulitply
	mov	_dy, ax
	mov	_dy+2, dx	; dy = TwoAsquared * b

	mov	ax, Asquared
	mov	dx, Asquared+2	; DX:AX = Asquared
	sar	dx, 1
	rcr	ax, 1
	sar	dx, 1
	rcr	ax, 1		; DX:AX = Asquared/4

	add	ax, Bsquared
	adc	dx, Bsquared+2	; DX:AX = Bsquared + Asquared/4
	mov	_d, ax
	mov	_d+2, dx

	mov	ax, Asquared
	mov	dx, Asquared+2
	mov	cx, b
	call	LongMultiply	; DX:AX = Asquared*b
	sub	_d, ax
	sbb	_d+2, dx	; d = Bsquared - Asquared*b + Asquared/4

; loop until dy/dx >= -1
	mov	bx, b		; BX = initial y-coordinate

	xor	cx, cx		; CH = 0 (initial y-increment)
				; CL = 0 (initial x-increment)
L110:	mov	ax, _dx
	mov	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2
	jns	L120		; jump if dx>=dy

	call	Set4Pixels

	mov	cx, 1		; CH = 0 (y-increment)
				; CL = 1 (x-increment)
	cmp	_d+2, 0
	js	L111		; jump if d < 0

	mov	ch, 1		; increment in y direction
	dec	bx		; decrement current y-coordinate

	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy -= TwoAsquared

	sub	_d, ax
	sbb	_d+2, dx	    ; d -= dy

L111:	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx += TwoBsquared

	add	ax, Bsquared
	adc	dx, Bsquared+2	    ; DX:AX = dx + Bsquared
	add	_d, ax
	adc	_d+2, dx	    ; d += dx + Bsquared

	jmp	L110

			    ; plot pixels from current (x,y) until y < 0

; update decision variables
L120:	push	bx		; preserve current y-coordinate
	push	cx		; preserve x- and y-increments

	mov	ax, Asquared
	mov	dx, Asquared+2
	sub	ax, Bsquared
	sbb	dx, Bsquared+2	; DX:AX = Asquared-Bsquared

	mov	bx, ax
	mov	cx, dx	    ; CX:BX = (Asquared-Bsquared)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX = (Asquared-Bsquared)/2
	add	ax, bx
	adc	dx, cx	    ; DX:AX = 3*(Asquared-Bsquared)/2

	sub	ax, _dx
	sbb	dx, _dx+2
	sub	ax, _dy
	sbb	dx, _dy+2   ; DX:AX = 3*(Asquared-Bsquared)/2 - (dx+dy)

	sar	dx, 1
	rcr	ax, 1	    ; DX:AX =
			    ;  (3*(Asquared-Bsquared)/2 - (dx+dy))/2
	add	_d, ax
	adc	_d+2, dx    ; update d

; loop until y < 0
	pop	cx		; CH,CL = y- and x-increments
	pop	bx		; BX = y

L121:	call	Set4Pixels

	mov	cx, 100h	; CH = 1 (y-increment)
				; CL = 0 (x-increment)

	cmp	_d+2, 0
	jns	L122		; jump if d >= 0

	mov	cl, 1		; increment in x direction

	mov	ax, _dx
	mov	dx, _dx+2
	add	ax, TwoBsquared
	adc	dx, TwoBsquared+2   ; DX:AX = dx + TwoBsquared
	mov	_dx, ax
	mov	_dx+2, dx	    ; dx += TwoBsquared

	add	_d, ax
	adc	_d+2, dx	    ; d += dx

L122:	mov	ax, _dy
	mov	dx, _dy+2
	sub	ax, TwoAsquared
	sbb	dx, TwoAsquared+2   ; DX:AX = dy - TwoAsquared
	mov	_dy, ax
	mov	_dy+2, dx	    ; dy -= TwoAsquared

	sub	ax, Asquared
	sbb	dx, Asquared+2	    ; DX:AX = dy - Asquared
	sub	_d, ax
	sbb	_d+2, dx	    ; d += Asquared - dy

	dec	bx		    ; decrement y
	jns	L121		    ; loop if y >= 0

; restore default Graphics Controller registers
	mov	ax, 0FF08h	; default Bit Mask
	mov	dx, 3CEh
	out	dx, ax

	mov	ax, 3		; default Function Select
	out	dx, ax

	mov	ax, 1		; default Enable Set/Reset
	out	dx, ax

	pop	di		; restore registers and return
	pop	si
	leave			; 4*sizeof(USHORT) + sizeof(UCHAR)
	ret	10

ELLIPSE10EGA	ENDP

; Set4Pixels
;
; Caller:   CH = y-increment (0, -1)
;	    CL = x-increment (0, 1)

Set4Pixels	PROC	NEAR


	push	ax		; preserve these regs
	push	bx
	push	dx

	mov	dx, 3CEh	; DX = Graphics Controller I/O addr

	xor	bx, bx		; BX = 0
	test	ch, ch
	jz	L130		; jump if y-increment = 0

	mov	bx, VSP.cbRow	; BX = positive increment
	neg	bx		; BX = negative increment

L130:	mov	al, 8		; AL = Bit Mask reg number

; pixels at (xc-x,yc+y) and (xc-x,yc-y)
	xor	si, si		; SI = 0
	mov	ah, LMask

	rol	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around
	neg	si		; SI = 0 or -1

	mov	di, si		; SI,DI = left horizontal increment

	add	si, ULAddr	; SI = upper left addr + horiz incr
	add	si, bx		; SI = new upper left addr
	add	di, LLAddr
	sub	di, bx		; DI = new lower left addr

	mov	LMask, ah	; update these variables
	mov	ULAddr, si
	mov	LLAddr, di

	out	dx, ax		; update Bit Mask register

	and	es:[si], ch	; update upper left pixel
	and	es:[di], ch	; update lower left pixel

; pixels at (xc+x,yc+y) and (xc+x,yc-y)
	xor	si, si		; SI = 0
	mov	ah, RMask

	ror	ah, cl		; AH = bit mask rotated horizontally
	rcl	si, 1		; SI = 1 if bit mask rotated around

	mov	di, si		; SI,DI = right horizontal increment

	add	si, URAddr	; SI = upper right addr + horiz incr
	add	si, bx		; SI = new upper right addr
	add	di, LRAddr
	sub	di, bx		; DI = new lower right addr

	mov	RMask, ah	; update these variables
	mov	URAddr, si
	mov	LRAddr, di

	out	dx, ax		; update Bit Mask register

	and	es:[si], ch	; update upper left pixel
	and	es:[di], ch	; update lower left pixel

	pop	dx
	pop	bx
	pop	ax
	ret

Set4Pixels	ENDP

; LongMultiply
;
; Caller:	DX:AX = L (32-bit integer)
;		CX =	S (16-bit integer)
; Returns:	DX:AX = L*S (32-bit product)

LongMultiply	PROC	NEAR

	push	ax	    ; preserve LOWORD(L)
	mov	ax, dx	    ; AX = HIWORD(L)
	mul	cx	    ; AX = HIWORD(L)*S
	xchg	ax, cx	    ; AX = S; CX=HIWORD(L)*S
	pop	dx	    ; DX = LOWORD(L)
	mul	dx	    ; AX = LOWORD(L)*S
			    ; DX = carry
	add	dx, cx	    ; DX = HIWORD(L)*S + carry
	ret

LongMultiply	ENDP










VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS

_DATA		ENDS

		END
