/***********************************************************************

  ANITEST.C

***********************************************************************/

#include    <stdio.h>	    /* sprintf sscanf */
#include    <conio.h>	    /* _getch _kbhit */
#include    <stdlib.h>	    /* exit rand */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

typedef void (* TESTPROC)( void );

void	    main( int, char * * );
void	    Test0( void );
void	    Test1( void );
void	    Test2( void );
void	    Test3( void );
void	    Test4( void );
void	    Test5( void );
static void InitVMode( void );
static void HollowRect( short, short, short, short );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS     vsp;

static TESTPROC Test[] = { Test0, Test1, Test2, Test3, Test4, Test5 };
static USHORT	usMode;
void (VS2API *	fnLine)( USHORT, USHORT, USHORT, USHORT, UCHAR );
void (VS2API *	fnGlyphBlt)( USHORT, USHORT, UCHAR, UCHAR,
				    LPVOID, USHORT, USHORT, USHORT );
ULONG (VS2API * fnBltToRAM)( LPVOID, USHORT, USHORT, USHORT, USHORT );
void (VS2API *	fnBltToVBuf)( USHORT, USHORT, LPVOID, USHORT );
static UCHAR	SuperGlyph[14*3];


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * argv[] )
{
    short   t;


    /* verify command-line syntax */
    if( argc != 2 )
    {
      printf( "Syntax: ANITEST <mode #>\n" );
      return;
    }

    sscanf( argv[1], "%x", &usMode );

    for( t=0; t<=5; t++ )
      (Test[t])();

    /* restore 80-by-25 alphanumeric mode */
    SetVMode( 0x03 );
}


/***********************************************************************

  Test0

***********************************************************************/

void Test0()
{
    short   n;
    LPVDDA  lpVDDA = ADDRVDDA;


    InitVMode();

    for( n=0; n<3; n++ )
    {
      vsp.cRMW = 0x18;				/* raster op = XOR */
      (*fnGlyphBlt)( 0, 10*lpVDDA->Points,	/* x, y */
		     0x0E, 0x01,		/* fgd, bkgd */
		     SuperGlyph,
		     24, 14,			/* w, h */
		     TRUE );			/* opaque bkgd */

      vsp.cRMW = 0x00;				/* raster op = none */
      TextAt( 5, 10, "<-- Now you see it ...", 0x07 );
      _getch();

      vsp.cRMW = 0x18;				/* raster op = XOR */
      (*fnGlyphBlt)( 0, 10*lpVDDA->Points,	/* x, y */
		     0x0E, 0x01,		/* fgd, bkgd */
		     SuperGlyph,
		     24, 14,			/* w, h */
		     TRUE );			/* opaque bkgd */

      vsp.cRMW = 0x00;				/* raster op = none */
      TextAt( 5, 10, "<-- ... now you don't ", 0x07 );
      _getch();
    }
}


/***********************************************************************

  Test1

***********************************************************************/

void Test1()
{
    USHORT	x, y;
    static char szHello[] = "Hello, World";


    /* establish 640x480 16-color mode */
    SetVMode( 0x12 );
    InitVSP( 0x12 );

    /* solid background */
    for( y=0; y<vsp.usSY/2; y++ )
      Line10( vsp.usSX/2, y, vsp.usSX-1, y, 0x07 );

    /* striped background */
    for( x=0; x<vsp.usSX/2; x+=2 )
      Line10( x, vsp.usSY/2, x, vsp.usSY-1, 0x07 );

    /* randomly-stippled background */
    for( x=vsp.usSX/2; x<vsp.usSX; x++ )
      for( y=vsp.usSY/2; y<vsp.usSY; y++ )
	if( 1 & rand() )
	  SetPixel10( x, y, 0x07 );

    /* display text in all four quadrants (attrib bit 7 = 1 for XOR) */
    TextAt( 14,  7, szHello, 0x87 );
    TextAt( 14, 22, szHello, 0x87 );
    TextAt( 54,  7, szHello, 0x87 );
    TextAt( 54, 22, szHello, 0x87 );
    _getch();
}


/***********************************************************************

  Test2

***********************************************************************/

void Test2()
{
    USHORT  w, h;


    InitVMode();
    TextAt( (vsp.usSX/8-15)/2, 10, "XOR animation 1", 0x0E );

    w = 10;
    h = (10 * vsp.usSY) / vsp.usSX;

    vsp.cRMW = 0x18;			      /* raster op = XOR */
    while( (w<vsp.usSX) && (h<vsp.usSY) )
    {
      /* show a rectangle */
      HollowRect( (vsp.usSX-w)/2, (vsp.usSY-h)/2,
		    (vsp.usSX+w)/2, (vsp.usSY+h)/2 );

      /* wait for a keypress */
      _getch();

      /* xor the rectangle */
      HollowRect( (vsp.usSX-w)/2, (vsp.usSY-h)/2,
		    (vsp.usSX+w)/2, (vsp.usSY+h)/2 );

      /* change the width and height */
      w += 2;
      h += 2;
    }

    _getch();
}


/***********************************************************************

  Test3

***********************************************************************/

void Test3()
{
    USHORT  q;


    InitVMode();
    TextAt( (vsp.usSX/8-24)/2, 10, "XOR animation 2", 0x0C );

    vsp.cRMW = 0x18;			      /* raster op = XOR */

    for( q=0; q<186; q++ )
    {
      /* show the character glyphs */
      (*fnGlyphBlt)( q, q, 0x0E, 0x01, SuperGlyph, 24, 14, TRUE );

      /* wait for a keypress */
      _getch();

      /* hide the character glyphs */
      (*fnGlyphBlt)( q, q, 0x0E, 0x01, SuperGlyph, 24, 14, TRUE );
    }
}


/***********************************************************************

  Test4

***********************************************************************/

void Test4()
{
    void *  pBMP;
    USHORT  x, usSize;


    InitVMode();
    TextAt( (vsp.usSX/8-27)/2, 10, "Overlapped bitmap animation", 0x0D );

    /* draw a little arrow */
    (*fnLine)(	1, 10, 21, 10, 0x0E );
    (*fnLine)( 21,  0, 31, 10, 0x0E );
    (*fnLine)( 21, 20, 31, 10, 0x0E );
    (*fnLine)( 21,  0, 21, 20, 0x0E );

    /* copy the arrow as a bitmap into RAM */
    usSize = (USHORT)(*fnBltToRAM)( NULL, 0, 0, 32, 24 );
    pBMP = malloc( usSize );
    (*fnBltToRAM)( pBMP, 0, 0, 32, 24 );

    /* copy it repeatedly (with a margin along its left side) */
    for( x=1; x<vsp.usSX-32; x++ )
      (*fnBltToVBuf)( x, 0, pBMP, FALSE );

    free( pBMP );

    _getch();
}


/***********************************************************************

  Test5

***********************************************************************/

void Test5()
{
    USHORT	    x;
    short	    nColors;
    UCHAR	    c = 8;
    static UCHAR    RGBTable[256][3];


    /* convert bits per pixel into the number of available colors */
    InitVMode();
    nColors =  (short)(1 << vsp.cBPP);

    /* draw the current spectrum of colors using all but pixel
	values 0-7 */
    for( x=(vsp.usSX-(nColors-8))/2; x<(vsp.usSX+(nColors-8))/2; x++ )
      (*fnLine)( x, vsp.usSY/4, x, 3*vsp.usSY/4, c++ );

    /* get a copy of the current DAC registers */
    VRWait();
    GetDACRegs( RGBTable, 0, 256 );

    /* animate by rotating the DAC's internal lookup table */
    TextAt( (vsp.usSX/8-17)/2, 4, "Palette animation", 0x07 );
    do
    {
      VRWait();
      SetDACRegs( RGBTable, 8, 248 );
      RotateDACTable( RGBTable, 256, 1 );
    }
    while( !_kbhit() );

    /* discard the keypress */
    _getch();
}


/***********************************************************************

  InitVMode

***********************************************************************/

static void InitVMode()
{
    short   x, y;
    LPCHAR  GlyphTable;


    SetVMode( usMode );
    InitVSP( usMode );

    switch( vsp.usMode )
    {
      case 0x0D:
      case 0x0E:
      case 0x0F:
      case 0x10:
      case 0x11:
      case 0x12:
	fnLine = Line10;
	fnGlyphBlt = GlyphBlt10;
	fnBltToRAM = BltToRAM10;
	fnBltToVBuf = BltToVBuf10;
	break;

      case 0x13:
	fnLine = Line13;
	fnGlyphBlt = GlyphBlt13;
	fnBltToRAM = BltToRAM13;
	fnBltToVBuf = BltToVBuf13;
	break;

      case 0x840:
      case 0x841:
      case 0x842:
      case 0x843:
      case 0x844:
      case 0x845:
	fnLine = Line256;
	fnGlyphBlt = GlyphBlt256;
	fnBltToRAM = BltToRAM256;
	fnBltToVBuf = BltToVBuf256;
	break;

      default:
	printf( "*** unsupported video mode ***\n" );
	exit( 3 );
    }

    /* get a pointer to 8x14 character glyphs in ROM */
    __asm
    {
      push  bp
      mov   ax, 1130h
      mov   bh, 2
      int   10h
      mov   ax, bp
      pop   bp
      mov   WORD PTR GlyphTable, ax
      mov   WORD PTR GlyphTable+2, es
    }

    /* create an 'ABC' superglyph */
    for( x=0; x<3; x++ )
      for( y=0; y<14; y++ )
	SuperGlyph[y*3+x] = GlyphTable[('A'+x)*14+y];
}


/***********************************************************************

  HollowRect

***********************************************************************/

static void HollowRect( short x0, short y0, short x1, short y1 )
{
    /* draw 4 line segments without overlapping the endpoints */
    (*fnLine)( x0, y0, x0,	       (USHORT)(y1-1), 0x0F );
    (*fnLine)( x0, y1, (USHORT)(x1-1), y1,	       0x0F );
    (*fnLine)( x1, y1, x1,	       (USHORT)(y0+1), 0x0F );
    (*fnLine)( x1, y0, (USHORT)(x0+1), y0,	       0x0F );
}
