/***********************************************************************

  GBTEST.C

***********************************************************************/

#include    <stdio.h>	    /* printf */
#include    <stdlib.h>	    /* exit */
#include    <conio.h>	    /* _getch */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

void	main( int, char * * );
void	InitVMode( USHORT );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;

void (VS2API *	fnGlyphBlt)( USHORT, USHORT, UCHAR, UCHAR,
				    LPVOID, USHORT, USHORT, USHORT );

static UCHAR	cRMWBits = 0x00;
static UCHAR	SuperGlyph[14*8];


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * argv[] )
{
    USHORT  usMode, q, w, x, y;
    LPCHAR  GlyphTable;


    if( argc != 2 )
    {
      printf( "Syntax: GBTEST <mode>\n" );
      return;
    }

    /* get the specified video mode */
    sscanf( argv[1], "%x", &usMode );
    InitVMode( usMode );

    /* get a pointer to 8x14 character glyphs in ROM */
    __asm
    {
      push  bp
      mov   ax, 1130h
      mov   bh, 2
      int   10h
      mov   ax, bp
      pop   bp
      mov   WORD PTR GlyphTable, ax
      mov   WORD PTR GlyphTable+2, es
    }

    /* one byte of pixels */
    for( q=0; q<16; q++ )
    {
      for( w=1; w<=8; w++ )
	(*fnGlyphBlt)( q+(w*10), q*10, 0x0F, (UCHAR)(q%7+1),
			GlyphTable+(q*14), w, 14, TRUE );
      _getch();
    }

    /* superglyphs */
    for( q=2; q<=8; q++ )
    {
      InitVMode( usMode );
      for( x=0; x<q; x++ )
	for( y=0; y<14; y++ )
	  SuperGlyph[y*q+x] = GlyphTable[('a'+x)*14+y];

      /* display at various x-coordinates and with various widths */
      for( x=0; x<=16; x++ )
	for( w=0; w<8; w++ )
	{
	  /* don't overlap the end of the video buffer */
	  if( (x+(x*q*8) + (q*8-w)) >= vsp.usSX )
	    continue;

	  /* show the text */
	  (*fnGlyphBlt)( x+(x*q*8), w*15, 0x0F, (UCHAR)(x%7+1),
			    SuperGlyph, q*8-w, 14, TRUE );
	  _getch();
	}
    }

    /* set 80-by-25 text mode */
    SetVMode( 3 );

    return;
}


/***********************************************************************

  InitVMode

***********************************************************************/

void InitVMode( USHORT usMode )
{
    SetVMode( usMode );
    InitVSP( usMode );

    /* set up for Graphics Controller raster ops */
    vsp.cRMW = cRMWBits;

    switch( vsp.usMode )
    {
      case 0x0D:
      case 0x0E:
      case 0x0F:
      case 0x10:
      case 0x11:
      case 0x12:
	fnGlyphBlt = GlyphBlt10;
	break;

      case 0x13:
	fnGlyphBlt = GlyphBlt13;
	break;

      case 0x840:
      case 0x841:
      case 0x842:
      case 0x843:
      case 0x844:
      case 0x845:
	fnGlyphBlt = GlyphBlt256;
	break;

      default:
	printf( "*** unsupported video mode ***\n" );
	exit( 3 );
    }
}
