/***********************************************************************

  PATEST.C

***********************************************************************/

#include    <stdio.h>	    /* printf */
#include    <conio.h>	    /* getch */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

int main( int, char * * );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;


/***********************************************************************

  main

***********************************************************************/

int main( int argc, char * * argv )
{
    USHORT  usMode, usX, usY;
    LPCHAR  lp;


    /* verify command-line syntax */
    if( 2 != argc )
    {
      printf( "\nSyntax: PATEST <hexadecimal BIOS mode number>\n" );
      return 3;
    }

    /* get video mode number from command line */
    sscanf( argv[1], "%x", &usMode );

    /* initialize global variables */
    InitVSP( usMode );
    printf( "vsp.usMode = %04Xh\n", vsp.usMode );
    printf( "vsp.segVBuf = %04Xh\n", vsp.segVBuf );
    printf( "vsp.ofsVBuf = %04Xh\n", vsp.ofsVBuf );
    printf( "vsp.usPPB = %u\n", vsp.usPPB );
    printf( "vsp.cbRow = %u (%04Xh)\n", vsp.cbRow, vsp.cbRow );
    printf( "vsp.usCX,usCY = %u,%u\n", vsp.usCX, vsp.usCY );
    printf( "vsp.usX,usY = %u,%u\n", vsp.usX, vsp.usY );
    getch();

    /* compute pixel addresses */
    for( usX=0; usX<32; usX++ )
      for( usY=0; usY<32; usY++ )
      {
	switch( usMode )
	{
	  case 0x840:
	  case 0x841:
	  case 0x842:
	  case 0x843:
	  case 0x844:
	  case 0x845:
	    lp = PixelAddr256( usX, usY );
	    break;

	  case 0x13:
	    lp = PixelAddr13( usX, usY );
	    break;

	  default:
	    lp = PixelAddr10( usX, usY );
	    break;
	}

	printf( "(%2d, %2d) at %08lX\n", usX, usY, lp );
      }

    return 0;
}
