		TITLE	'RSEQ.ASM'
		NAME	RSEQ
		PAGE	55,132

.286

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

; StartXY
;
;   void VS2API StartXY( USHORT usCX, USHORT usCY );

; parameters
usCY		EQU	[bp+6]
usCX		EQU	[bp+8]

		PUBLIC	STARTXY
STARTXY 	PROC	FAR

	enter	0, 0

	mov	ax, usCX    ; AX = width
	mov	XMax, ax

	mov	bx, usCY    ; BX = height
	mov	YMax, bx

; determine which bit mask to use
	mul	bx	    ; DX:AX = width*height
	xor	cx, cx	    ; CX = 0

L000:	shr	dx, 1
	rcr	ax, 1	    ; DX:AX = (DX:AX) SHR 1
	or	ax, ax	    ; zf = 0 if AX = 0
	loopnz	L000	    ; loop while nonzero
	not	cx

; at this point CX contains the number of the highest
;  1-bit in the binary value of width*height
	mov	bx, cx
	shl	bx, 2		; BX = DWORD offset
	mov	ax, WORD PTR ulMask[bx]
	mov	MaskLo, ax
	mov	ax, WORD PTR ulMask[bx+2]
	mov	MaskHi, ax

	mov	SeqNoLo, 1
	mov	SeqNoHi, 0

	leave
	ret	4	    ; 2*sizeof(USHORT)

STARTXY 	ENDP

; NextXY
;
;   USHORT VS2API NextXY( USHORT * pX, USHORT * pY );
;
; Notes:
;   Returns 0 if random sequence is complete

; parameters
pY		EQU	[bp+6]
pX		EQU	[bp+8]

		PUBLIC	NEXTXY
NEXTXY		PROC	FAR

	enter	0, 0

; shift the 32-bit sequence number 1 bit rightward
L10:	mov	dx, WORD PTR SeqNoHi
	mov	ax, WORD PTR SeqNoLo
	shr	dx, 1
	rcr	ax, 1	    ; DX:AX = SeqNo SHR 1
			    ; cf = previous bit 0
	jnc	L11

	xor	dx, MaskHi
	xor	ax, MaskLo

; save the new sequence number
L11:	mov	SeqNoHi, dx
	mov	SeqNoLo, ax

; use the current sequence number to determine the x, y
	div	YMax	    ; AX = x; DX = y
	cmp	ax, XMax
	jae	L10	    ; try again if AX is out of bounds

	mov	bx, pX
	mov	[bx], ax    ; update X
	mov	bx, pY
	mov	[bx], dx    ; update Y

	sub	dx, 1
	sbb	ax, 0
	or	ax, dx	    ; AX = 0 if AX:DX was 1

	leave
	ret	4	    ; 2*sizeof(near *)

NEXTXY		ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

SeqNoLo 	WORD	?
SeqNoHi 	WORD	?
MaskLo		WORD	?
MaskHi		WORD	?
XMax		WORD	?
YMax		WORD	?

ulMask		DWORD	00000000h, 00000003h, 00000006h, 0000000Ch
		DWORD	00000014h, 00000030h, 00000060h, 000000B8h
		DWORD	00000110h, 00000240h, 00000500h, 00000CA0h
		DWORD	00001B00h, 00003500h, 00006000h, 0000B400h
		DWORD	00012000h, 00039000h, 00072000h, 00090000h
		DWORD	00140000h, 00300000h, 00420000h, 00D80000h
		DWORD	01200000h, 03880000h, 07200000h, 09000000h

_DATA		ENDS

		END
