/***********************************************************************

  SCANTEST.C

***********************************************************************/

#include    <stdio.h>	    /* printf sscanf */
#include    <conio.h>	    /* _getch */
#include    <vs2.h>


/***********************************************************************

  TYPEDEFS etc.

***********************************************************************/

#define SCAN_UNTIL  0
#define SCAN_WHILE  1


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

void	      main( int, char * * );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;

USHORT (VS2API * fnScanLeft)( USHORT, USHORT, UCHAR, short );
USHORT (VS2API * fnScanRight)( USHORT, USHORT, UCHAR, short );
void (VS2API *	fnLine)( USHORT, USHORT, USHORT, USHORT, UCHAR );


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * argv[] )
{
    USHORT  usMode, y;


    if( argc != 2 )
    {
      printf( "Syntax: SCANTEST <mode #>\n" );
      return;
    }

    /* select the specified video mode */
    sscanf( argv[1], "%x", &usMode );
    SetVMode( usMode );
    InitVSP( usMode );

    /* select the right functions for the video mode */
    if( (usMode >= 0x0D) && (usMode <= 0x12) )
    {
      fnScanLeft = ScanLeft10;
      fnScanRight = ScanRight10;
      fnLine = Line10;
    }
    else
    if( usMode == 0x13 )
    {
      fnScanLeft = ScanLeft13;
      fnScanRight = ScanRight13;
      fnLine = Line13;
    }
    else
    if( (usMode >= 0x840) && (usMode <= 0x845) )
    {
      fnScanLeft = ScanLeft256;
      fnScanRight = ScanRight256;
      fnLine = Line256;
    }

    /* two lines */
    (*fnLine)( 101, 24, 0, 124, 0x0C );
    (*fnLine)( 101, 24, 200, 124, 0x0C );

    /* test ScanLeft */
    for( y=24; y<130; y++ )
    {
      printf( "Lt( 101, %3d, 12, SCAN_UNTIL ): %3d  \r",
		y, (*fnScanLeft)( 101, y, 12, SCAN_UNTIL ) );
      _getch();
    }

    for( y=24; y<130; y++ )
    {
      printf( "Lt( 101, %3d, 12, SCAN_WHILE ): %3d  \r",
		y, (*fnScanLeft)( 101, y, 12, SCAN_WHILE ) );
      _getch();
    }

    /* test ScanRight */
    for( y=24; y<130; y++ )
    {
      printf( "Rt( 101, %3d, 12, SCAN_UNTIL ): %3d  \r",
		y, (*fnScanRight)( 101, y, 12, SCAN_UNTIL ) );
      _getch();
    }

    for( y=24; y<130; y++ )
    {
      printf( "Rt( 101, %3d, 12, SCAN_WHILE ): %3d  \r",
		y, (*fnScanRight)( 101, y, 12, SCAN_WHILE ) );
      _getch();
    }

    /* test functionality at edges of video buffer */
    (*fnLine)( 1, 110, 1, 129, 1 );
    (*fnLine)( 101, 24, 0, 124, 0x0C );

    for( y=110; y<130; y++ )
    {
      printf( "Lt( 1, %3d, 12, SCAN_WHILE ): %3d  \r",
		y, (*fnScanLeft)( 1, y, 12, SCAN_WHILE ) );
      _getch();
    }

    for( y=110; y<130; y++ )
    {
      printf( "Lt( 1, %3d, 12, SCAN_UNTIL ): %3d  \r",
		y, (*fnScanLeft)( 1, y, 12, SCAN_UNTIL ) );
      _getch();
    }

    (*fnLine)( vsp.usSX-2, 110, vsp.usSX-2, 129, 1 );
    (*fnLine)( vsp.usSX-1, 124, vsp.usSX-11, 114, 12 );

    for( y=110; y<130; y++ )
    {
      printf( "Rt( %d, %3d, 12, SCAN_UNTIL ): %3d  \r",
		vsp.usSX-2, y, (*fnScanRight)( vsp.usSX-2, y, 12, SCAN_UNTIL ) );
      _getch();
    }

    for( y=110; y<130; y++ )
    {
      printf( "Rt( %d, %3d, 12, SCAN_WHILE ): %3d  \r",
		vsp.usSX-2, y, (*fnScanRight)( vsp.usSX-2, y, 12, SCAN_WHILE ) );
      _getch();
    }
}
