/***********************************************************************

  SPTEST.C

***********************************************************************/

#include    <conio.h>	    /* _getch */
#include    <stdio.h>	    /* printf sscanf */
#include    <string.h>	    /* strlen */
#include    <vs2.h>


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

int	    main( int, char * * );
static void Test0( USHORT );

/* stuff not defined in VS2.H ... */
void VS2API SetPixel04( USHORT, USHORT, UCHAR );
void VS2API SetPixel06( USHORT, USHORT, UCHAR );
void VS2API SetPixelHGC( USHORT, USHORT, UCHAR );

void VS2API ModeVGAHGC( void );

void VS2API StartXY( USHORT, USHORT );
short VS2API NextXY( USHORT *, USHORT * );


/***********************************************************************

  main

***********************************************************************/

int main( int argc, char * argv[] )
{
    USHORT  usMode;


    if( argc != 2 )
    {
      printf( "Syntax: SPTEST <mode #>\n" );
      return 3;
    }

    /* select the specified video mode */
    sscanf( argv[1], "%x", &usMode );

    if( usMode != 7 )
    {
      SetVMode( usMode );

      /* initialize global variables */
      InitVSP( usMode );
    }

    else
      ModeVGAHGC();

    Test0( usMode );

    /* restore 80x25 text mode */
    SetVMode( 3 );
}


/***********************************************************************

  Test0 -- set every pixel on the screen

***********************************************************************/

static void Test0( USHORT usMode )
{
    void (VS2API * SetPixel)( USHORT, USHORT, UCHAR );
    USHORT  usX, usY, usContinue;


    switch( usMode )
    {
      case 4:
      case 5:
	SetPixel = SetPixel04;
	break;

      case 6:
	SetPixel = SetPixel06;
	break;

      case 0x0D:
      case 0x0E:
      case 0x0F:
      case 0x10:
      case 0x11:
      case 0x12:
	SetPixel = SetPixel10;
	break;

      case 0x13:
	SetPixel = SetPixel13;
	break;

      case 0x7:
	SetPixel = SetPixelHGC;
	_getch();
	break;

      case 0x840:
      case 0x841:
      case 0x842:
      case 0x843:
      case 0x844:
      case 0x845:
	SetPixel = SetPixel256;
	break;

      default:
	printf( "*** unsupported video mode ***" );
	_getch();
	return;
    }

    StartXY( vsp.usSX, vsp.usSY );
    do
    {
      usContinue = NextXY( &usX, &usY );
      (*SetPixel)( usX, usY, (UCHAR)(usX+usY) );
    }
    while( usContinue );

    StartXY( vsp.usSX, vsp.usSY );
    do
    {
      usContinue = NextXY( &usX, &usY );
      (*SetPixel)( usX, usY, (UCHAR)(usX+usY) );
    }
    while( usContinue );

    (*SetPixel)( 0, 0, 0 );

    _getch();
}
